﻿"use strict";
/*
------------------------------------------------------------------------------------------

NOME AZIENDA	: EPSON ITALIA SPA
NOME FILE		: mPOSKeyboard-V6.1.js
DESCRIZIONE		: File principale JavaScript tastiera virtuale mPOSKeyboard.

PROPRIETÀ		: Le informazioni qui contenute sono proprietà di EPSON ITALIA SPA.
				  È fatto divieto di usare, rivelare a terzi o riprodurre senza il
				  consenso scritto di EPSON ITALIA SPA.
------------------------------------------------------------------------------------------
*/
var mPOSKeyboardVersion = "6.1";
var debugMode = false;

var devWebServerIPAddress = "192.168.1.110";
// var devWebServerIPAddress = "10.15.10.10";
var devPrinterIPAddress = "192.168.1.90";
// var devPrinterIPAddress = "10.15.10.140";
// var devPrinterIPAddress = "10.15.10.81";

var appLoadingInProgress = true;
var mainSettings = [];
var beep = new Audio("audio/beep.wav");

var keyPages = [];
var keyPageNameList = [];
var keyPageXMLFileNameList = [];
var operatorXMLArray = [];
var departmentXMLArray = [];
var departmentParamsArray = [];
var paymentsXMLArray = [];
var pluArray = []; // Dal file esterno.
var scontrinoCortesiaArray = [];
var retailHeaderArray = [];

var oldDailyTakingsFilesDaysThreshold = 3;	// Default = tre giorni.
var webAppHasEftpos = false;
var webAppHasSconCort = false;

// * * * * * T I M E O U T * * * * * * *
var defaultPostTimeout = 12000;			// Timeout all'interno di fiscalprint js per ricevere una risposta dalla stampante.
var defaultQueryStringTimeout = 3000;	// Utilizzato durante la fase di connessione iniziale fra fpmate.cgi ed il firmware fiscale.
var pageLoadTimeout = 30000;			// Utilizzato durante la fase di caricamento webapp.

var pluPostTimeout = 10000;
var directIOTimeout = 6000;				// Da utilizzare con il tag directIO.
var longDirectIOTimeout = 12000;
var ZReportTimeout = 27000;				// Da utilizzare con i tag.
var ZReportPostTimeout = 30000;

var eftposPostTimeout =  63000;			// 60000 + (3000 per la connessione iniziale). Aggiornato dopo una lettura SET 31.
var eftposQueryStringTimeout = 60000;	// Timeout pagamento elettronico POS. Aggiornato dopo una lettura SET 31.
// * * * * * F I N E   T I M E O U T * * * * * * *

var xmlHTTPRequestURLMain = "";
var xmlHTTPRequestURLPageLoad = "";
var xmlHTTPRequestURLEftpos = "";

var webSocketTCPPort = "8008";

var numSecondaryPages = 0;	// Deprecato.
var currentTillNumber = -1; // 0 con tipoConnessione Dedicata o operatori 1. 1 a 999 con tipoConnessione Multipla e operatori 0. 
var currentTillNumberString = "";
var currentOperatorNumber = -1; // 0 per lab. 1 a 12 per lab e produzione. -1 indica "non ancora impostato". 1 se operatori = 0.
var currentOperatorNumberString = "";
var switchingOperators = false;
var masterTillOrOperator = false; // Ha significato solo con tipoConnessione Multipla ed operatori = 0.

var statoStampante = "";

var maxDescLines = 4;
var maxCharsPerLine = 25;
var maxChars = maxDescLines * maxCharsPerLine + (maxDescLines - 1); // Comprende i CR \n).
var maxCharsWarningText = "Max " + maxDescLines * maxCharsPerLine + " caratteri raggiunti. La stampa sarà troncata.";
var maxLinesWarningText = "Max " + maxDescLines + " righe raggiunte. La stampa sarà troncata.";
var addRowPrefix = "";
var eposDevice = new epsonlib.ePOSDevice();

var TNT = 999;
var TCL = 12;
var TCONT = 0x0d;	// 13 - Carriage Return
var TENTER = TCONT;	// 13 - Carriage Return

var tab_scan_code_lower_case = [
	TNT, TNT, '1',  '2', '3', '4',  '5',   '6',  '7',   '8',	// 00 - 09
	'9', '0', '\'', TNT, TNT, TNT,  'q',   'w',  'e',   'r',	// 10 - 19
	't', 'y', 'u',  'i', 'o', 'p',  TNT,   '*', TENTER, TNT,	// 20 - 29
	'a', 's', 'd',  'f', 'g', 'h',  'j',   'k',  'l',   '@',	// 30 - 39
	TNT, TNT, TNT,  '>', 'z', 'x',  'c',   'v',  'b',   'n',	// 40 - 49
	'm', ';', '.',  '-', TNT, '*',  TNT,   ' ',  TNT,   TNT,	// 50 - 59
	TNT, TNT, TNT,  TNT, TNT, TNT,  TNT,   TNT,  TNT,   TCL,	// 60 - 69	69 = CL Clear sul tastierino nero 23/24 tasti.
	TNT, '7', '8',  '9', '-', '4',  '5',   '6',  '+',   '1',	// 70 - 79
	'2', '3', '0',  '.', TNT, TNT,  TNT,   TNT,  TNT,   TNT,	// 80 - 89
	TNT, TNT, TNT, TNT,  TNT, TNT, TENTER, TNT,  TNT,   TNT,	// 90 - 99
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//100 - 109
	TNT, TCL, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//110 - 119	111 = CL Clear sul tastierino POS.
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//120 - 129
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT, 	//130 - 139
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//140 - 149
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//150 - 159
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//160 - 169
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//170 - 179
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//180 - 189
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//190 - 199
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//200 - 209
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//210 - 219
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//220 - 229
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//230 - 239
	TNT, TNT, TNT, TNT,  TNT, TNT,  TNT,   TNT,  TNT,   TNT,	//240 - 249
	TNT, TNT, TNT, TNT,  TNT, TNT,								//250 - 255
];

var tab_scan_code_upper_case = [
	TNT, TNT, '!', '"', '#', '$',  '%',   '&',  '/',   '(',		// 00 - 09
	')', '=', '?', TNT, TNT, TNT,  'Q',   'W',  'E',   'R',		// 10 - 19
	'T', 'Y', 'U', 'I', 'O', 'P',  TNT,   '+', TENTER, TNT,		// 20 - 29
	'A', 'S', 'D', 'F', 'G', 'H',  'J',   'K',  'L',   '@',		// 30 - 39
	TNT, TNT, TNT, '<', 'Z', 'X',  'C',   'V',  'B',   'N',		// 40 - 49
	'M', ',', ':', '_', TNT, '*',  TNT,   ' ',  TNT,   TNT,		// 50 - 59
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TCL,		// 60 - 69	69 = CL Clear sul tastierino nero 23/24 tasti.
	TNT, '7', '8', '9', '-', '4',  '5',   '6',  '+',   '1',		// 70 - 79
	'2', '3', '0', '.', TNT, TNT,  TNT,   TNT,  TNT,   TNT,		// 80 - 89
	TNT, TNT, TNT, TNT, TNT, TNT, TENTER, TNT,  TNT,   TNT,		// 90 - 99
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//100 - 109
	TNT, TCL, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//110 - 119	111 = CL Clear sul tastierino POS.
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//120 - 129
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//130 - 139
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//140 - 149
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//150 - 159
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//160 - 169
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//170 - 179
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//180 - 189
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//190 - 199
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//200 - 209
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//210 - 219
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//220 - 229
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//230 - 239
	TNT, TNT, TNT, TNT, TNT, TNT,  TNT,   TNT,  TNT,   TNT,		//240 - 249
	TNT, TNT, TNT, TNT, TNT, TNT,								//250 - 255
];

function preparePage()
{	
	document.title += mPOSKeyboardVersion;
}

function imageErrorHandler(imgObject, position)
{
	var alertText = "Errore caricamento logo ";
	var imageSource = imgObject.src.replace(/%20/g, " ");
	
	if (position == "left")
	{
		alertText += "sinistro";
	}
	else
	{
		alertText += "destro";
	}
	alert(alertText + ":\r\n" + imageSource);
}

function prepareAndSaveDefaultMainSettings()
{
	mainSettings = {
		printerURL: "",
		printerProtocol: window.location.protocol,
		printerIPAddress: window.location.hostname,
		printerPort: window.location.port,
		tipoConnessione: "Dedicata",
		operatori: "",		
		beepMode:  "0", // Default beep off.
		progReparti:  false,
		progNomiPagamenti: false,
		demoMode: false,
		usaWebSocket: false,	// Default.
		mostraLogoSinistro:  true,
		fileLogoSinistro: "Default",
		mostraLogoDestro: true,
		fileLogoDestro: "Default",
		mostraRigaInformativa: "0",
		coloreFontRigaInformativa:	"Default",
		databasePLU: "0",	// Default legge i PLU dalla stampante.		
		downloadPLU: false,	// Download dalla stampante verso il browser.
		uploadPLU: false,	// Upload delle voci nel file PLU.xml verso la stampante.
		numeroPLUStampante:	1000, // Tutte le voci per default.
	};
	
	if (mainSettings.tipoConnessione == "Dedicata")
	{
		mainSettings.operatori = "0";
	}
	
	else // Multipla
	{
		mainSettings.operatori = "1";
	}
}


function statoAndResultConsoleLog(result, tag_names_array, add_info)
{
	statoStampante = result.success?'Stampa riuscita':'Stampa non riuscita';      
	console.log('result.success: ' + result.success);
	console.log('result.code: ' + result.code);
	console.log('result.status: ' + result.status);
	console.log('statoStampante: ' + statoStampante);
	console.log('tag_names_array_list: ' + tag_names_array);
	var i = 0;
	for (i = 0; i < tag_names_array.length; i++)
	{
		console.log('tag_names_array[' + tag_names_array[i] + '] = ' + add_info[tag_names_array[i]]);
	}
}
	
function parseQueryString()
{
	if (location.search != "")
	{
		console.log('location.search = ' + location.search);
		var myQueryStringIn = location.search.substr(1).split('&', 30);
		console.log('myQueryStringIn = ' + myQueryStringIn);
		var qsi = 0;
		for (qsi = 0; qsi < myQueryStringIn.length; qsi++)
		{
			var myParamArray = myQueryStringIn[qsi].split('=');
			console.log(myParamArray[0] + ' = ' + myParamArray[1]);
			switch (myParamArray[0].toLowerCase())
			{
				case "debug":
					if (myParamArray[1] == 1)
					{
						debugMode = true;
					}
					break;
				
				case "printerURL".toLowerCase():
					decodeURL(myParamArray[1]);
					break;
				
				case "printerProtocol".toLowerCase():
					mainSettings.printerProtocol = myParamArray[1];
					if (mainSettings.printerProtocol.lastIndexOf(":") == -1)
					{
						mainSettings.printerProtocol += ":";
					}
					break;
					
				case "printerIPAddress".toLowerCase():
					mainSettings.printerIPAddress = myParamArray[1];
					break;
				
				case "printerPort".toLowerCase():
					mainSettings.printerPort = myParamArray[1];
					break;
			
				case "tipoConnessione".toLowerCase():
					if (myParamArray[1].toLowerCase() == "multipla" ||
						myParamArray[1].toLowerCase() == "multiple")
					{
						mainSettings.tipoConnessione = "Multipla";
					}
					else if (myParamArray[1].toLowerCase() == "dedicata" ||
							myParamArray[1].toLowerCase() == "dedicated")
					{
						mainSettings.tipoConnessione = "Dedicata";
					}
					else
					{
						mainSettings.tipoConnessione = myParamArray[1];
					}
					break;
				
				/*case "tipoMultipla".toLowerCase():
					if (myParamArray[1].toLowerCase() == "casse")
					{
						multipleMode = "Tills";
					}
					else if (myParamArray[1].toLowerCase() == "operatori")
					{
						multipleMode = "Operators";
					}
					else
					{
						multipleMode = myParamArray[1].toLowerCase();
					}
					break;
				*/
				
				case "operatori":
					mainSettings.operatori = myParamArray[1];
					break;
				
				case "cassa":
				case "cassiera":
					currentTillNumber = myParamArray[1];
					break;
				
				case "operatore":
					currentOperatorNumber = myParamArray[1];
					break;
					
				case "beepMode".toLowerCase():
				case "beep".toLowerCase():
					mainSettings.beepMode=myParamArray[1];
					break;
				
				case "progReparti".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.progReparti = true;
					}
					else
					{
						mainSettings.progReparti = false;
					}
					break;
				
				case "progNomiPagamenti".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.progNomiPagamenti = true;
					}
					else
					{
						mainSettings.progNomiPagamenti = false;
					}
					break;
				
				case "demoMode".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.demoMode = true;
					}
					else
					{
						mainSettings.demoMode = false;
					}
					break;
					
				/*
				case "ignoraFileConf".toLowerCase():
					if (myParamArray[1] == 1)
					{
						ignoraFileConf = true;
					}
					else
					{
						ignoraFileConf = false;
					}
					break;
				*/
					
				case "mostraLogoSinistro".toLowerCase():
					if (myParamArray[1] == 0)
					{
						mainSettings.mostraLogoSinistro = false;
					}
					else if (myParamArray[1] == 1)
					{
						mainSettings.mostraLogoSinistro = true;
					}
					break;
					
				case "mostraLogoDestro".toLowerCase():
					if (myParamArray[1] == 0)
					{
						mainSettings.mostraLogoDestro = false;
					}
					else if (myParamArray[1] == 1)
					{
						mainSettings.mostraLogoDestro = true;
					}
					break;
						
				case "mostraRigaInformativa".toLowerCase():
					if (myParamArray[1] == 1)
					{
						activateInfoLine();
					}
					else
					{
						deactivateInfoLine();
					}
					break;
				
				case "coloreFontRigaInformativa".toLowerCase():
					$('.rowInfo').css('color', myParamArray[1]);
					break;

				case "databasePLU".toLowerCase():
					mainSettings.databasePLU=myParamArray[1];
					break;
				
				case "downloadPLU".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.downloadPLU = true;
					}
					else
					{
						mainSettings.downloadPLU = false;
					}
					break;
					
				case "uploadPLU".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.uploadPLU = true;
					}
					else
					{
						mainSettings.uploadPLU = false;
					}
					break;
					
				case "numeroPLUStampante".toLowerCase():
					mainSettings.numeroPLUStampante = myParamArray[1];
					break;
					
				case "usaWebSocket".toLowerCase():
					if (myParamArray[1] == 1)
					{
						mainSettings.usaWebSocket = true;
					}
					else
					{
						mainSettings.usaWebSocket = false;
					}
					break;
					
				/*case "numeroPagine".toLowerCase():
					numSecondaryPages = myParamArray[1];
					break;
				*/
	
				default:
					alert("Parametro " + myParamArray[0] + " non esiste. Scegliere fra:\n\n" +
						"printerURL\n" +
						"printerProtocol, printerIPAddress, printerPort\n" +
						"tipoConnessione (Dedicata o Multipla)\n" +						 
						"beepMode o beep (0, 1 o 2)\n" +
						"progReparti, progNomiPagamenti\n" +
						"demoMode\n" +
						"mostraLogoSinistro, mostraLogoDestro\n" +
						"mostraRigaInformativa, coloreFontRigaInformativa\n" +
						"dataBasePLU, downloadPLU, uploadPLU, numeroPLUStampante\n" +
						"usaWebSocket\n" +
						"cassa o cassiera\n" +
						"operatore");
						// "numeroPagine\n" +
						// "ignoraFileConf\n" +
						// "tipoMultipla (Casse o Operatori)\n" +
			}			
		}
	}
	if (debugMode == true)
	{
		console.log('debugMode = ' + debugMode);
		// console.log('ignoraFileConf = ' + ignoraFileConf);
	}
}

function readSettingsXMLFile()
{
	var filePath = "xml/Settings.xml";
	var xmlhttpSettings, xmlSettingsDoc;
	xmlhttpSettings= new XMLHttpRequest();
	xmlhttpSettings.onreadystatechange = function()
	{
    	console.log('readyState = ' + this.readyState);
    	console.log('status = ' + this.status);
    	
    	var prefixText = "";
    	var usaWebSocket = "";
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlSettingsDoc = xmlhttpSettings.responseXML;
			try
			{
				prefixText = "Settings.xml - Settings";
				var tags = xmlSettingsDoc.getElementsByTagName('Settings');
				try
				{
					
					prefixText = "Settings.xml - Settings - printerURL";
					if (tags[0].getAttribute("printerURL") != "" && tags[0].getAttribute("printerURL") != null)
					{
						decodeURL(tags[0].getAttribute("printerURL"));
					}
					
					prefixText = "Settings.xml - Settings - printerProtocol";
					if (tags[0].getAttribute("printerProtocol") != "" && tags[0].getAttribute("printerProtocol") != null)
					{
						mainSettings.printerProtocol = tags[0].getAttribute("printerProtocol");
						if (mainSettings.printerProtocol.lastIndexOf(":") == -1)
						{
							mainSettings.printerProtocol += ":";
						}
					}

					prefixText = "Settings.xml - Settings - printerIPAddress";
					if (tags[0].getAttribute("printerIPAddress") != "" && tags[0].getAttribute("printerIPAddress") != null)
					{
						mainSettings.printerIPAddress = tags[0].getAttribute("printerIPAddress");
					}
					
					prefixText = "Settings.xml - Settings - printerPort";
					if (tags[0].getAttribute("printerPort") != "" && tags[0].getAttribute("printerPort") != null)
					{
						mainSettings.printerPort = tags[0].getAttribute("printerPort");
					}

					prefixText = "Settings.xml - Settings - tipoConnessione";
					if (tags[0].getAttribute("tipoConnessione") != "" &&
						tags[0].getAttribute("tipoConnessione") != null)
					{
						if (tags[0].getAttribute("tipoConnessione").toLowerCase() == "multipla" ||
							tags[0].getAttribute("tipoConnessione").toLowerCase() == "multiple")
						{
							mainSettings.tipoConnessione = "Multipla";
						}
						else if (tags[0].getAttribute("tipoConnessione").toLowerCase() == "dedicata" ||
								 tags[0].getAttribute("tipoConnessione").toLowerCase() == "dedicated")
						{
							mainSettings.tipoConnessione = "Dedicata";
						}
						else
						{
							mainSettings.tipoConnessione = tags[0].getAttribute("tipoConnessione");
						}
					}
					
					/*
					prefixText = "Settings.xml - Settings - tipoMultipla";
					if (tags[0].getAttribute("tipoMultipla") != "" && tags[0].getAttribute("tipoMultipla") != null)
					{
						if (tags[0].getAttribute("tipoMultipla").toLowerCase() == "casse")
						{
							multipleMode = "Tills";
						}
						else if (tags[0].getAttribute("tipoMultipla").toLowerCase() == "operatori")
						{
							multipleMode = "Operators";
						}
						else
						{
							multipleMode = tags[0].getAttribute("tipoMultipla");
						}
					}
					*/
					
					// Impostiamo la modalità di default degli operatori che dipende da tipoConnessione.
					if (mainSettings.tipoConnessione == "Dedicata")
					{
						mainSettings.operatori = "0";
					}
					else
					{
						mainSettings.operatori = "1";
					}

					prefixText = "Settings.xml - Settings - operatori";
					if (tags[0].getAttribute("operatori") != "" && tags[0].getAttribute("operatori") != null)
					{
						mainSettings.operatori = tags[0].getAttribute("operatori");
					}

					prefixText = "Settings.xml - Settings - beepMode";
					if (tags[0].getAttribute("beepMode") != "" && tags[0].getAttribute("beepMode") != null)
					{
						mainSettings.beepMode = tags[0].getAttribute("beepMode");
					}
					
					prefixText = "Settings.xml - Settings - progReparti";
					if (tags[0].getAttribute("progReparti") == "1")
					{
						mainSettings.progReparti = true;
					}
					else
					{
						mainSettings.progReparti = false;
					}
					
					prefixText = "Settings.xml - Settings - progNomiPagamenti";
					if (tags[0].getAttribute("progNomiPagamenti") == "1")
					{
						mainSettings.progNomiPagamenti = true;
					}
					else
					{
						mainSettings.progNomiPagamenti = false;
					}
					
					prefixText = "Settings.xml - Settings - demoMode";
					if (tags[0].getAttribute("demoMode") == "1")
					{
						mainSettings.demoMode = true;
					}
					else
					{
						mainSettings.demoMode = false;
					}
					
					prefixText = "Settings.xml - Settings - usaWebSocket";
					usaWebSocket = tags[0].getAttribute("usaWebSocket");
					
					console.log('usaWebSocket (Settings tag) = ' + usaWebSocket);
					
					if (usaWebSocket == "1")
					{
						mainSettings.usaWebSocket = true;
					}

					/*
					prefixText = "Settings.xml - Tasti";
					var tags = xmlSettingsDoc.getElementsByTagName('Tasti');
					prefixText = "Settings.xml - Tasti - ignoraFileConf";
					var ignoreCustomKeysFile = tags[0].getAttribute("ignoraFileConf");
					if (ignoreCustomKeysFile == "1")
					{
						ignoraFileConf = true;
					}
					else
					{
						ignoraFileConf = false;
					}
					*/					
		
					prefixText = "Settings.xml - Loghi";
					tags = xmlSettingsDoc.getElementsByTagName('Loghi');
					if (tags[0].getAttribute("mostraLogoSinistro") == "0")
					{
						mainSettings.mostraLogoSinistro = false;
					}
					else
					{
						mainSettings.mostraLogoSinistro = true;
					}
					if (tags[0].getAttribute("fileLogoSinistro") == "" ||
						tags[0].getAttribute("fileLogoSinistro") == null ||
						tags[0].getAttribute("fileLogoSinistro").toLowerCase() == "default")
					{
						mainSettings.fileLogoSinistro = "Default";
					}
					else
					{
						if (tags[0].getAttribute("fileLogoSinistro").lastIndexOf("/") == -1)
						{
							// File sotto cartella img
							mainSettings.fileLogoSinistro = "img/" + tags[0].getAttribute("fileLogoSinistro");
						}
						else
						{
							mainSettings.fileLogoSinistro = tags[0].getAttribute("fileLogoSinistro");
						}
					}

					if (tags[0].getAttribute("mostraLogoDestro") == "0")
					{
						mainSettings.mostraLogoDestro = false;
					}
					else
					{
						mainSettings.mostraLogoDestro = true;
					}
					if (tags[0].getAttribute("fileLogoDestro") == "" ||
						tags[0].getAttribute("fileLogoDestro") == null ||
						tags[0].getAttribute("fileLogoDestro").toLowerCase() == "default")
					{
						mainSettings.fileLogoDestro = "Default";
					}
					else
					{
						if (tags[0].getAttribute("fileLogoDestro").lastIndexOf("/") == -1)
						{
							// File sotto cartella img
							mainSettings.fileLogoDestro = "img/" + tags[0].getAttribute("fileLogoDestro");
						}
						else
						{
							mainSettings.fileLogoDestro = tags[0].getAttribute("fileLogoDestro");
						}
					}
					
					prefixText = "Settings.xml - RigaInformativa";
					tags = xmlSettingsDoc.getElementsByTagName('RigaInformativa');
					if (tags[0].getAttribute("mostraRigaInformativa") == "1")
					{
						activateInfoLine();						
					}
					else
					{
						deactivateInfoLine();
					}
										
					if (tags[0].getAttribute("coloreFontRigaInformativa") != "" &&
						tags[0].getAttribute("coloreFontRigaInformativa") != null)
					{
						$('.rowInfo').css('color', tags[0].getAttribute("coloreFontRigaInformativa"));
					}
					
					prefixText = "Settings.xml - PLU";
					tags = xmlSettingsDoc.getElementsByTagName('PLU');
					prefixText = "Settings.xml - PLU - databasePLU";
					if (tags[0].getAttribute("databasePLU") != "" && tags[0].getAttribute("databasePLU") != null)
					{
						mainSettings.databasePLU = tags[0].getAttribute("databasePLU");
					}
											
					prefixText = "Settings.xml - PLU - uploadPLU";
					if (tags[0].getAttribute("uploadPLU") == "1")
					{
						mainSettings.uploadPLU = true;
					}
					else
					{
						mainSettings.uploadPLU = false;
					}
					
					prefixText = "Settings.xml - PLU - downloadPLU";
					if (tags[0].getAttribute("downloadPLU") == "1")
					{
						mainSettings.downloadPLU = true;
					}
					else
					{
						mainSettings.downloadPLU = false;
					}
					
					prefixText = "Settings.xml - PLU - numeroPLUStampante";
					if (tags[0].getAttribute("numeroPLUStampante") != "" && tags[0].getAttribute("numeroPLUStampante") != null)
					{
						if (isNaN(tags[0].getAttribute("numeroPLUStampante")) == false)
						{
							mainSettings.numeroPLUStampante = parseInt(tags[0].getAttribute("numeroPLUStampante"),10);
							if (mainSettings.numeroPLUStampante < 1)
							{
								alert ("Attributo numeroPLUStampante nel file Settings.xml deve essere > 0.");
								mainSettings.numeroPLUStampante = 0;
							}								
						}
					}
					
					// Vecchia posizione lasciata per compatibilità.
					prefixText = "Settings.xml - PLU - usaWebSocket";
					usaWebSocket = tags[0].getAttribute("usaWebSocket");
					console.log('usaWebSocket (PLU tag) = ' + usaWebSocket);
					
					if (usaWebSocket == "1")
					{
						mainSettings.usaWebSocket = true;
					}
											
					/*
					prefixText = "Settings.xml - pagineSecondarie";
					tags = xmlSettingsDoc.getElementsByTagName('PagineSecondarie');				
					prefixText = "Settings.xml - pagineSecondarie - numeroPagine";
					if (tags[0].getAttribute("numeroPagine") != "" && tags[0].getAttribute("numeroPagine") != null)
					{
						if (isNaN(tags[0].getAttribute("numeroPagine")) == false)
						{
							numSecondaryPages = parseInt(tags[0].getAttribute("numeroPagine"), 10);
						}
					}
					*/
				}
				catch (myEx)
				{
					console.log(prefixText + " " + myEx.message);
					alert(prefixText + "\n" + myEx.message);
				}
			}
			catch (myEx)
			{
				console.log(prefixText + " " + myEx.message);
				alert(prefixText + "\n" + myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
			
			console.log('databasePLU = ' + mainSettings.databasePLU);
			console.log('usaWebSocket = ' + mainSettings.usaWebSocket);
			console.log('numeroPagine (deprecato) = ' + numSecondaryPages);
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			// alert("File di configurazione " + filePath + " non trovato.");
		}
		else
		{
			// alert(this.readyState + " " + this.status);
		}
    };
    
	xmlhttpSettings.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpSettings.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function decodeURL(printerURL)
{
	var printerURLArray = printerURL.split(':', 3);
	if (printerURLArray.length >= 2)
	{
		mainSettings.printerProtocol = printerURLArray[0] + ":";
		mainSettings.printerIPAddress = printerURLArray[1].replace(/\//g, '');
	}
	if (printerURLArray.length == 3)
	{
		mainSettings.printerPort = printerURLArray[2];
	}
}
			
function activateInfoLine()
{
	$('.infoLineClass').css('display', 'block');
	$('.virtualPrinterDisplayWrapper').css('height', '14%');
	$('.zone ul').css('height', '78%');
}

function deactivateInfoLine()
{
	$('.infoLineClass').css('display', 'none');
	$('.virtualPrinterDisplayWrapper').css('height', '16%');
	$('.zone ul').css('height', '84%');
}

function readPagesFile()
{
	keyPageNameList = [];
	keyPageXMLFileNameList = [];
	var filePath = "xml/Pagine.xml";
	var xmlhttpPages, xmlPagesDoc;
	xmlhttpPages = new XMLHttpRequest();
	xmlhttpPages.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlPagesDoc= xmlhttpPages.responseXML;
			try
			{
				var mainTag = xmlPagesDoc.getElementsByTagName('PaginaPrincipale');
				keyPageNameList[0] = mainTag[0].getAttribute("nomePagina");
				keyPageXMLFileNameList[0] =  mainTag[0].getAttribute("nomeFileXML");

				var secondaryTags = xmlPagesDoc.getElementsByTagName('Pagina');
				var ti = 0;
				for (ti = 0; ti < secondaryTags.length; ti++)
				{
					try
					{
						keyPageNameList[ti + 1] = secondaryTags[ti].getAttribute("nomePagina");
						keyPageXMLFileNameList[ti + 1] =  secondaryTags[ti].getAttribute("nomeFileXML");
						if (debugMode == true)
						{
							console.log('keyPageNameList entry ' + (ti + 1) + ' = ' + keyPageNameList[ti + 1]);
							console.log('keyPageXMLFileNameList entry ' + (ti + 1) + ' = ' + keyPageXMLFileNameList[ti + 1]);
						}
					}
					catch (myEx)
					{
						console.log(myEx.message);
						alert(myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File " + filePath + " non trovato.");
		}
    };
    
	xmlhttpPages.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpPages.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function storePageKeys(arrayIndex)
{
	var elements = document.getElementsByTagName('button');
	var ei = 0;
	for (ei = 0; ei < elements.length; ei++)
	{
		var myID = elements[ei].id;
		var myTitle = elements[ei].title;
		var myText =  elements[ei].innerHTML;
		if (myID != "" && myID.length >= 7)
		{
			if (myID.toLowerCase().substr(0, 4) == "land" || myID.toLowerCase().substr(0, 4) == "port")
			{
				var keyObject = { position: myID, className: elements[ei].className, buttonFunction: myTitle, buttonText: myText };
				keyPages[arrayIndex].push(keyObject);
				if (myTitle.toLowerCase() == "eftpos" ||
					myTitle.toLowerCase() == "eft-pos")
				{
					webAppHasEftpos = true;
				}
				var myTitleTrimmedToLower = myTitle.toLowerCase();
				myTitleTrimmedToLower = myTitleTrimmedToLower.replace(/ /g, "");	// Togliere eventuali spazi.				if (myTitle.toLowerCase() == "scontrino di corteftpos" ||
				if (myTitleTrimmedToLower == "scontrinodicortesia" ||
					myTitleTrimmedToLower == "scontrinocortesia")
				{
					webAppHasSconCort = true;
				}
			}
		}
	}
}

function readAndStorePageFile(pageFilePathName, keyPageListIndex)
{
	// var filePath = "xml/Pagina-" + pageNumber + ".xml";
	var xmlhttpPages, xmlPagesDoc;
	xmlhttpPages= new XMLHttpRequest();
	xmlhttpPages.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
    	
    	// var exitFunctionsFound = 0; // Si tratta della funzione "Esci".
    	var exitOrGotoMainPageFunctionsFound = 0;
    	// Nel caso in cui non sia presente, non sarà possibile tornare alla pagina principale.
    	// Dovrebbe essere due (uno Landscape ed uno Portrait).
    	
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlPagesDoc = xmlhttpPages.responseXML;
			try
			{
				var tags = xmlPagesDoc.getElementsByTagName('key');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						var posxy = tags[ti].getAttribute("posizione");
						if (debugMode == true)
						{
							console.log('posxy = ' + posxy);
							console.log('class = ' + tags[ti].getAttribute("class"));
							console.log('funzione = ' + tags[ti].getAttribute("funzione"));
							console.log('testo = ' + tags[ti].getAttribute("testo"));
						}
						if ((tags[ti].getAttribute("class") != "" &&
							tags[ti].getAttribute("funzione") != "" &&
							tags[ti].getAttribute("testo") != "") ||
							tags[ti].getAttribute("funzione").toLowerCase() == "nasconde" ||
							tags[ti].getAttribute("funzione").toLowerCase() == "invariata")
						{
							var className = tags[ti].getAttribute("class");
							var buttonFunction = tags[ti].getAttribute("funzione");
							var buttonText = tags[ti].getAttribute("testo").replace("\\n", "<br>");
							var keyObject = { position: posxy, className: className, buttonFunction: buttonFunction, buttonText: buttonText };
							var tia = 0;
							for (tia = 0; tia < keyPages[0].length; tia++)
							{		
								var arrayPosxy = keyPages[0][tia].position;
								if (arrayPosxy == posxy)
								{
									keyPages[keyPageListIndex][tia] = keyObject;
									break;
								}
							}
							// keyPages[keyPageListIndex].push(keyObject);
							if (tags[ti].getAttribute("funzione").toLowerCase() == "esci" ||
								tags[ti].getAttribute("funzione").toLowerCase() == "pagina-principale")
							{
								exitOrGotoMainPageFunctionsFound ++;
							}
							if (tags[ti].getAttribute("funzione").toLowerCase() == "eftpos" ||
								tags[ti].getAttribute("funzione").toLowerCase() == "eft-pos")
							{
								webAppHasEftpos = true;
							}
							var myTitleTrimmedToLower = tags[ti].getAttribute("funzione").toLowerCase();
							myTitleTrimmedToLower = myTitleTrimmedToLower.replace(/ /g, "");	// Togliere eventuali spazi.				if (myTitle.toLowerCase() == "scontrino di corteftpos" ||
							if (myTitleTrimmedToLower == "scontrinodicortesia" ||
								myTitleTrimmedToLower == "scontrinocortesia")
							{
								webAppHasSconCort = true;
							}
						}
					}
					catch (myEx)
					{
						console.log(myEx.message);
						alert(myEx.message);
						break;
					}
				}
				if (exitOrGotoMainPageFunctionsFound == 0 && keyPageListIndex != 0)
				{	
					// alert ("Nel file " + pageFilePathName + " non è stato configurato un tasto con la funzione \"Esci\". Non sarà possibile tornare alla pagina principale.");
					alert ("Nel file " + pageFilePathName + " non è stato configurato un tasto con la funzione \"Esci\" o \"Pagina-Principale\". Non sarà possibile tornare alla pagina principale.");
				}
				else if (exitOrGotoMainPageFunctionsFound == 1 && keyPageListIndex != 0)
				{
					// alert ("Nel file " + pageFilePathName + " è stato configurato un solo tasto con la funzione \"Esci\". Dipende dall'orientazione della pagina (landscape o portrait), non sarà possibile tornare alla pagina principale.");
					alert ("Nel file " + pageFilePathName + " è stato configurato un solo tasto con la funzione \"Esci\" o \"Pagina-Principale\". Dipende dall'orientamento della pagina (landscape o portrait), non sarà possibile tornare alla pagina principale.");
				}
			}
			catch (myEx)
			{
				console.log(myEx.message);
				alert(myEx.message  + "\n(File " + pageFilePathName + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{			
			alert("File di pagina " + pageFilePathName + " non trovato.");
		}
    };
    
	xmlhttpPages.open("GET", pageFilePathName + "?t=" + (new Date()).getTime(), false); // Synchronous. query string con getTime (sempre numero unico) supera problema di caching nel browser del cliente.
	try
	{
		xmlhttpPages.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function showMainPage()
{
	var ti = 0;
	for (ti = 0; ti < keyPages[0].length; ti++)
	{
		var posxy = keyPages[0][ti].position;
		if (debugMode == true)
		{
			console.log('posxy = ' + posxy);
			console.log('class = ' + keyPages[0][ti].className);
			console.log('funzione = ' + keyPages[0][ti].buttonFunction);
			console.log('testo = ' + keyPages[0][ti].buttonText);
		}
		document.getElementById(posxy).className = keyPages[0][ti].className;
		document.getElementById(posxy).title = keyPages[0][ti].buttonFunction;
		document.getElementById(posxy).innerHTML = keyPages[0][ti].buttonText;
		if (document.getElementById(posxy).title.toLowerCase() == "nasconde")
		{
			document.getElementById(posxy).style.visibility = "hidden";
		}
		else
		{
			document.getElementById(posxy).style.visibility = "visible";
		}
	}
}

function readCustomKeysXMLFile()	// Riguarda solamente la pagina principale.
{
	var filePath = "xml/Tasti.xml";
	var xmlhttpMainPage, xmlMainPageDoc;
	xmlhttpMainPage = new XMLHttpRequest();
	xmlhttpMainPage.onreadystatechange = function()
	{
    	if (debugMode == true)
		{
			console.log('readyState = ' + this.readyState);
	    	console.log('status = ' + this.status);
		}
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlMainPageDoc = xmlhttpMainPage.responseXML;
			try
			{
				var tags = xmlMainPageDoc.getElementsByTagName('key');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						var posxy = tags[ti].getAttribute("posizione");
						if (debugMode == true)
						{
							console.log('posxy = ' + posxy);
							console.log('class = ' + tags[ti].getAttribute("class"));
							console.log('funzione = ' + tags[ti].getAttribute("funzione"));
							console.log('testo = ' + tags[ti].getAttribute("testo"));
						}
						if (tags[ti].getAttribute("class") != "" && tags[ti].getAttribute("class") != null &&
							tags[ti].getAttribute("funzione") != "" && tags[ti].getAttribute("funzione") != null &&
							tags[ti].getAttribute("testo") != "" && tags[ti].getAttribute("testo") != null)
						{
							document.getElementById(posxy).className = tags[ti].getAttribute("class");
							document.getElementById(posxy).title = tags[ti].getAttribute("funzione");
							document.getElementById(posxy).innerHTML = tags[ti].getAttribute("testo").replace("\\n", "<br>");
							if (document.getElementById(posxy).title.toLowerCase() == "nasconde")
							{
								document.getElementById(posxy).style.visibility = "hidden";
							}
							else
							{
								document.getElementById(posxy).style.visibility = "visible";
							}
						}
					}
					catch (myEx)
					{
						console.log(myEx.message);
						alert(myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File di tasti " + filePath + " non trovato.\n\nPer eventualmente ignorare il file, impostare l'attributo ignoraFileConf al valore 1 nel file Settings.xml.");
		}
    };
    
	xmlhttpMainPage.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpMainPage.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function readPluXmlFile()
{
	var filePath = "xml/PLU.xml";
	var xmlhttpPLU, xmlPLUDoc;
	xmlhttpPLU= new XMLHttpRequest();
	xmlhttpPLU.onreadystatechange = function()
	{
    	if (debugMode == true)
		{
			console.log('readyState = ' + this.readyState);
	    	console.log('status = ' + this.status);
	    }
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlPLUDoc = xmlhttpPLU.responseXML;
			try
			{
				var tags = xmlPLUDoc.getElementsByTagName('PLUEntry');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						var pluNumber = tags[ti].getAttribute("numero");				
						var pluDescription = tags[ti].getAttribute("descrizione");
						var pluUnitPrice = tags[ti].getAttribute("prezzoUnitario");
						var pluDep = tags[ti].getAttribute("reparto");
						var pluBarcode = tags[ti].getAttribute("barcode");
						if (debugMode == true)
						{
							console.log('numero = ' + pluNumber);
							console.log('descrizione = ' + pluDescription);
							console.log('prezzo unitario = ' + pluUnitPrice);
							console.log('reparto = ' + pluDep);
							console.log('barcode = ' + pluBarcode);
						}
							
						var pluEntry = [pluNumber, pluDescription, pluUnitPrice, pluDep, pluBarcode];
						pluArray.push(pluEntry);
					}
					catch (myEx)
					{
						console.log(myEx.message);
						alert(myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File " + filePath + " non trovato.");
		}
    };
    
	xmlhttpPLU.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpPLU.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function storeMainPageKeys()
{
	var elements = document.getElementsByTagName('button');
	var ei = 0;
	for (ei = 0; ei < elements.length; ei++)
	{
		var myID = elements[ei].id;
		var myTitle = elements[ei].title;
		var myText =  elements[ei].innerHTML;
		if (myID != "" && myID.length >= 7)
		{
			if (myID.toLowerCase().substr(0, 4) == "land" || myID.toLowerCase().substr(0, 4) == "port")
			{
				var keyObject = { position: myID, className: elements[ei].className, buttonFunction: myTitle, buttonText: myText };
				keyPages[0].push(keyObject);
			}
		}
	}
}

function readSecondaryPageFile_Non_Utilizzata(pageNumber)
{
	var filePath = "xml/Pagina-" + pageNumber + ".xml";
	var xmlhttpPages, xmlPagesDoc;
	xmlhttpPages = new XMLHttpRequest();
	xmlhttpPages.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
    	var exitFunctionsFound = 0; // Si tratta della funzione "Esci". Nel caso in cui non sia presente, non sarà possibile tornare alla pagina principale.
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlPagesDoc= xmlhttpPages.responseXML;
			try
			{
				var tags = xmlPagesDoc.getElementsByTagName('key');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						var posxy = tags[ti].getAttribute("posizione");
						if (debugMode == true)
						{
							console.log('posxy = ' + posxy);
							console.log('class = ' + tags[ti].getAttribute("class"));
							console.log('funzione = ' + tags[ti].getAttribute("funzione"));
							console.log('testo = ' + tags[ti].getAttribute("testo"));
						}
						if ((tags[ti].getAttribute("class") != "" && tags[ti].getAttribute("funzione") != "" && tags[ti].getAttribute("testo") != "") ||
							tags[ti].getAttribute("funzione").toLowerCase() == "nasconde")
						{
							var className = tags[ti].getAttribute("class");
							var buttonFunction = tags[ti].getAttribute("funzione");
							var buttonText = tags[ti].getAttribute("testo").replace("\\n", "<br>");
							var keyObject = { position: posxy, className: className, buttonFunction: buttonFunction, buttonText: buttonText };
							keyPages[pageNumber].push(keyObject);
							if (tags[ti].getAttribute("funzione").toLowerCase() == "esci")
							{
								exitFunctionsFound++;
							}
						}
					}
					catch (myEx)
					{
						console.log(myEx.message);
						alert(myEx.message);
						break;
					}
				}
				if (exitFunctionsFound == 0)
				{	
					alert ("Nel file " + filePath + " non è stato configurato un tasto con la funzione \"Esci\". Non sarà possibile tornare alla pagina principale.");
				}
				else if (exitFunctionsFound == 1)
				{
					alert ("Nel file " + filePath + " è stato configurato un solo tasto con la funzione \"Esci\". Dipende dall'orientazione della pagina (landscape o portrait), non sarà possibile tornare alla pagina principale.");
				}
			}
			catch (myEx)
			{
				console.log(myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File di pagina secondaria " + filePath + " non trovato.");
		}
    };
    
	xmlhttpPages.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpPages.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function readOperatorsXMLFile()
{
	var filePath = "xml/Operatori.xml";
	var xmlhttpOper, xmlOperDoc;
	xmlhttpOper = new XMLHttpRequest();
	xmlhttpOper.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
    	var prefixText = "";
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlOperDoc = xmlhttpOper.responseXML;
			try
			{
				var tags = xmlOperDoc.getElementsByTagName('Operatore');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						// numeroReparto="1" nome="Brioches" gruppoIVA="1" />
						var myNR = parseInt(tags[ti].getAttribute("numeroOperatore"), 10);
						var myName = tags[ti].getAttribute("nome");
						var operObject = { name: myName };
						operatorXMLArray[myNR] = operObject;			
					}
					catch (myEx)
					{
						console.log(prefixText + " " + myEx.message);
						alert(prefixText + "\n" + myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(prefixText + " " + myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			console.log("File degli operatori " + filePath + " non trovato. La stampante non sarà programmata con i nomi operatore.");
		}
    };
    
	xmlhttpOper.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpOper.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function setOperatorButtonNames()
{
	var oai = 1;
	var opButtonID = "";
	for (oai = 1; oai < operatorXMLArray.length; oai++)
	{
		if (operatorXMLArray[oai] != null && operatorXMLArray[oai].name != null)
		{
			opButtonID = "operatorButton" + oai.toString();
			if (operatorXMLArray[oai].name.length <= 10)
			{
				document.getElementById(opButtonID).innerHTML = operatorXMLArray[oai].name;
			}
			else
			{
				document.getElementById(opButtonID).innerHTML = operatorXMLArray[oai].name.substr(0, 10) +
																"<br>" +
																operatorXMLArray[oai].name.substr(10);
			}
		}
	}
}

function progOperatorNames()
{
	var eposOperOut = new epson.fiscalPrint();
	eposOperOut.onreceive = function (result, tag_names_array, add_info)
	{
		// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
		if (debugMode == true)
		{
			statoAndResultConsoleLog(result, tag_names_array, add_info);
		}
	};

	var xmlProgOperators = "";
	var oai = 0;
	var myOperatorName = "";
	var opNumber = "";
	
	if (operatorXMLArray != null)
	{
		for (oai = 0; oai < operatorXMLArray.length; oai++)
		{
			if (operatorXMLArray[oai] != null && operatorXMLArray[oai].name != null)
			{
				opNumber = oai.toString();
				if (oai < 10)
				{
					opNumber = "0" + opNumber;
				}
				myOperatorName = operatorXMLArray[oai].name + "                    ";
				myOperatorName = myOperatorName.substr(0, 20);
				xmlProgOperators += '\t<directIO  command="4013" data="' + opNumber + myOperatorName + '00000000" />\r\n';			
			}
		}
	}
	if (xmlProgOperators != "")
	{
		var dataToSend = '<printerCommands>\r\n' + xmlProgOperators + '</printerCommands>\r\n';
		eposOperOut.send(xmlHTTPRequestURLPageLoad , dataToSend , 0, "sync");
	}
}

function readDepartmentsXMLFileAndParams()
{
	var filePath = "xml/Reparti.xml";
	var xmlhttpDept, xmlDeptDoc;
	xmlhttpDept = new XMLHttpRequest();
	xmlhttpDept.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
    	var prefixText = "";
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlDeptDoc = xmlhttpDept.responseXML;
			try
			{
				var tags = xmlDeptDoc.getElementsByTagName('Reparto');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						// numeroReparto="1" nome="Brioches" gruppoIVA="1" />
						var myNR = parseInt(tags[ti].getAttribute("numeroReparto"), 10);
						var myName = tags[ti].getAttribute("nome");
						var myTaxGroup = tags[ti].getAttribute("gruppoIVA");
						var depObject = { name: myName, taxGroup: myTaxGroup };
						departmentXMLArray[myNR] = depObject;
						readDepartmentParams(myNR);				
					}
					catch (myEx)
					{
						console.log(prefixText + " " + myEx.message);
						alert(prefixText + "\n" + myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(prefixText + " " + myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File dei reparti " + filePath + " non trovato.");
		}
    };
    
	xmlhttpDept.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpDept.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function readDepartmentParams(depNumber)
{
	var eposDepIn = new epson.fiscalPrint();
	eposDepIn.onreceive = function (result, tag_names_array, add_info)
	{
		// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
		if (debugMode == true)
		{
			statoAndResultConsoleLog(result, tag_names_array, add_info);
		}
		if (result.success == true)
		{
			if (add_info.responseData !== undefined)
			{
				//	<responseData>01PRODOTTO  1         0000000000000000000000000000010000000000000  </responseData>
				//				  012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012
				var response_data = add_info.responseData;
				if (debugMode == true)
				{
					console.log('Reparto response_data  = ' + response_data);
				}
				departmentParamsArray[depNumber] = response_data;
			}
		}
	};
				
	var depNumString = depNumber.toString();
	if (depNumber < 10)
	{
		depNumString = "0" + depNumString;
	}
	var dataToSend = '<printerCommand>\r\n' +
						'\t<directIO  command="4202" data="' + depNumString + '" />\r\n' +
						'</printerCommand>\r\n';						
	eposDepIn.send(xmlHTTPRequestURLMain, dataToSend , defaultPostTimeout, "sync");
}

function progDepartmentsParams()
{
	var eposDepOut = new epson.fiscalPrint();
	eposDepOut.onreceive = function (result, tag_names_array, add_info)
	{
		// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
		if (debugMode == true)
		{
			statoAndResultConsoleLog(result, tag_names_array, add_info);
		}
	};
			
	var xmlProgDeps = "";
	var di = 1;
	for (di = 1; di <= 99; di++)
	{
		if (departmentXMLArray[di] != null && departmentXMLArray[di] != "" && departmentParamsArray[di] != null && departmentParamsArray[di] != "")
		{
			var depNumber = di.toString();
			if (di < 10)
			{
				depNumber = "0" + depNumber;
			}
			var depName = departmentXMLArray[di].name;
			depName += "                    ";
			depName = depName.substr(0, 20);
			var taxGroup = departmentXMLArray[di].taxGroup;
			if (taxGroup.length == 1)
			{
				taxGroup = "0" + taxGroup;
			}
			//	<responseData>01PRODOTTO  1         0000000000000000000000000000010000000000000  </responseData>
			//				  012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012
			var params1 = departmentParamsArray[di].substr(22, 28);
			var params2 = departmentParamsArray[di].substr(52);
			xmlProgDeps += ('\t<directIO  command="4002" data="' + depNumber + depName + params1 + taxGroup + params2 + '" />\r\n');
		}
			
	}
	if (xmlProgDeps != "")
	{
		var dataToSend = '<printerCommands>\r\n' + xmlProgDeps + '</printerCommands>\r\n';
		eposDepOut.send(xmlHTTPRequestURLMain, dataToSend , defaultPostTimeout, "sync");
	}
}

function readPaymentsXMLFile()
{
	var filePath = "xml/Pagamenti.xml";
	var xmlhttpPay, xmlPayDoc;
	xmlhttpPay = new XMLHttpRequest();
	xmlhttpPay.onreadystatechange = function()
	{
    	if (debugMode == true)
    	{
    		console.log('readyState = ' + this.readyState);
    		console.log('status = ' + this.status);
    	}
    	var prefixText = "";
		if (this.readyState == 4 && this.status == 200)
    	{
       		xmlPayDoc = xmlhttpPay.responseXML;
			try
			{
				
				var tags = xmlPayDoc.getElementsByTagName('Pagamento');
				var ti = 0;
				for (ti = 0; ti < tags.length; ti++)
				{
					try
					{
						// <pagamento tipoPagamento="0" indice="1" nome="Bancanote €5" />
						var myType = parseInt(tags[ti].getAttribute("tipoPagamento"), 10);
						var myIndex = parseInt(tags[ti].getAttribute("indice"), 10);
						var myName = tags[ti].getAttribute("nome");
						var payObject = { index: myIndex, name:myName };
						if (paymentsXMLArray[myType] == null || paymentsXMLArray[myType] == "")
						{
							paymentsXMLArray[myType] = [];
						}
						paymentsXMLArray[myType].push(payObject);
					}
					catch (myEx)
					{
						console.log(prefixText + " " + myEx.message);
						alert(prefixText + "\n" + myEx.message);
						break;
					}
				}
			}
			catch (myEx)
			{
				console.log(prefixText + " " + myEx.message);
				alert(myEx.message  + "\n(File " + filePath + " non è un file XML o è malformato).");
			}
		}
		else if (this.readyState == 4 && this.status == 404)
		{
			alert("File dei pagamenti " + filePath + " non trovato.");
		}
    };
    
	xmlhttpPay.open("GET", filePath + "?t=" + (new Date()).getTime(), false); // Synchronous.
	try
	{
		xmlhttpPay.send();	
	}
	catch (myEx)
	{
		console.log(myEx.message);
		alert(myEx.message);
	}	
}

function progPaymentsName()
{
	var eposPayOut = new epson.fiscalPrint();
	eposPayOut.onreceive = function (result, tag_names_array, add_info)
	{
		// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
		if (debugMode == true)
		{
			statoAndResultConsoleLog(result, tag_names_array, add_info);
		}
	};

	var xmlProgPayments = "";
	var payType = 0;
	var pi = 0;
	var myIndex = 0;
	var myPayName = "";
	
	if (paymentsXMLArray[payType] != null && paymentsXMLArray[payType] != "")
	{
		for (pi = 0; pi < paymentsXMLArray[payType].length; pi++)
		{
			myIndex = paymentsXMLArray[payType][pi].index.toString();
			if (myIndex != "0") // Contante 0 ha un nome fisso (CONTANTI).
			{
				if (myIndex.length == 1)
				{
					myIndex = "0" + myIndex;
				}
				myPayName = paymentsXMLArray[payType][pi].name + "                    ";
				myPayName = myPayName.substr(0, 20);
				xmlProgPayments += '\t<directIO  command="4053" data="' + myIndex + myPayName + '" />\r\n';
			}
		}
	}
	payType = 2;
	if (paymentsXMLArray[payType] != null && paymentsXMLArray[payType] != "")
	{
		pi = 0;
		for (pi = 0; pi < paymentsXMLArray[payType].length; pi++)
		{
			myIndex = paymentsXMLArray[payType][pi].index.toString();
			if (myIndex != "0") // Carta di credito 0 ha un nome fisso (CREDITI).
			{
				if (myIndex.length == 1)
				{
					myIndex = "0" + myIndex;
				}
				myPayName = paymentsXMLArray[payType][pi].name + "                    ";
				myPayName = myPayName.substr(0, 20);
				xmlProgPayments += '\t<directIO  command="4007" data="' + myIndex + myPayName + '" />\r\n';
			}
		}
	}

	payType = 3;
	if (paymentsXMLArray[payType] != null && paymentsXMLArray[payType] != "")
	{
		pi = 0;
		for (pi = 0; pi < paymentsXMLArray[payType].length; pi++)
		{
			myIndex = paymentsXMLArray[payType][pi].index.toString();
			if (myIndex != "0") // Ticket 0 non esiste.
			{
				if (myIndex.length == 1)
				{
					myIndex = "0" + myIndex;
				}
				myPayName = paymentsXMLArray[payType][pi].name + "                    ";
				myPayName = myPayName.substr(0, 20);
				xmlProgPayments += '\t<directIO  command="4010" data="' + myIndex + myPayName + '000000000" />\r\n';
			}
		}
	}
	if (xmlProgPayments != "")
	{
		var dataToSend = '<printerCommands>\r\n' + xmlProgPayments + '</printerCommands>\r\n';
		eposPayOut.send(xmlHTTPRequestURLMain, dataToSend , defaultPostTimeout, "sync");
	}
}

function manageExtendedDescription(textAreaTag, warningLabelTag)
{
	var descLines = document.getElementById(textAreaTag).value.split("\n");
	// if (document.getElementById('extendedDescriptionTextArea').value.length >= maxChars)
	if (descLines.length > maxDescLines)
	{
		// alert (maxCharsWarningText);		
		document.getElementById(warningLabelTag).style.visibility = "visible";
	}
	else
	{
		document.getElementById(warningLabelTag).style.visibility = "hidden";
	}
	
	switch (event.keyCode)
	{
		case 0:		// Problema Android modalità predictive text
		case 8:		// Backspace
		case 46:	// Canc
		case 229:	// Problema Android modalità predictive text
		case 37:	// Freccia sinistra
		case 38:	// Freccia su
		case 39:	// Freccia destra
		case 40:	// freccia giù
			return;
			// break;
		
		default:
			break;
	}
		
	if (document.getElementById(textAreaTag).selectionStart != document.getElementById(textAreaTag).selectionEnd)
	{
		return;
	}
	checkAndRealignExtendedDescription(descLines, textAreaTag);
}

function checkAndRealignExtendedDescription(descLines, textAreaTag)
{
	var overFlowChar = "";
	var cursorPosition = document.getElementById(textAreaTag).selectionStart;
	
	// var totalLength = document.getElementById(textAreaTag).value.length;
	document.getElementById(textAreaTag).value = "";
	var dl = 0;
	for (dl = 0; dl < descLines.length; dl++)
	{
		descLines[dl] = overFlowChar + descLines[dl];
		overFlowChar = "";
		if (descLines[dl].length > maxCharsPerLine)
		{
			if (cursorPosition % (maxCharsPerLine + 1) == 0)
			{
				cursorPosition++; // Solamente se il cursore è alla fine della riga.
			}
			overFlowChar = descLines[dl].substr(maxCharsPerLine);
			descLines[dl] = descLines[dl].substr(0, maxCharsPerLine);	
		}
	}
	if (overFlowChar != "")
	{
		// Aggiunge riga
		descLines[descLines.length] = overFlowChar;
		if (descLines[descLines.length - 1].length > 25)
		{
			descLines[descLines.length - 1] = overFlowChar.substr(0, 25);
			descLines[descLines.length] = overFlowChar.substr(25);
			if (descLines[descLines.length - 1].length > 25)
			{
				descLines[descLines.length - 1] = descLines[descLines.length - 1].substr(0, 25);
				descLines[descLines.length] = descLines[descLines.length - 1].substr(25);
				if (descLines[descLines.length - 1].length > 25)
				{
					descLines[descLines.length - 1] = descLines[descLines.length - 1].substr(0, 25);
				}
			}
		}
	}	 
	dl = 0;
	for (dl = 0; dl < descLines.length; dl++)
	{
		if (dl > 0)
		{
			document.getElementById(textAreaTag).value += "\n";
		}
		document.getElementById(textAreaTag).value += descLines[dl];
	}
	
	document.getElementById(textAreaTag).selectionStart = cursorPosition;
	document.getElementById(textAreaTag).selectionEnd = cursorPosition;
}

function manageCodes()
{
	var cursorPosition = document.getElementById('codeString').selectionStart;
	/*switch (event.keyCode)
	{
		case 0:		// Problema Android modalità predictive text
		case 8:		// Backspace
		case 46:	// Canc
		case 229:	// Problema Android modalità predictive text
		case 37:	// Freccia sinistra
		case 38:	// Freccia su
		case 39:	// Freccia destra
		case 40:	// freccia giù
			return;
			break;
		
		default:
			break;
	}
	*/

	if (document.getElementById('codeString').value.length > (document.getElementById('codeString').maxLength))
	{
		// alert (event.keyCode);
		alert("Max " + document.getElementById('codeString').maxLength + " caratteri raggiunti!");
		var tempValue = document.getElementById('codeString').value;
		document.getElementById('codeString').value = tempValue.substr(0, (cursorPosition - 1));
		if (cursorPosition != document.getElementById('codeString').maxLength)
		{
			 document.getElementById('codeString').value += tempValue.substr(cursorPosition);
		}
	}
}

function manageEscapeChars(stringIn)
{
	var stringOut = stringIn.replace(/\&/g, "&amp;"); // must be the first substitution
	stringOut = stringOut.replace(/\</g, "&lt;");
	stringOut = stringOut.replace(/\>/g, "&gt;");
	stringOut = stringOut.replace(/\"/g, "&quot;");
	stringOut = stringOut.replace(/\'/g, "&apos;");
	return stringOut;
}
