﻿"use strict";
/*
------------------------------------------------------------------------------------------

NOME AZIENDA	: EPSON ITALIA SPA
NOME FILE		: mPOSKeyboardZepto-V6.1.js 
DESCRIZIONE		: File principale JavaScript tastiera virtuale mPOSKeyboard.

PROPRIETÀ		: Le informazioni qui contenute sono proprietà di EPSON ITALIA SPA.
				  È fatto divieto di usare, rivelare a terzi o riprodurre senza il
				  consenso scritto di EPSON ITALIA SPA.
------------------------------------------------------------------------------------------
*/
Zepto(function($)
{
	// ************ M E S S A G G I ***********************
	var messaggioFPNoAnswer = "Servizio fpmate.cgi non è riuscito a comunicare con il firmware fiscale (errore FP_NO_ANSWER).\n" +
						"Il firmware fiscale consente una connessione alla volta per cui chiudere per cortesia un'eventuale connessione in corso (EpsonFpWizard, software gestionale, ecc.).\n" +
						"Verificare inoltre il flag SET 14/35 XON-XOFF che deve essere 0 e SET 19 CONNESSIONE che deve essere \"COMPUTER\".";
	var messaggioFPNoAnswerNetwork = "Il browser non riesce a comunicare con la stampante. Controlla per cortesia la rete, stampante spenta, parametri printerIPAddress ecc.";
	var offlineAlertText = "Fine rotolo/carta o coperchio stampante aperto!";
	var prepWebAppInProgessText =	'PREPARARE WEB APP...';
	var prepWebAppOKText =			'PREPARARE WEB APP OK';	
	var progPrinterText =			'PROGRAM STAMPANTE...';
	var progPrinterDemoText =		'PROG. STAMPANTE DEMO';	// Messaggio indicativo che però non effettua nessuna programmazione in modalità Demo.
	var registrationStateText =		'STATO  REGISTRAZIONE';
	var offlineText =				' STAMPANTE OFF-LINE ';	// 03
	var erroneousKeyText =			'    TASTO ERRATO    ';	// 08
	var erroneousDateText =			'    DATA  ERRATA    ';	// 10
	var erroneousSequenceText =		'  SEQUENZA  ERRATA  ';	// 11
	var nonExistentDataText =		'  DATI INESISTENTI  ';	// 12
	var erroneousValueText =		'   VALORE  ERRATO   ';	// 13
	var	notForeseenText =			'    NON PREVISTO    ';	// 16
	var notPossibleNowText =		'  IMPOSSIBILE  ORA  ';	// 17
	var notPossibleText =			'   NON  POSSIBILE   ';	// 18
	var valueExceededText =			'   SUPERA  VALORE   ';	// 20
	var limitExceededText = 		'   SUPERA  LIMITE   ';	// 21
	var notProgrammedText =			'  NON  PROGRAMMATO  ';	// 22
	var insufficientCashText =		'  CASSA  INFERIORE  ';	// 26
	var depLimitExceededText =		'OLTRE PROGRAMMAZIONE';	// 27
	var checksumErrorText =			'  CHECKSUM  ERRATO  ';	// 30
	var eftposErrorText =			' EFT-POS in ERRORE  ';	// 38
	var docAlreadyVoidedText =		' DOC già ANNULLATO  ';	// 39
	var docAlreadyReturnedText =	'    DOC già RESO    ';	// 40
	var refDocTypeRefundErrorText =	'ERRORE DOC RIF. RESO';	// 41
	var refDocTypeVoidErrorText =	'ERR DOC RIF. ANNULLO';	// 42
	var protocolErrorText =			' ERRORE  PROTOCOLLO ';
	var	printingFailedText =		'   STAMPA FALLITA   ';
	var discountText =				'SCONTO              ';
	var percentageDiscountText =	'SCONTO PERCENTUALE  ';
	var surchargeText =				'MAGGIORAZIONE       ';
	var percentageSurchargeText =	'MAGGIORAZ. PERCENT. ';
	var stornoText =				'STORNO              ';
	var sconCortStornoText = 		'> > > > S T O R N O < < < <';
	var sconCortStornoTextEsc = "";
	var voidLastText =				'CORREZIONE          ';
	var subtotalText =				'SUBTOTALE           ';
	var paymentDifferenceText =		'DIFFERENZA          ';
	var cashText =					'CONTANTE            ';
	var changeText =				'RESTO               ';
	var fiscalSerialNumberText =	'     MATRICOLA      ';
	var dateText =					'        DATA        ';
	var zeroDateText =				'00-00-00';
	var documentNumberText =		'  NUMERO DOCUMENTO  ';
	var closureNumberText =			'  NUMERO  CHIUSURA  ';
	var zeroDocZText =				'0000';
	var genericDepartmentText =		'Reparto';
	var xReportText =				'FINANZIARIO GIORNAL.';
	var xOperatorsReportText =		' OPERATORI GIORNAL. ';
	var xOperatorReportText =		' OPERATORE GIORNAL. ';
	var zReportText =				'CHIUSURA GIORNALIERA';
	var openDrawerText =			' APERTURA  CASSETTO ';
	var cashInText =				'ENTRATE CONTANTI    ';
	var cashOutText =				'USCITE CONTANTI     ';
	var docDiResoApertoText =		'DOC DI RESO APERTO  ';
	var docDiAnnulloApertoText =	'DOC DI ANNUL. APERTO';
	var eftposInProgRow1Text =		'    < EFT  POS >    ';
	var eftposInProgRow2Text =		' PAGAMENTO IN CORSO ';

	// ************ M E S S A G G I ***********************
	
	// ************ M A T R I C O L A ***********************
	var manufacturerCode = '';
	var modelCode = '';
	var serialNumerals = '';
	var fiscalSerialNumber = '';
	// ************ M A T R I C O L A ***********************
	
	// ************ R E S O    A N N U L L O ***********************
	var docResoAnnulloOpeningInProgress = false;
	var docResoAnnulloStep = 0;
	var resoAnnulloFiscalSerialNumber = '';
	var resoAnnulloDate = '';
	var	datePosition = 0;
	var resoAnnulloDocNum = '';
	var resoAnnulloZNum = '';
	var resoAnnulloButtonText = '';
	// ************ R E S O    A N N U L L O ***********************
	
	// ************ P L U ***********************
	var lastPluNumber = '';
	var lastPluUnitPrice = '';
	var lastPluDepartment = '';
	var lastPluDescription = '';
	// ************ P L U ***********************
	
	// ********** I N P U T *********************
	var acceptNewNumericInput = true;
	var anyNumKeyWasPressed = false;
	var	docOpen = false;
	var eftposInProgress = false;
	var lastUnitPrice = '';
	var lastTransactionAmount = 0;
	var lastSaleStornoAmount = 0;
	var quantityDecimalsInProgress = false;
	var defaultQuantity1 =  '0001000';	// quantity (1 + 3 decimal)
	var currentQuantityDecimal = 0;
	var quantity = defaultQuantity1;
	var genericDepartmentStep = 1;	// 1 is pricing. 2 is department number.
	var genericDepartmentNumber = '';
	var somethingToVoid = false;
	var paymentPhase = false;
	var paymentOutstanding = 0;
	var partialPaymentsInProgress = false;
	var extendedDescriptionFormOpen = false;
	var extendedDescriptionAndSaleFormOpen = false;
	var codesFormOpen = false;
	var paymentFormOpen = false;
	var ePOSDeviceString = "";
	var scontrinoCortesiaRequested = false;
	document.getElementById('maxLinesWarningLabel1').innerHTML = maxLinesWarningText;
	document.getElementById('maxLinesWarningLabel2').innerHTML = maxLinesWarningText;
	// ********** I N P U T *********************

	// ********** T A S T I *********************
	var commaKeyAllowed = true;
	var stornoPressed = false;
	var subtotalPressed = false;
	var needClear = false;
	var previousFunction = '';
	// ********** T A S T I *********************
	
	var supportsTouch = 'ontouchstart' in window || navigator.msMaxTouchPoints;
	var display = $('.virtualPrinterDisplayWrapper');
	var rowInfo = $('.rowInfo');
	var row1 = $('.row1');
	var row2 = $('.row2');
	display.data('row1','');	// Numerals and comma but no spaces and no Euro symbol.
	display.data('row2','');	// Numerals and comma but no spaces and no Euro symbol.
	var receiptTotalReadFromPrinter = 0;
	var receiptTotalCalculatedInternally = 0;
	var bodyXML = "";
	var lastDocCommDate = "";
	var lastDocCommTime = "";
	var lastDocCommZRepNumber = "";
	var lastDocCommDocNumber = "";

	$(document).ready(function()
	{
		rowInfo.html('');
		row1.html(prepWebAppInProgessText);
		row2.html('');
		display.data('row1','0,00');
		display.data('row2','');
		sconCortStornoTextEsc = manageEscapeChars(sconCortStornoText);

		prepareAndSaveDefaultMainSettings();
		if (mainSettings.printerProtocol.substr(0, 4).toLowerCase() == "file")	// URL sul file system locale.
		{
			mainSettings.printerProtocol = "http:";
		}
		readSettingsXMLFile();
		
		if (window.location.hostname == devWebServerIPAddress)
		{
			mainSettings.printerIPAddress = devPrinterIPAddress;
		}
		
		parseQueryString();
		/*
		if (ignoraFileConf == false)
		{
			readCustomKeysXMLFile();
		}
		*/
		
		readPagesFile();
		
		// keyPages.push([]);
		// storeMainPageKeys();
		keyPages.push([]);
		storePageKeys(0); // Salva i valori nel file index.htm per la retro-compatibilità
		var np = 0;
		for (np = 0; np < keyPageNameList.length; np++)
		{
			if (np > 0)
			{
				keyPages.push([]);
			}
			var filePath = "xml/" + keyPageXMLFileNameList[np];
			readAndStorePageFile(filePath, np);
		}
		showMainPage();		
		
		if (mainSettings.mostraLogoSinistro == true)
		{
			document.getElementById('leftLogo').style.visibility = "visible";
			if (mainSettings.fileLogoSinistro.toLowerCase() != "default")
			{
				document.getElementById('leftLogo').src = mainSettings.fileLogoSinistro;
			}
		}
		else
		{
			document.getElementById('leftLogo').style.visibility = "hidden";
		}
		
		if (mainSettings.mostraLogoDestro == true)
		{
			document.getElementById('rightLogo').style.visibility = "visible";
			if (mainSettings.fileLogoDestro.toLowerCase() != "default")
			{
				document.getElementById('rightLogo').src = mainSettings.fileLogoDestro;
			}
		}
		else
		{
			document.getElementById('rightLogo').style.visibility = "hidden";
		}
		
		if (mainSettings.databasePLU == "1")
		{
			readPluXmlFile();
		}
				
		// queryStringMain = "?" + "devid=local_printer" + "&" + "timeout=3000";
		
		xmlHTTPRequestURLMain = mainSettings.printerProtocol + "//" + mainSettings.printerIPAddress;
		if (mainSettings.printerPort != "")
		{
			xmlHTTPRequestURLMain += (':' + mainSettings.printerPort);
		}
		xmlHTTPRequestURLMain += "/cgi-bin/fpmate.cgi?timeout=";
		xmlHTTPRequestURLEftpos = xmlHTTPRequestURLMain;
		xmlHTTPRequestURLPageLoad = xmlHTTPRequestURLMain;
		
		xmlHTTPRequestURLMain += defaultQueryStringTimeout;		
		xmlHTTPRequestURLPageLoad += pageLoadTimeout;
		xmlHTTPRequestURLEftpos += eftposQueryStringTimeout;
		
		row1.html(prepWebAppOKText);
		
		if (mainSettings.printerIPAddress != "" && mainSettings.printerIPAddress != null)
		{
			if (mainSettings.operatori == "1")
			{
				masterTillOrOperator = true;
				currentTillNumber = 0;
				readOperatorsXMLFile();
				setOperatorButtonNames();
				if (currentOperatorNumber == -1) 
				{
					$('.landscape').css('display', 'none');
					$('.portrait').css('display', 'none');
					$('.operatorsFormClass').css('display', 'block');
					appLoadingInProgress = false;
				}
				else
				{
					prepareAll();
				}
			}
			else	// mainSettings.operatori == "0".
			{
				currentOperatorNumber = 1;
				if (mainSettings.tipoConnessione == "Dedicata" ||
					currentTillNumber == 1)
				{
					masterTillOrOperator = true;
				}
				if (currentTillNumber == -1)
				{
					if (mainSettings.tipoConnessione == "Multipla")
					{
						$('.landscape').css('display', 'none');
						$('.portrait').css('display', 'none');
						$('.tillsFormClass').css('display', 'block');
						appLoadingInProgress = false;
					}
					else	// Dedicata.
					{
						currentTillNumber = 0;
						prepareAll();
					}
				}
				else
				{
					prepareAll();
				}
			}			
		}
		else
		{
			row1.html('€&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0,00');
			row2.html('STATO&nbsp;&nbsp;REGISTRAZIONE');
			alert("Nessun indirizzo IP stampante impostato. Prova di aggiungere una query string all'URL nel formato ?printerIPAddress=x.x.x.x");			
			appLoadingInProgress = false;
		}
	});

	String.prototype.replaceAt=function(index, character)
	{
		return this.substr(0, index) + character + this.substr(index+character.length);
	};

	function pad(n, width, z)
	{
		z = z || '0';
		n = n + '';
		return n.length >= width ? n : new Array(width - n.length + 1).join(z) + n;
	}

	function prepareAll()
	{
		appLoadingInProgress = true;
		var myTimeout = 1000;
		currentOperatorNumberString = "0" + currentOperatorNumber;
		currentOperatorNumberString = currentOperatorNumberString.substr(currentOperatorNumberString.length - 2);
		
		currentTillNumberString = "00" + currentTillNumber.toString();
		currentTillNumberString = currentTillNumberString.substr(currentTillNumberString.length - 3);		
			
		if (masterTillOrOperator == true && switchingOperators == false)
		{
			if (mainSettings.demoMode == false)
			{
				row2.html(progPrinterText);
			}
			else
			{
				row2.html(progPrinterDemoText);
			}
		}
		
		if (switchingOperators == true)	// Funzione Cambia Operatore.
		{
			myTimeout = 50;
		}
		
		setTimeout(function()
		{
			if (mainSettings.demoMode == false && switchingOperators == false)
			{
				if (masterTillOrOperator == true)
				{
					preparePrinterSettings();
				}
				if (mainSettings.tipoConnessione == "Multipla" && mainSettings.operatori == "0")
				{
					setCurrentTillNumberAndNoOperatorsOnPrinter();
				}
				
				readSET1525();
				requestSerialNumber();
				if (webAppHasEftpos == true)
				{
					readSET31();
				}
				
				if (mainSettings.tipoConnessione == "Dedicata" && webAppHasSconCort == true)
				{
					readAndStoreRetailHeader();
				}
				
				if (mainSettings.downloadPLU == true && mainSettings.numeroPLUStampante != 0)
				{
					downloadPrinterPluDatabaseToBrowser();
				}
				else if (mainSettings.uploadPLU == true)
				{
					if (masterTillOrOperator == true)
					{
						uploadPLUDatabaseToPrinter();
					}
				}
			
				if (masterTillOrOperator == true)
				{
					if (mainSettings.operatori == "1")
					{
						progOperatorNames();
						// Program all Operatori.xml names here.
						// Operator number is in most of the commands.
						// No set "active operator concept" exists.
					}
					
					if (mainSettings.progReparti == true)
					{
						readDepartmentsXMLFileAndParams();
						progDepartmentsParams();
					}
				
					if (mainSettings.progNomiPagamenti == true)
					{
						readPaymentsXMLFile();
						progPaymentsName();
					}
				}
								
				if (mainSettings.usaWebSocket == true)
				{
					// setTimeout nestato supera problema di scadenza prematura in caso di un alert tipo "carta in esaurimento".
					setTimeout(function()
					{
						if (masterTillOrOperator == true)
						{
							var dataToSend = '<printerCommand>\r\n' +
												'\t<directIO  command="4034" data="0104001                                                               " comment="Web socket abilitato" />\r\n' +
												'</printerCommand>\r\n';
							// Delay sending as web server gets reset and breaks communication momentarily.
							setTimeout(sendToPrinter, 2000, dataToSend, true);
						}
					
						if (mainSettings.tipoConnessione == "Dedicata")
						{
							setTimeout(manageEposDevice, 4000);
						}
					},2000);				
				}
			} // Fine mainSettings.demoMode == false && switchingOperators == false)
			
			if (mainSettings.demoMode == true)
			{
				fiscalSerialNumber = "99IEC123456";			
			}

			if (mainSettings.operatori == "1")
			{
				if (operatorXMLArray[currentOperatorNumber] != null &&
					operatorXMLArray[currentOperatorNumber].name != null)
				{
					// if (operatorXMLArray[currentOperatorNumber].name.length
					addRowPrefix = operatorXMLArray[currentOperatorNumber].name;
				}
				else
				{
					addRowPrefix = "OP. " + currentOperatorNumber;
				}
			}
			else if (mainSettings.tipoConnessione == "Dedicata")
			{
				addRowPrefix = "Dedicata";
			}
			else 
			{
				addRowPrefix = "Cassa " + currentTillNumber;
			}			
			rowInfo.html(addRowPrefix);

			if (switchingOperators == false)
			{
				row1.html('€&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0,00');
				row2.html('STATO&nbsp;&nbsp;REGISTRAZIONE');
				setTimeout(function(){
					appLoadingInProgress = false;
				}, 500);
			}
			switchingOperators = false;
			if (debugMode == true)
			{
				if (mainSettings.operatori == "1")
				{
					if (operatorXMLArray[currentOperatorNumber] != null &&
						operatorXMLArray[currentOperatorNumber].name != null)
					{
						console.log ("Nome operatore = " + operatorXMLArray[currentOperatorNumber].name);
					}
					else
					{
						console.log ("Nome operatore = OPERATORE " + currentOperatorNumber);
					}
				}
				console.log("addRowPrefix = " + addRowPrefix);
				console.log("rowInfo.html) = " + rowInfo.html);				
			}
		}, myTimeout);
	}
	
	function managePageChange(pageName)
	{
		var tempText = "";
		var pageIndex = keyPageNameList.indexOf(pageName);
		if (pageIndex < 0)
		{
			tempText = "Nome pagina " + pageName + " invalido. I nomi validi sono:\r\n\r\n";
			for (var pg = 0; pg < keyPageNameList.length; pg++)
			{
				tempText += ("- " + keyPageNameList[pg]);
				if (pg == 0)
				{
					tempText += " (alias della funzione \"Esci\")";
				}
				tempText += "\r\n";
			}
			console.log (tempText);
			alert(tempText);
		}
		else if (keyPages[pageIndex].length > 0)
		{
			var ti = 0;
			for (ti = 0; ti < keyPages[pageIndex].length; ti++)
			{
				var posxy = "";
				if  (keyPages[pageIndex][ti] != null)
				{
					posxy = keyPages[pageIndex][ti].position;
					if (debugMode == true)
					{
						console.log('posxy = ' + posxy);
						console.log('class = ' + keyPages[pageIndex][ti].className);
						console.log('funzione = ' + keyPages[pageIndex][ti].buttonFunction);
						console.log('testo = ' + keyPages[pageIndex][ti].buttonText);
					}
				
					document.getElementById(posxy).className = keyPages[pageIndex][ti].className;
					document.getElementById(posxy).title = keyPages[pageIndex][ti].buttonFunction;
					document.getElementById(posxy).innerHTML = keyPages[pageIndex][ti].buttonText;
					if (document.getElementById(posxy).title.toLowerCase() == "nasconde")
					{
						document.getElementById(posxy).style.visibility = "hidden";
					}
					else
					{
						document.getElementById(posxy).style.visibility = "visible";
					}
				}
			}
		}
		else
		{
			tempText = "Pagina " + pageName + " è vuota (file xml/Pagina-" + pageName + ".xml non esiste o file non contiene i tag previsti).";
			console.log (tempText);
			alert(tempText);			
		}
	}

	function prepareText(myText)
	{
		myText = myText.replace(/,/g, '');
		myText = myText.replace(/\./g, '');
		myText = myText.replace(/€/g, '');
		myText = myText.replace(/\s/g, '');
		return myText;
	}

	function sendToPrinter(xml, ignoreError, pageLoadInProgress)
	{
		var onErrorCount = 0;
		var eposGeneral = new epson.fiscalPrint();
		eposGeneral.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false && ignoreError == false)
			{
				manageErrors(result, 90);
			}
		};
		// alert (xml);
		eposGeneral.onerror = function (result)
		{
			onErrorCount++;
			if (onErrorCount == 1) // Ignoriamo eventi onError multipli (possono verificarsi quando timeout ! = 0. Due eventi in fiscalprint.js.
			{
				if (ignoreError == false)	// Abilitazione Web socket genera sempre un errore in quanto il web server viene resettato prima di inviare la risposta.
				{
					manageErrors(result, 90);
				}
			}			
		};
		try
		{
			if (pageLoadInProgress == true)
			{
				eposGeneral.send(xmlHTTPRequestURLPageLoad, xml, pageLoadTimeout);
			}
			else
			{
				eposGeneral.send(xmlHTTPRequestURLMain, xml, defaultPostTimeout);
			}
		}
		catch (myEx)
		{
			alert(myEx.message);
		}
	}
	
	function manageErrors(result, internalCode)
	{
		display.trigger('virtualPrinterDisplay:blank', []);
					
		if (result.code == "FP_NO_ANSWER")
		{
			display.trigger('virtualPrinterDisplay:set_row2_to', [result.code]);
			alert(messaggioFPNoAnswer);
			return;			
		}
		else if (result.code == "FP_NO_ANSWER_NETWORK")
		{
			display.trigger('virtualPrinterDisplay:set_row2_to', [result.code]);
			alert(messaggioFPNoAnswerNetwork);
			return;			
		}
	
		switch (result.status)
		{
			case 3:
				display.trigger('virtualPrinterDisplay:set_row2_to', [offlineText]);
				alert (offlineAlertText);
				break;
			case 8:
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
				break;
			case 10:
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousDateText]);
				break;
			case 11:
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousSequenceText]);
				break;
			case 12:
				display.trigger('virtualPrinterDisplay:set_row2_to', [nonExistentDataText]);
				break;
			case 13:
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousValueText]);
				break;
			case 16:
				display.trigger('virtualPrinterDisplay:set_row2_to', [notForeseenText]);
				break;
			case 17:
				display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
				if (docOpen == false)
				{
					requestRTStatus(false);
				}
				break;
			case 18:
				display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleText]);
				break;
			case 20:
				display.trigger('virtualPrinterDisplay:set_row2_to', [valueExceededText]);
				break;
			case 21:
				display.trigger('virtualPrinterDisplay:set_row2_to', [limitExceededText]);
				break;
			case 22:
				display.trigger('virtualPrinterDisplay:set_row2_to', [notProgrammedText]);
				break;
			case 26:
				display.trigger('virtualPrinterDisplay:set_row2_to', [insufficientCashText]);
				break;
			case 27:
				display.trigger('virtualPrinterDisplay:set_row2_to', [depLimitExceededText]);
				break;
			case 30:
				display.trigger('virtualPrinterDisplay:set_row2_to', [checksumErrorText]);
				break;
			case 38:
				display.trigger('virtualPrinterDisplay:set_row2_to', [eftposErrorText]);
				break;
			case 39:
				display.trigger('virtualPrinterDisplay:set_row2_to', [docAlreadyVoidedText]);
				break;
			case 40:
				display.trigger('virtualPrinterDisplay:set_row2_to', [docAlreadyReturnedText]);
				break;
			case 41:
				display.trigger('virtualPrinterDisplay:set_row2_to', [refDocTypeRefundErrorText]);
				break;
			case 42:
				display.trigger('virtualPrinterDisplay:set_row2_to', [refDocTypeVoidErrorText]);
				break;

			default:
				switch (internalCode)	// Error number only in this tool.
				{
					case 90:
						display.trigger('virtualPrinterDisplay:set_row2_to', [printingFailedText]);
						break;
					case 91:	
						display.trigger('virtualPrinterDisplay:set_row2_to', [protocolErrorText]);
						break;
					
					default:
				}
		}
	}

	function preparePrinterSettings()
	{
		var dataToSend = '<printerCommands>\r\n' +
							'\t<directIO  command="4014" data="040" comment="OPERATORI off prima per consentire sempre il cambiamento del numero operatore altrimenti reset potrebbe fallire." />\r\n' + 
							'\t<directIO  command="1088" data="' + currentOperatorNumberString + '" comment="Reset stampante"/>\r\n';	
		if (mainSettings.operatori == "1") // Tutti gli operatori programmano la modalità operatore.
		{
			 dataToSend +=  ('\t<directIO  command="4014" data="041" comment="OPERATORI on" />\r\n' +
			 				 '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n');
			 				// Mettiamo STAMPA OPERATORE off per i doc commericale per affrontare crash con codice fiscale.			 				
			 				// La stessa stampa facciamo mediante trailer line tipo 2.
		}
		else
		{
			 dataToSend +=  ('\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n');
		}
		dataToSend +=		('\t<directIO  command="4014" data="111" comment="TX QUASI FINE CARTA RICH." />\r\n' +
							'\t<directIO  command="4014" data="120" comment="VIS. QUASI FINE CARTA off" />\r\n' +
							'\t<directIO  command="4014" data="291" comment="JavaPOS active" />\r\n' +
							'\t<directIO  command="4014" data="580" comment="RT RESO MERCE=NdC off" />\r\n' +
							'\t<directIO  command="4014" data="590" comment="RT ANNULLAM.= NdC off" />\r\n' +
							'\t<directIO  command="4015" data="01001" comment="VALORE IMPUTAZIONE 1" />\r\n' +
							'\t<directIO  command="4015" data="02001" comment="ARROTOND. IMPORTO 1" />\r\n' +
							'\t<directIO  command="4015" data="03001" comment="ARROTONDAMENTO % 1" />\r\n');
		/*
		Si blocca la comunicazione. Lo facciamo in un altro modo
		if (usaWebSocket == true)
		{
			dataToSend += '\t<directIO  command="4034" data="0104001                                                               " comment="Web socket abilitato" />\r\n';
		}
		else
		{
			dataToSend += '\t<directIO  command="4034" data="0104000                                                               " comment="Web socket disattivato" />\r\n';
		}
		*/
		dataToSend += '\t<directIO  command="4034" data="0401002                                                               " comment="Tipo memoria webapp = SD card" />\r\n' +
						'\t<directIO  command="4034" data="0701001                                                               " comment="Caricamento del webapp all\'avvio = sì" />\r\n' +
						'</printerCommands>\r\n';
		sendToPrinter(dataToSend, false, true);
	}
	
	function setCurrentTillNumberAndNoOperatorsOnPrinter()
	{
		var directIOLine = compileCurrentTillNumberDirectIOLine();
		var dataToSend = '<printerCommands>\r\n' +
							directIOLine +
							'\t<directIO  command="4014" data="040" comment="OPERATORI off" />\r\n' +
			 				'\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n' +
							'</printerCommands>\r\n';
		sendToPrinter(dataToSend, false, true);
	}
	
	function setCurrentTillNumberOnPrinter()
	{
		var directIOLine = compileCurrentTillNumberDirectIOLine();
		var dataToSend = '<printerCommand>\r\n' +
							directIOLine +
						'</printerCommand>\r\n';
		sendToPrinter(dataToSend, false, false);
	}

	function compileCurrentTillNumberDirectIOLine()
	{
		var directIOLine = '\t<directIO  command="4015" data="11' + currentTillNumberString + '"' +
							' comment="NUMERO CASSA ' + currentTillNumber.toString() + '" />\r\n';
 		return directIOLine;
	}

	function readSET1525()
	{
		var getConfNativeCommand = '4215';
		var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + getConfNativeCommand + '" data="25" comment="Soglia vecchi file corrispettivi in giorni" />\r\n' +
							'</printerCommand>\r\n';
		var eposSET1525 = new epson.fiscalPrint();
		eposSET1525.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.responseData !== undefined)
				{
					var response_data = add_info.responseData;
					try
					{
						oldDailyTakingsFilesDaysThreshold = parseInt(response_data.substr(2), 10);
					}
					catch (myEx)
					{						
					}
					if (debugMode == true)
					{
						console.log('responseData = ' +  response_data);
						console.log('oldDailyTakingsFilesDaysThreshold = ' + oldDailyTakingsFilesDaysThreshold);
					}
				}
				else
				{
					manageErrors(result, 91);
				}
			}
		};
		
		eposSET1525.send(xmlHTTPRequestURLPageLoad, dataToSend);
	}

	function requestSerialNumber()
	{
		var getFiscalSerialNumberNativeCommand = '3217';
		var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + getFiscalSerialNumberNativeCommand + '" data="' + currentOperatorNumberString + '" />\r\n' +
							'</printerCommand>\r\n';
		var eposSerial = new epson.fiscalPrint();
		eposSerial.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.responseData !== undefined)
				{
					var response_data = add_info.responseData;
					// 01000002EC99
					// 012345678901
					manufacturerCode = response_data.substr(10, 2);
					modelCode = response_data.substr(8, 2);
					serialNumerals = response_data.substr(2, 6);
					if (debugMode == true)
					{
						console.log('manufacturerCode = ' +  manufacturerCode);
						console.log('modelCode = ' + modelCode);
						console.log('serialNumerals = ' + serialNumerals);
					}
					requestRTStatus(true);					
				}
				else
				{
					manageErrors(result, 91);
				}
				
				if (add_info.printerStatus !== undefined)
				{
					managePrinterStatus(add_info.printerStatus);
				}
				else
				{
					manageErrors(result, 91);
				}
			}
		};
		
		eposSerial.send(xmlHTTPRequestURLPageLoad, dataToSend);
	}
	
	function readSET31()
	{
		var getEftposNativeCommand = '4231';
		var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + getEftposNativeCommand + '" comment="Leggere parametri EFT-POS" />\r\n' +
							'</printerCommand>\r\n';
		var eposSET31 = new epson.fiscalPrint();
		eposSET31.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.responseData !== undefined)
				{
					var response_data = add_info.responseData;
					try
					{
						eftposQueryStringTimeout = parseInt(response_data.substr(response_data.length - 7, 3), 10);
						eftposQueryStringTimeout =  eftposQueryStringTimeout * 1000;
						eftposPostTimeout = eftposQueryStringTimeout + defaultQueryStringTimeout;
					}
					catch (myEx)
					{						
					}
					if (debugMode == true)
					{
						console.log('responseData = ' +  response_data);
						console.log('eftposPostTimeout = ' + eftposPostTimeout);
						console.log('eftposQueryStringTimeout = ' + eftposQueryStringTimeout);						
					}
				}
				else
				{
					manageErrors(result, 91);
				}
			}
		};
		
		eposSET31.send(xmlHTTPRequestURLPageLoad, dataToSend);
	}
	
	function readAndStoreRetailHeader()
	{
		var getHeaderLineCommand = '3216';
		var maxRetries = 3;
		var retryCount = 0;
		var hl = 1;

		for (hl = 1; hl <= 16; hl++)
		{
			var eposHeader = new epson.fiscalPrint();
			eposHeader.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					if (retryCount <= maxRetries)
					{
						hl--;
						retryCount++;
					}
					else
					{
						retryCount = 0;
					}
				}
				else
				{
					if (add_info.responseData !== undefined)
					{
						retryCount = 0;
						//	<responseData>01   EPSON ITALIA                         </responseData>                                     </responseData>
						//				  xx1234567890123456789012345678901234567890
						var responseData = add_info.responseData;
						var headerRowNum = parseInt(responseData.substr(0, 2), 10);
						var headerText = responseData.substr(2);						
						if (debugMode == true)
						{
							console.log('headerRowNum = ' +  headerRowNum);
							console.log('headerText = ' + headerText);
						}
						// Esce se si trovano due righe consecutive bianche, per ottimizzare la rete.
						if (headerRowNum > 1)
						{
							var headerTextThisRowTrimmed = headerText.replace(/ /g, "");	// Togliere eventuali spazi.
							var headerTextLastRowTrimmed = retailHeaderArray[headerRowNum - 1].replace(/ /g, "");	// Togliere eventuali spazi.

							if (headerTextThisRowTrimmed == "" && headerTextLastRowTrimmed == "")
							{
								 retailHeaderArray.pop();
								 // break; // non va
								 hl = 17;
							}
							else
							{
								retailHeaderArray[headerRowNum] = headerText;
							}
						}
						else
						{
							retailHeaderArray[headerRowNum] = headerText;
						}
					}
					else if (retryCount <= maxRetries)
					{
						hl--;
						retryCount++;
					}
					else
					{
						retryCount = 0;
					}
				}
			};
			
			var headerRowNumString = hl.toString();
			if (hl < 10)
			{
				headerRowNumString = "0" + headerRowNumString;
			}
		 	var dataToSend = '<printerCommand>\r\n' +
								'\t<directIO  command="' + getHeaderLineCommand + '" data="' + headerRowNumString + '" />\r\n' +
								'</printerCommand>\r\n';			
			eposHeader.send(xmlHTTPRequestURLMain, dataToSend, "", "sync");
		}
	}
	
	function downloadPrinterPluDatabaseToBrowser()
	{
		var getPLUEntryNativeCommand = '4203';
		var maxRetries = 3;
		var retryCount = 0;
		var pe = 1;
		for (pe = 1; pe <= mainSettings.numeroPLUStampante; pe++)
		{
			var eposPLU = new epson.fiscalPrint();
			eposPLU.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false && retryCount <= maxRetries)
				{
					pe--;
					retryCount++;
				}
				else
				{
					if (add_info.responseData !== undefined)
					{
						retryCount = 0;
						//	PLU		<responseData>0001P.L.U.    1         00000012300000000000000000001                                        </responseData>
						// 	NO PLU	<responseData>0002P.L.U.    2         00000000000000000000000000000                                        </responseData>
						//						  012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012
						var response_data = add_info.responseData;
						var pluDesc = response_data.substr(4, 20);
						var pluUnitPrice = response_data.substr(24, 7) + "," + response_data.substr(31, 2);
						var pluDep = response_data.substr(51, 2);
						var pluBarcode = response_data.substr(53, 40);
						pluBarcode = pluBarcode.trim();
						if (debugMode == true)
						{
							console.log('pluDesc = ' +  pluDesc);
							console.log('pluUnitPrice = ' + pluUnitPrice);
							console.log('pluDep = ' + pluDep);
							console.log('pluBarcode = ' + pluBarcode);
						}
						pluArray.push([pe, pluDesc, pluUnitPrice, pluDep, pluBarcode]);				
					}
					else if (retryCount <= maxRetries)
					{
						pe--;
						retryCount++;
					}
				}
			};
			
			var pluNum = "000" + pe;
			pluNum = pluNum.substr(pluNum.length - 4);
		 	var dataToSend = '<printerCommand>\r\n' +
								'\t<directIO  command="' + getPLUEntryNativeCommand + '" data="' + pluNum + '" />\r\n' + 	// operator
								'</printerCommand>\r\n';			
			eposPLU.send(xmlHTTPRequestURLMain, dataToSend, pluPostTimeout, "sync");
		}
	}

	function uploadPLUDatabaseToPrinter()
	{
		/*
			Array =
				0 = PLU Number
				1 = Description
				2 = Unit Price
				3 = Deparment
				4 = Barcode
			*/
		var pluXMLFileSequenceNumber = 0;
		var maxEntriesPerUpload = 100; // Programmiamo in gruppi max 100.
		var dataToSend = '<printerCommands>\r\n';
		var paInd=0;
		for (paInd=0; paInd < pluArray.length; paInd++)
		{
			pluXMLFileSequenceNumber++;
			
			var pluNumber = "000" + pluArray[paInd][0];
			pluNumber = pluNumber.substr(pluNumber.length - 4);
			var pluDescription = pluArray[paInd][1] + "                    ";
			pluDescription = pluDescription.substr(0, 20);
			var pluUnitPrice = pluArray[paInd][2];
			if (pluUnitPrice.lastIndexOf(",") == -1) // Voce ha numero intero senza decimali.
			{
				pluUnitPrice += "00";
			}
			else // Voce ha decimali.
			{
				pluUnitPrice = pluUnitPrice.replace(/,/g, '');
			}
			pluUnitPrice = "000000000" + pluUnitPrice;
			pluUnitPrice = pluUnitPrice.substr(pluUnitPrice.length - 9);
			var pluDep = pluArray[paInd][3];
			if (pluDep.length == 1)
			{
				pluDep = "0" + pluDep;
			}
			var pluBarcode = pluArray[paInd][4] + "                                        ";
			pluBarcode = pluBarcode.substr(0, 40);
			var pluEntry = [ pluDescription, pluUnitPrice, pluDep, pluBarcode];

			dataToSend += ('\t<directIO  command="4003" data="' + pluNumber + pluDescription + pluUnitPrice + '000000000' + '000000000' + pluDep + pluBarcode + '" />\r\n');
			if (pluXMLFileSequenceNumber == maxEntriesPerUpload)
			{
				dataToSend += '</printerCommands>\r\n';
				sendToPrinter(dataToSend, false, true);
				// Preparare la prossima voce.
				dataToSend = '<printerCommands>\r\n';
				pluXMLFileSequenceNumber = 0;
			}
		}
		if (pluXMLFileSequenceNumber != 0)
		{
			dataToSend += '</printerCommands>\r\n';
			sendToPrinter(dataToSend, false, true);
		}
	}
	
	function manageEposDevice()
	{
		if (debugMode == true)
		{
			console.log('manageEposDevice');
		}
		var connCallback = function(code)
		{
			if (debugMode == true)
			{
				console.log('manageEposDevice --> connCallback');
			}
	        if (code == "close")
	        {
				if (debugMode == true)
				{
					console.log('ePOS Device connection closed.');
				}
				return;
	        }
	        var createDeviceCallback = function(driverObj, code)
	        {
	            if (debugMode == true)
				{
					console.log('manageEposDevice --> createDeviceCallback. code = ' + code );
				}
	        	if (code == "OK")
	        	{
	        		if (mainSettings.tipoConnessione == "Multipla")
	        		{
	        			display.trigger('virtualPrinterDisplay:set_row2_to', ["CANALE USB  CONNESSO"]);
	        		}
	        	}
	        	else
	        	{
					setTimeout(manageEposDevice(), 2000);
	        		if (debugMode == true)
					{
						console.log('ePOS Device disconnecting...');
					}
	        		eposDevice.disconnect();
	        		return;
	        	}
	            // add the method to the driver object to handle device data
	            driverObj.ondata = function (data)
	            {
	            	if (debugMode == true)
					{
						console.log("type = " + data.type +
		            			    "  data1 = " + data.data1 +
		            			    "  data2 = " + data.data2 +
		            			    "  data3 = " + data.data3 +
		            			    "  data4 = " + data.data4);
		            }
	                var scanCodeChar;
	                if (isNaN(data.data4))
	                {
	                	if (debugMode == true)
						{
							console.log("ePOS Device data received is not a number.");
						}
	                }
	                else
	                {
	                	if (data.data2 == 1)
	                	{
							scanCodeChar = tab_scan_code_upper_case[data.data4];
							if (debugMode == true)
							{
								console.log("ePOS Device received data indicated that shift key was pressed. Scan code = " + scanCodeChar);
							}
						}
						else
						{
	                    	scanCodeChar = tab_scan_code_lower_case[data.data4];
	                    	if (debugMode == true)
							{
								console.log("ePOS Device received data indicated that shift key was not pressed. Scan code = " + scanCodeChar);
							}
						}
						if (scanCodeChar == TENTER)
						{
	        				if (debugMode == true)
							{
								console.log("CR");
		        				console.log('ePOSDeviceString = ' + ePOSDeviceString);
		        				console.log('Lunghezza ePOSDeviceString = ' + ePOSDeviceString.length);

		        			}
	        				// alert(ePOSDeviceString);
	        				checkEposDeviceString(ePOSDeviceString);
	        				ePOSDeviceString = "";
						}
						else if (scanCodeChar == TCL)
						{
							eposDevice.disconnect();
							display.trigger('virtualPrinterDisplay:set_row2_to', ["CANALE USB SCONNESSO"]);
						}
						else
						{
							ePOSDeviceString += scanCodeChar;
						}
	                }
	            };
	            
	        };
	        
	        eposDevice.createDevice("local_scanner", "type_scanner", false, createDeviceCallback);
	    };
	    
	    eposDevice.connect(mainSettings.printerIPAddress, webSocketTCPPort, connCallback);
	}

	function checkEposDeviceString(stringScanned)
	{
		if (verifyCodiceFiscale(stringScanned, false) == true)
		{
			sendCodiceFiscale(stringScanned);
		}
		else
		{
			manageForms("codici", "webSocket", stringScanned);
			return;

			/*
			var numTries = 3;
			var attemptNum = 1;
			for (attemptNum = 1; attemptNum <= numTries; attemptNum++)
			{
				var stringType = prompt("Per cortesia indicare il tipo. Digitare Lotteria, PLU o P.IVA", "Lotteria");
				if (stringType.toLowerCase() == "lotteria")
				{
					attemptNum = numTries;
					manageLotteryCode(stringScanned);					
				}
				else if (stringType.toLowerCase() == "plu")
				{
					
				}
				else if (stringType.toLowerCase() == "p.iva")
				{
					attemptNum = numTries;
					managePartitaIVA(stringScanned);
				}
				else
				{
					if (attemptNum == numTries)
					{
						alert("Max tentavi esausti. Eventualmente, rifare la lettura.");
					}					
				}
			}
			*/
		}
	}
	
	function updateSubtotal()
	{
		var newSubtotal = (receiptTotalCalculatedInternally / 100).toFixed(2);
		newSubtotal = newSubtotal.replace('.',',');
		var newSubtotalLine = addRowPrefix + '&nbsp;' + 'SUBTOTALE' + '&nbsp;&euro;' + newSubtotal;
		var maxChars = 26; // Max chars sulla riga. Dobbiamo considerare l'orientamento portrait.
		var lengthCorrection = 15; // per prendere in considerazione l'escaping &nbsp; &nbsp;&euro;
		maxChars += lengthCorrection;
		if (newSubtotalLine.length > maxChars)
		{
			newSubtotalLine = addRowPrefix + '&nbsp;' + 'SUBT.' + '&nbsp;&euro;' + newSubtotal;
		}
		if (newSubtotalLine.length > maxChars)
		{
			var arpl = addRowPrefix.length - 2;
			while (newSubtotalLine.length > maxChars && arpl > 0)	// arpl > 0 è solo una protezione contro un loop infinito.
			{
				newSubtotalLine = addRowPrefix.substr(0, arpl) + '.' + '&nbsp;' + 'SUBT.' + '&nbsp;&euro;' + newSubtotal;
				arpl--;
			}
		}
		rowInfo.html(newSubtotalLine);		
	}
	
	function updateTotal()
	{
		var docTotal = (receiptTotalCalculatedInternally / 100).toFixed(2);
		if (docTotal.length > 8)
		{
			docTotal = 'TOT. DOCUMENTO &euro;' + docTotal.replace('.',',');
		}
		else
		{
			docTotal = 'TOTALE DOCUMENTO &euro;' + docTotal.replace('.',',');
		}
		rowInfo.html(docTotal);
	}
	
	function managePluBarcode(pluBarcode)
	{
		var pluFound = false;
		/*
		Array =
			0 = PLU Number
			1 = Description
			2 = Unit Price
			3 = Deparment
			4 = Barcode
		*/
		var paInd=0;
		for (paInd=0; paInd < pluArray.length; paInd++)
		{
			if (pluArray[paInd][4] == pluBarcode)
			{
				pluFound = true;
				var uPriceToSend = "";
				var uPrice1 = pluArray[paInd][2].replace(/\./g, '');
				var uPrice2 = uPrice1.split(',');
				if (uPrice2.length == 1)	// No decimal separator
				{
					uPriceToSend = uPrice1 + "00";
				}
				else
				{
					uPriceToSend = uPrice2[0] + uPrice2[1].substr(0, 2);	// Ignore possibile third decimaal onwards.
				}
				display.trigger('virtualPrinterDisplay:set_row2_to', [pluArray[paInd][1]]);
				addSaleStorno(uPriceToSend, pluArray[paInd][3], pluArray[paInd][1], stornoPressed);
				break;
			}
		}
		if (pluFound == false)
		{
			if (mainSettings.databasePLU == "1")
			{
				alert("Barcode " + pluBarcode + " non trovato nel database xml/PLU.xml.");
			}
			else
			{
				if (mainSettings.downloadPLU == true)
				{
					alert("Barcode " + pluBarcode + " non trovato nel database della stampante (fino al numero PLU " + mainSettings.numeroPLUStampante + ").");
				}
				else
				{
					alert("Non è stata abilitata la gestione di un database PLU nel file Settings.xml.");
				}
			}
			
		}
	}
	
	function verifyCodiceFiscale(CFString, showAlerts)
	{
		var cfMatch = false;
		// CFString = "ABCDEF12G34H567I";	// Bad checksum
		// CFString = "ABCDEF12G34H567S";	// Good checksum
		if (CFString.length == 16)
		{
			// Controlliamo la struttura.
			var myPattern = /[A-Z]{6}[0-9]{2}[A-Z]{1}[0-9]{2}[A-Z]{1}/g;
			cfMatch = myPattern.test(CFString);
			if (cfMatch == false && showAlerts == true)
			{
				alert("Il formato del Codice Fiscale è erroneo!");
			}
		}
		else if (showAlerts == true)
		{
			alert ("Codice Fiscale deve essere 16 caratteri!");
		}
		return cfMatch;
	}
		
	function sendCodiceFiscale(CFString)
	{
		// Invia Codice Fiscale
		var directIOLine = '\t<directIO  command="1061" data="' + currentOperatorNumberString + CFString + '" />\r\n';
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var dataToSend = '<printerCommand>\r\n' +
							directIOLine +
							'</printerCommand>\r\n';
			var eposCF = new epson.fiscalPrint();
			eposCF.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				display.trigger('virtualPrinterDisplay:blank', []);
				if (result.success == false)
				{
					manageErrors(result, 91);
					needClear = true;
				}
				else
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [CFString + "  OK"]);
					needClear = false;
				}
			};
			
			eposCF.onerror = function (result)
			{
				manageErrors(result, 90);
			};
			
			eposCF.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else	// Casse multipla. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// Codice Fiscale
			}
			bodyXML += directIOLine;
			display.trigger('virtualPrinterDisplay:set_row2_to', [CFString + "  OK"]);
		}
	}
	
	function managePartitaIVA(codeString)
	{
		if (codeString.substr(0, 2).toUpperCase() == "IT")
		{
			codeString = codeString.substr(2);
		}
		var piMatch = false;
		// "12345678901";	// Bad checksum
		// "12345678903";	// Good checksum
		
		if (codeString.length != 11)
		{
			alert ("Partita IVA deve essere 11 numeri con o senza \"IT\" prefisso!");
			return false;
		}
		
		// Controlliamo la struttura.
		var myPattern = /[0-9]{11}/g;					
		piMatch = myPattern.test(codeString);
		if (piMatch == false)
		{
			alert("Il formato della Partita IVA è erroneo!");
			return false;
		}
		
		if (mainSettings.demoMode == false)
		{
			sendPartitaIVA(codeString);
		}
		else
		{
			display.trigger('virtualPrinterDisplay:set_row2_to', [codeString + "  OK"]);
		}
		return true;		
	}
	
	function sendPartitaIVA(PIVAString)
	{
		// Invia Partita IVA
		var directIOLine = '\t<directIO  command="1060" data="' + currentOperatorNumberString + PIVAString + '" />\r\n';
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var dataToSend = '<printerCommand>\r\n' +
								directIOLine +
								'</printerCommand>\r\n';
			var eposPI = new epson.fiscalPrint();
			eposPI.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				display.trigger('virtualPrinterDisplay:blank', []);
				if (result.success == false)
				{
					manageErrors(result, 91);
					needClear = true;
				}
				else
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [PIVAString + "  OK"]);
					needClear = false;
				}
			};
			
			eposPI.onerror = function (result)
			{
				manageErrors(result, 90);
			};
	
			eposPI.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else	// Casse multipla. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// Partita IVA
			}
			bodyXML += directIOLine;
			display.trigger('virtualPrinterDisplay:set_row2_to', [PIVAString + "  OK"]);
		}
	}
	
	function manageLotteryCode(codeString)
	{
		var lcMatch = false;
		// "ABCDEFGA"	// Bad checksum
		// "ABCDEFGN"	// Good checksum
		if (codeString.length < 2 || codeString.length > 16)
		{
			alert ("Codice lotteria deve essere fra 2 a 16 caratteri!");
			return false;
		}
		
		// Controlliamo la struttura.
		var myPattern = /[A-Z0-9]+$/g;
		lcMatch = myPattern.test(codeString);
		if (lcMatch == false)
		{
			alert("Il formato del codice lotteria è erroneo!");
			return false;
		}
		if (mainSettings.demoMode == false)
		{
			sendLotteryCode(codeString);
		}
		else
		{
			display.trigger('virtualPrinterDisplay:set_row2_to', [codeString + "  OK"]);
		}
		return true;
	}
	
	function sendLotteryCode(lotteryCode)
	{
		// Invia codice lotteria
		var	lotteryCodePadded = lotteryCode + "              ";
		lotteryCodePadded = lotteryCodePadded.substr(0, 16);
		var directIOLine = '\t<directIO  command="1135" data="' + currentOperatorNumberString + lotteryCodePadded + '0000' + '" />\r\n';
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var dataToSend = '<printerCommand>\r\n' +
							directIOLine +
							'</printerCommand>\r\n';
			var eposLC = new epson.fiscalPrint();
			eposLC.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				display.trigger('virtualPrinterDisplay:blank', []);
				if (result.success == false)
				{
					manageErrors(result, 91);
					needClear = true;
				}
				else
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [lotteryCode + "  OK"]);
					needClear = false;
				}
			};
			
			eposLC.onerror = function (result)
			{
				manageErrors(result, 90);
			};
	
			eposLC.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else	// Casse multipla. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// Lotteria
			}
			bodyXML += directIOLine;
			display.trigger('virtualPrinterDisplay:set_row2_to', [lotteryCode + "  OK"]);
		}		
	}
	
	function managePrinterStatus(printerStatus)
	{
		if (printerStatus.substr(0, 1) == "2")
		{
			alert("Carta in esaurimento.");
		}
	}
	
	function manageEftpos(amount)
	{
		eftposInProgress = true;
		if (mainSettings.demoMode == true)
		{
			if (parseInt(amount, 10) == 0)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousValueText]);
				eftposInProgress = false;
				needClear = true;
			}
			else
			{
				display.trigger('virtualPrinterDisplay:set_row1_to', [eftposInProgRow1Text]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [eftposInProgRow2Text]);
				setTimeout(function()
				{
					eftposInProgress = false;
					alert("Simulazione pagamento mediante POS effettuato.");
					resetDisplayAndVariables();
				}, 10000);
			}
			return;
		}
		
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var dataToSend = '<printerCommand>\r\n' +
							'\t<queryPrinterStatus  operator="' + currentOperatorNumberString + '" statusType="0" />\r\n' +
							'</printerCommand>\r\n'; // statusType="0" = comando nativo 1074.
			var eposStatus = new epson.fiscalPrint();
			eposStatus.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				eftposInProgress = false;
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					if (add_info.fpStatus != undefined)
					{
						if (debugMode == true)
						{
							console.log('fpStatus = ' + add_info.fpStatus);
						}
						if (add_info.fpStatus.substr(0, 1) == "3")
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [offlineText]);
							alert (offlineAlertText);
							needClear = true;
						}
						else if (add_info.fpStatus.substr(3, 1) != "1")
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousSequenceText]);
							alert ("Documento aperto.");
							needClear = true;
						}
						else if (add_info.fpStatus.substr(4, 1) != "0")
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
							needClear = true;
						}
						else
						{
							sendAuthorizeSales(amount);
						}
					}
					else
					{
						manageErrors(result, 91);
					}				
				}
			};
			eposStatus.onerror = function (result)
			{
				eftposInProgress = false;
				manageErrors(result, 90);
			};
			eposStatus.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else //  mainSettings.tipoConnessione == "Multipla"
		{
			sendAuthorizeSales(amount);
		}
	}

	function sendAuthorizeSales(amount)
	{
		if (mainSettings.tipoConnessione == "Multipla" && mainSettings.operatori == "0")
		{
			setCurrentTillNumberOnPrinter();
		}
		
		eftposInProgress = true;
		var onErrorCount = 0;
		amount = amount.substr(0, amount.length - 2) + "," + amount.substr(amount.length - 2);
		var dataToSend = '<printerCommand>\r\n' +
							'\t<authorizeSales  operator="' + currentOperatorNumberString + '" amount="' + amount + '" />\r\n' +
							'</printerCommand>\r\n';
		var eposEftpos = new epson.fiscalPrint();
		eposEftpos.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			eftposInProgress = false;
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
		};
		
		eposEftpos.onerror = function (result)
		{
			eftposInProgress = false;
			onErrorCount++;
			if (onErrorCount == 1) // Ignoriamo eventi onError multipli.
			{	
				manageErrors(result, 90);
			}
		};

		display.trigger('virtualPrinterDisplay:set_row1_to', [eftposInProgRow1Text]);
		display.trigger('virtualPrinterDisplay:set_row2_to', [eftposInProgRow2Text]);
		
		try
		{
			eposEftpos.send(xmlHTTPRequestURLEftpos, dataToSend, eftposPostTimeout);	
		}
		catch (myEx)
		{
			eftposInProgress = false;
			console.log(myEx.message);
			alert(myEx.message);
		}	
	}
	
	function requestRTStatus(pageLoadInProgress)
	{
		var dataToSend = '<printerCommand>\r\n' +
							'\t<queryPrinterStatus  operator="' + currentOperatorNumberString + '" statusType="1" />\r\n' +
							'</printerCommand>\r\n'; // statusType="1" = comando nativo 1138.
		var eposRTStatus = new epson.fiscalPrint();
		eposRTStatus.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.rtType != undefined)
				{
					var rtDeviceType = add_info.rtType;
					fiscalSerialNumber = manufacturerCode + rtDeviceType + modelCode + serialNumerals;
					if (debugMode == true)
					{
						console.log('fiscalSerialNumber = ' + fiscalSerialNumber);
					}
				}
				else
				{
					manageErrors(result, 91);
				}
				
				if (add_info.rtNoWorkingPeriod != undefined)
				{
					if (add_info.rtNoWorkingPeriod == "1")
					{
						if (confirm('La stampante si trova nella condizione:\r\n' +
									'"PERIODO INATTIVO ESEGUIRE CHIUSURA".\r\n' +
									'Finché non viene effettuata una chiusura fiscale giornaliera, la stampante rimane fuori servizio. Vuoi farla adesso???') == true)
						{
							manageZReport();
						}
					}
				}
				else
				{
					manageErrors(result, 91);
				}

				if (add_info.rtOldFileToSend != undefined)
				{
					try
					{
						var oldFiles = parseInt(add_info.rtOldFileToSend, 10);						
						if (oldFiles > 0)
						{
							var myWarningText = "C'è " + oldFiles + " file di chiusura giornaliera non ancora trasmesso";
							if (oldFiles > 1)
							{
								myWarningText = "Ci sono " + oldFiles + " file di chiusure giornaliere non ancora trasmessi";
							}
							myWarningText += " da più di " + oldDailyTakingsFilesDaysThreshold + " ";
							if (oldDailyTakingsFilesDaysThreshold == 1)
							{
								myWarningText += "giorno";
							}
							else
							{
								myWarningText += "giorni";
							}
							myWarningText += (".\r\n" + 
											"Per cortesia verificare la rete e l'accesso ad Internet.");
							alert(myWarningText);
						}
					}
					catch (myEx)
					{
					}
				}
				else
				{
					manageErrors(result, 91);
				}
			}
		};
		
		if (pageLoadInProgress == true)
		{
			eposRTStatus.send(xmlHTTPRequestURLPageLoad, dataToSend, pageLoadTimeout);
		}
		else
		{
			eposRTStatus.send(xmlHTTPRequestURLMain, dataToSend);
		}
	}

	function addSaleStorno(unitPrice, department, description, storno)
	{
		// var dataToSend = '<printRecItem operator="' + currentOperatorNumberString + '" description="' + description + '" quantity="1" unitPrice="' + price + '" department="' + department + '" justification="1" />';
		if (debugMode == true)
		{
			console.log('addSaleStorno input =:');
			console.log('    unitPrice = ' + unitPrice + ' quantity = ' + quantity + ' department = ' + department + ' description = ' + description);
		}
		var saleStornoAmount = Math.round(parseInt(unitPrice, 10) * (parseInt(quantity, 10) / 1000));	// saleStornoAmount in centesimi.
		// lastPluUnitPrice = '';
		// lastPluDepartment = '';
		// lastPluDescription = '';
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var saleNativeCommand = '1080';		
			var stornoNativeCommand = '1082';
			var nativeCommand = '';
			var onErrorCount = 0;
			if (storno == false)
			{
				nativeCommand = saleNativeCommand;
			}
			else
			{
				nativeCommand = stornoNativeCommand;
			}
			unitPrice = pad(unitPrice, 9, '0');
			quantity  = pad(quantity , 7, '0');
			department = pad(department , 2, '0');		
	
			/* see manual "Communication Protocol Operazioni Light */
			var dataToSend = '<printerCommand>\r\n' +
								'\t<directIO  command="' + nativeCommand + '" data="' + currentOperatorNumberString +	// operator
								description +
								quantity +
								unitPrice + 
								department + 
								'1"' +	// Display left alignment.
								' timeout="' + directIOTimeout + '"' +
								' />\r\n' + 
								'</printerCommand>\r\n';
			quantity = defaultQuantity1;
			
			var eposSaleStorno = new epson.fiscalPrint();
			eposSaleStorno.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					addSaleStornoSuccessTrue(storno, saleStornoAmount);
					if (storno == true)
					{
						scontrinoCortesiaArray.push(sconCortStornoTextEsc);
					}
					scontrinoCortesiaArray.push(description);
				}
			};
			
			eposSaleStorno.onerror = function (result)
			{
				onErrorCount++;
				if (onErrorCount == 1) // Ignoriamo eventi onError multipli (possono verificarsi quando timeout ! = 0. Due eventi in fiscalprint.js.
				{
					manageErrors(result, 90);
				}
			};
			// alert (xml);
			
			if (mainSettings.demoMode == false)
			{	try
				{
					eposSaleStorno.send(xmlHTTPRequestURLMain, dataToSend, defaultPostTimeout);
				}
				catch (myEx)
				{
					console.log(myEx.message);
					alert(myEx.message);
				}
			}
			else
			{
				addSaleStornoSuccessTrue(storno, saleStornoAmount);	// Demo mode
			}
		}
		else	//  Casse multipla. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// addSaleStorno
			}
			somethingToVoid = true;
			var saleCommandTag = 'printRecItem';
			var stornoCommandTag = 'printRecItemVoid';
			var commandTag = '';
			if (storno == false)
			{
				commandTag = saleCommandTag;
				receiptTotalCalculatedInternally += saleStornoAmount;
				lastTransactionAmount = saleStornoAmount;				
			}
			else
			{
				commandTag = stornoCommandTag;
				receiptTotalCalculatedInternally -= saleStornoAmount;
				lastTransactionAmount = -saleStornoAmount;
			}
			lastSaleStornoAmount = lastTransactionAmount;
			display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [saleStornoAmount, '', false]);
			if (debugMode == true)
			{
				console.log('receiptTotalCalculatedInternally = ' + receiptTotalCalculatedInternally);
			}
			updateSubtotal();
			
			unitPrice = unitPrice.substr(0, unitPrice.length - 2) + "," + unitPrice.substr(unitPrice.length - 2);
			if (quantity == defaultQuantity1)
			{
				quantity = "1";
			}
			else
			{
				quantity = quantity.substr(0, quantity.length - 3) + "," + quantity.substr(quantity.length - 3);
			}	
			bodyXML += '\t<' + commandTag + '  operator="' + currentOperatorNumberString + '" ' +
						'description="' + description + '" ' +
						'quantity="' + quantity + '" ' +
						'unitPrice="' + unitPrice + '" ' +
						'department="' + department + '" ' +
						'justification="1" />\r\n';			
			if (debugMode == true)
			{
				console.log('bodyXML = ' + bodyXML);
			}
			quantity = defaultQuantity1;
			if (storno == true)
			{
				scontrinoCortesiaArray.push(sconCortStornoTextEsc);
			}
			scontrinoCortesiaArray.push(description);
		}
	}
	
	function addSaleStornoSuccessTrue(storno, saleStornoAmount)
	{
		docOpen = true;	// addSaleStorno
		somethingToVoid = true;
		if (debugMode == true)
		{
			console.log('stornoPressed = ' + stornoPressed + ' storno = ' + storno);
		}
		// Don't use stornoPressed because it is reset before the XMLHTTP reply arrives.
		if (storno == false)
		{
			receiptTotalCalculatedInternally += saleStornoAmount;
			lastTransactionAmount = saleStornoAmount;						
		}
		else
		{
			receiptTotalCalculatedInternally -= saleStornoAmount;
			lastTransactionAmount = -saleStornoAmount;
		}
		display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [saleStornoAmount, '', false]);
		if (debugMode == true)
		{
			console.log('receiptTotalCalculatedInternally = ' + receiptTotalCalculatedInternally);
		}
		updateSubtotal();
	}
	
	function clearPrinterDisplay()
	{
		var dataToSend = '<printerCommand>\r\n' +
							'\t<displayText  operator="' + currentOperatorNumberString + '" data="€               0,00' + registrationStateText + '" />\r\n' +
							'</printerCommand>\r\n';
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}
	
	function resetDisplayAndVariables()
	{
		display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
		display.trigger('virtualPrinterDisplay:set_row2_to', [registrationStateText]);
		resetPrincipalVariables();
		quantityDecimalsInProgress = false;
		quantity = defaultQuantity1;
		stornoPressed = false;
		genericDepartmentStep = 1;
		// lastTransactionAmount = 0;
	}
	
	function resetPrincipalVariables()
	{
		acceptNewNumericInput = true;
		anyNumKeyWasPressed = false;
		subtotalPressed = false;
		stornoPressed = false;
		commaKeyAllowed = true;
		currentQuantityDecimal = 0;
		eftposInProgress = false;
	}
	
	function manageForms(buttonFunction, calledBy, webSocketString)
	{
		if (docResoAnnulloOpeningInProgress == true)
		{
			display.trigger('virtualPrinterDisplay:blank', []);
			display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
			needClear = true;
			return;
		}
		
		if (partialPaymentsInProgress == true)
		{
			display.trigger('virtualPrinterDisplay:blank', []);
			display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
			needClear = true;
			return;
		}

		if (buttonFunction.toLowerCase() == "codici")
		{
			if (calledBy == "webSocket")
			{
				$('#codFiscButton ').css('display', 'none');
				document.getElementById('codeString').value = webSocketString;
			}
			else
			{
				$('#codFiscButton ').css('display', '');
			}			
			$('.codesFormClass').css('display', 'block');
			codesFormOpen = true;
			document.getElementById('codeString').focus();
		}
		else if (buttonFunction.toLowerCase() == "descrizione")
		{
			$('.descriptionFormClass').css('display', 'block');
			extendedDescriptionFormOpen = true;
			document.getElementById('extendedDescriptionTextArea1').focus();
		}
		else	// descrizione e vendita
		{
			$('.descriptionAndSaleFormClass').css('display', 'block');
			extendedDescriptionAndSaleFormOpen = true;
			document.getElementById('extendedDescriptionTextArea2').focus();
		}								
		$('.landscape').css('display', 'none');
		$('.portrait').css('display', 'none');
	}
	
	function manageDocResoAnnullo(buttonFunction, buttonText)
	{
		if (buttonFunction.toLowerCase() == 'reso' || buttonFunction.toLowerCase() == 'annullo')
		{
			resoAnnulloButtonText = buttonText;
			docResoAnnulloStep = 1;	// Matricola.
			resoAnnulloFiscalSerialNumber = fiscalSerialNumber;
			display.trigger('virtualPrinterDisplay:set_row1_serial_to', []);
			display.trigger('virtualPrinterDisplay:set_row2_to', [fiscalSerialNumberText]);
		}
		else if (buttonFunction.toLowerCase() == 'x')
		{
			if (debugMode == true)
			{
				console.log('docResoAnnulloStep = ' + docResoAnnulloStep);
			}
			if (docResoAnnulloStep == 1)
			{
				// Cycle through MEX, MEY, SEA, IEB ed IEC.
				var currentRtTypeModel = resoAnnulloFiscalSerialNumber.substr(2, 3);
				if (debugMode == true)
				{
					console.log('currentRtTypeModel = ' + currentRtTypeModel);
				}
				var nextRtTypeModel = '';
				switch (currentRtTypeModel)
				{
					case 'MEX':
						nextRtTypeModel = 'MEY';
						break;
					case 'MEY':
						nextRtTypeModel = 'SEA';
						break;
					case 'SEA':
						nextRtTypeModel = 'IEB';
						break;
					case 'IEB':
						nextRtTypeModel = 'IEC';
						break;
					case 'IEC':
						nextRtTypeModel = 'MEX';
						break;
					default:
						nextRtTypeModel = currentRtTypeModel;
				}
				resoAnnulloFiscalSerialNumber = resoAnnulloFiscalSerialNumber.substr(0, 2) + nextRtTypeModel + resoAnnulloFiscalSerialNumber.substr(5, 6);
				display.trigger('virtualPrinterDisplay:set_row1_serial_to', []);
			}
			else
			{
				display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
				needClear = true;
			}
		}
		else if (isNaN(buttonFunction) == false)
		{
			if (debugMode == true)
			{
				console.log('numeric');
			}
			if (docResoAnnulloStep == 1)	// Matricola
			{
				resoAnnulloFiscalSerialNumber = resoAnnulloFiscalSerialNumber.substr(0, 5) +
												resoAnnulloFiscalSerialNumber.substr(6, 6) +
				 								buttonFunction;
				 display.trigger('virtualPrinterDisplay:set_row1_serial_to', []);
			}
			else if (docResoAnnulloStep == 2) // Date
			{
				// resoAnnulloDate contains hyphens.
				switch (datePosition)
				{
					case 1:	// ad es. 00-00-00 con tasto 1 diviene 01-00-00 oppure 12-34-56 con tasto 7 diviene 27-34-56
					case 2:	// ad es. 01-00-00 con tasto 2 diviene 12-00-00
						resoAnnulloDate = resoAnnulloDate.substr(1, 1) + buttonFunction + resoAnnulloDate.substr(2);
						break;
					case 3:	// ad es. 12-00-00 con tasto 3 diviene 12-03-00
					case 4:	// ad es. 12-03-00 con tasto 4 diviene 12-34-00
						resoAnnulloDate = resoAnnulloDate.substr(0, 3) + resoAnnulloDate.substr(4, 1) + buttonFunction + resoAnnulloDate.substr(5);
						break;
					case 5:	// ad es. 12-34-01 con tasto 5 diviene 12-34-15
					case 6:	// ad es. 12-34-05 con tasto 6 diviene 12-34-56
						resoAnnulloDate = resoAnnulloDate.substr(0, 6) + resoAnnulloDate.substr(7, 1) + buttonFunction;
						break;

					default:
				}
				datePosition++;
				if (datePosition == 7)
				{
					datePosition = 1;
				}
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDate]);
			}
			else if (docResoAnnulloStep == 3)	// Numero documento
			{
				resoAnnulloDocNum = resoAnnulloDocNum.substr(1, 3) + buttonFunction;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDocNum]);
			}
			else if (docResoAnnulloStep == 4)	// Numero chiusura
			{
				resoAnnulloZNum = resoAnnulloZNum.substr(1, 3) + buttonFunction;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloZNum]);
			}			 
		}
		else if (buttonFunction.toLowerCase() == 'cl clear' || buttonFunction.toLowerCase() == 'cl' || buttonFunction.toLowerCase() == 'clear')
		{
			if (docResoAnnulloStep == 1)	// Matricola
			{
				resoAnnulloFiscalSerialNumber = resoAnnulloFiscalSerialNumber.substr(0, 5) + '000000';
				display.trigger('virtualPrinterDisplay:set_row1_serial_to', []);
				display.trigger('virtualPrinterDisplay:set_row2_to', [fiscalSerialNumberText]);
			}
			else if (docResoAnnulloStep == 2)	// Date
			{
				resoAnnulloDate = zeroDateText;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDate]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [dateText]);
				datePosition = 1;
			}
			else if (docResoAnnulloStep == 3)	// Document number
			{
				resoAnnulloDocNum = zeroDocZText;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDocNum]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [documentNumberText]);
			}
			else if (docResoAnnulloStep == 4)	// Closure Number
			{
				resoAnnulloZNum = zeroDocZText;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloZNum]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [closureNumberText]);
			}

		}
		else if (buttonFunction.toLowerCase() == 'contante')
		{
			if (docResoAnnulloStep == 2)	// Date
			{
				resoAnnulloDate = zeroDateText;
				display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDate]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [dateText]);
				datePosition = 1;
			}
			else if (docResoAnnulloStep == 3)	// Numero documento
			{
				if (resoAnnulloDate == zeroDateText)
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [nonExistentDataText]);
					docResoAnnulloStep--;
					needClear = true;
				}
				else if (checkDateCongruence() == false)
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousDateText]);
					docResoAnnulloStep--;
					needClear = true;
				}
				else
				{
					resoAnnulloDocNum = zeroDocZText;
					display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloDocNum]);
					display.trigger('virtualPrinterDisplay:set_row2_to', [documentNumberText]);
				}
			}
			else if (docResoAnnulloStep == 4)	// Numero chiusura
			{
				if (resoAnnulloDocNum == zeroDocZText)
				{
					display.trigger('virtualPrinterDisplay:set_row2_to', [nonExistentDataText]);
					docResoAnnulloStep--;
					needClear = true;
				}
				else
				{
					resoAnnulloZNum = zeroDocZText;
					display.trigger('virtualPrinterDisplay:set_row1_Z91_to', [resoAnnulloZNum]);
					display.trigger('virtualPrinterDisplay:set_row2_to', [closureNumberText]);
				}
			}
			else if (docResoAnnulloStep == 5)
			{
				docResoAnnulloStep--;
				// display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
				// needClear = true;
				alert("Premere " + resoAnnulloButtonText);
			}
		}
	}
	
	function sendScontoMaggVal(buttonFunction, buttonText, amount, type)
	{
		if (debugMode == true)
		{
			console.log('sendScontoMaggVal =:');
			console.log('    buttonFunction = ' + buttonFunction + ' buttonText = ' + buttonText + ' type = ' + type);
		}
		
		if (mainSettings.tipoConnessione == "Dedicata")
		{
		
			amount= pad(amount, 9, '0');
			
			var dataToSend = '<printerCommand>\r\n' +
								'\t<directIO  command="1083" data="' + currentOperatorNumberString +	// Operator.
								buttonText +	// Description.
								amount +
								type.toString() + 		// One of eight types.
								'01' +		// Department (not important for our cases).
								'1"' +		// Left display justification.
								' timeout="' + directIOTimeout + '"' +
								' />\r\n' +
								'</printerCommand>\r\n';

			var eposScontoMaggVal = new epson.fiscalPrint();
			eposScontoMaggVal.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					docOpen = true;	// sendScontoMaggVal
					somethingToVoid = true;
					updateDiscMagg(type, amount);
					updateSubtotal();
				}
			};

			eposScontoMaggVal.onerror = function (result)
			{
				manageErrors(result, 90);
			};

			// alert (xml);
			if (mainSettings.demoMode == false)
			{
				try
				{
					eposScontoMaggVal.send(xmlHTTPRequestURLMain, dataToSend);
				}
				catch (myEx)
				{
					console.log(myEx.message);
					alert(myEx.message);
				}
			}
			else
			{
				docOpen = true;	// sendScontoMaggVal
				somethingToVoid = true;
				updateDiscMagg(type, amount);
				updateSubtotal();
			}
		}
		else	// Casse multipla. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// sendScontoMaggVal
			}
			somethingToVoid = true;
			var itemDiscountSurchargeCommandTag = 'printRecItemAdjustment';
			var subtotalDiscountSurchargeCommandTag = 'printRecSubtotalAdjustment';
			var commandTag = '';
			if (type == 0 || type == 3 || type == 5 || type == 8)
			{
				commandTag = itemDiscountSurchargeCommandTag;
			}
			else
			{
				commandTag = subtotalDiscountSurchargeCommandTag;
			}
			updateDiscMagg(type, amount);
			updateSubtotal();
			amount = amount.substr(0, amount.length - 2) + "," + amount.substr(amount.length - 2);

			bodyXML += '\t<' + commandTag + '  operator="' + currentOperatorNumberString + '" ' +
						'adjustmentType="' + type + '" ' +
						'description="' + buttonText + '" ' +
						'amount="' + amount + '" ' +
						'department="1" ' +
						'justification="1" />\r\n';			
			if (debugMode == true)
			{
				console.log('bodyXML = ' + bodyXML);
			}
		}
	}
	
	function updateDiscMagg(type, amount)
	{
		if (type <= 3)	// Sconti
		{
			receiptTotalCalculatedInternally -= parseInt(amount, 10);
			lastTransactionAmount = -parseInt(amount, 10);
		}
		else // Maggiorazioni
		{
			receiptTotalCalculatedInternally += parseInt(amount, 10);
			lastTransactionAmount = parseInt(amount, 10);
		}
		if (subtotalPressed == false)
		{
			lastSaleStornoAmount += lastTransactionAmount;
		}
		if (debugMode == true)
		{
			console.log('receiptTotalCalculatedInternally = ' + receiptTotalCalculatedInternally + ". lastTransactionAmount = " + lastTransactionAmount);
		}
		
		if (type == 0)
		{
			display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [amount, '', true]);
			display.trigger('virtualPrinterDisplay:set_row2_to', [discountText]);
		}
		else if (type == 1 || type == 6)
		{
			display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', true]);
			display.trigger('virtualPrinterDisplay:set_row2_to', [subtotalText]);
		}
		else if (type == 5)
		{
			display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [amount, '', true]);
			display.trigger('virtualPrinterDisplay:set_row2_to', [surchargeText]);
		}
	}
	
	function setBodyXMLHeader()
	{ 
		if (mainSettings.operatori == "1")
		{
			bodyXML = '\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n';
			// Mettiamo STAMPA OPERATORE off sui doc commericali per affrontare crash con codice fiscale.			 				
			// La stessa stampa facciamo mediante trailer line tipo 2.
		}
		else
		{
			bodyXML = compileCurrentTillNumberDirectIOLine();
		}
		bodyXML += 	'\t<beginFiscalReceipt  operator="' + currentOperatorNumberString + '" />\r\n';
		if (mainSettings.operatori == "1")
		{
			var operatorTrailerLine = compileOperatorLine();
			bodyXML += '\t<printRecMessage  operator="' + currentOperatorNumberString + '" messageType="2" index="1" font="1" message="' + operatorTrailerLine + '" />\r\n';
		}		
	}
	
	function compileOperatorLine()
	{
		// STAMPA OPERATORE off per affrontare crash con codice fiscale.
		// La stessa stampa facciamo mediante trailer line tipo 2 o additional header tipo 1.
		var operatorLine = "OPERATORE         ";
		if (currentOperatorNumber < 10)
		{
			operatorLine += " ";
		}
		operatorLine += (currentOperatorNumber.toString() + "      ");
		if (operatorXMLArray[currentOperatorNumber] != null &&
			operatorXMLArray[currentOperatorNumber].name != null)
		{
			operatorLine += operatorXMLArray[currentOperatorNumber].name + "                    ";
			operatorLine = operatorLine.substr(0, 46);
		}
		else
		{
			operatorLine += "OPERATORE ";
			if (currentOperatorNumber < 10)
			{
				operatorLine += " ";
			}
			operatorLine += (currentOperatorNumber.toString() + "        ");
		}
		
		return operatorLine;
	}
	
	function addPayment(amount, buttonFunction, buttonText)
	{
		var paymentType = '0';
		var paymentIndex = '00';
		var amountNumeric = 0;

		var buttonFunctionTrimmed = buttonFunction.replace(/ /g, "");	// Togliere eventuali spazi.
		if (buttonFunctionTrimmed.length >= 8 && buttonFunctionTrimmed.toLowerCase().substr(0, 8) == 'contante')
		{
			paymentType = '0';
			if (buttonFunctionTrimmed.length == 9)
			{
				paymentIndex = '0' + buttonFunctionTrimmed.substr(8, 1);
			}
			else
			{
				paymentIndex = '00';	// In caso di funzione contante senza indice, il valore 00 viene impostato.
			}			
		}
		else if (buttonFunctionTrimmed.toLowerCase() == 'assegni')
		{
			paymentType = '1';
			paymentIndex = '00';
		}
		else if (buttonFunctionTrimmed.toLowerCase() == 'credito')
		{
			paymentType = '2';
			paymentIndex = '00';
		}
		else if (buttonFunctionTrimmed.length >= 14 && buttonFunctionTrimmed.toLowerCase().substr(0, 14) == 'cartadicredito')
		{
			paymentType = '2';
			
			if (buttonFunctionTrimmed.length == 16)
			{
				paymentIndex = buttonFunctionTrimmed.substr(14, 2);
			}
			else if (buttonFunctionTrimmed.length == 15)
			{
				paymentIndex = '0' + buttonFunctionTrimmed.substr(14, 1);
			}
			else
			{
				paymentIndex = '01';
			}
		}				
		else if (buttonFunctionTrimmed.length >=6 && buttonFunctionTrimmed.toLowerCase().substr(0, 6) == 'ticket')
		{
			paymentType = '3';
			if (buttonFunctionTrimmed.length == 8)
			{
				paymentIndex = buttonFunctionTrimmed.substr(7, 2);
			}
			else if (buttonFunctionTrimmed.length == 7)
			{
				paymentIndex = '0' + buttonFunctionTrimmed.substr(7, 1);
			}
			else
			{
				paymentIndex = '01';
			}
		}
		else if (buttonFunctionTrimmed.length == 12 && buttonFunctionTrimmed.toLowerCase().substr(0, 9) == 'pagamento')
		{
			paymentType = buttonFunctionTrimmed.substr(9, 1);
			paymentIndex = buttonFunctionTrimmed.substr(10, 2);
		}

		if (mainSettings.tipoConnessione == "Dedicata" && mainSettings.demoMode == false)
		{
			/* see manual "Communication Protocol Operazioni Light */
			amount = pad(amount, 9, '0');
			var dataToSend = '<printerCommand>\r\n' +
								'\t<directIO  command="1084" data="' + currentOperatorNumberString + // Operator.
								buttonText + 
								amount +		// 0 if printer has to calculate the sum.
								paymentType +
								paymentIndex +
								'1"' +		// Display alignment
								' timeout="' + directIOTimeout + '"' +
								' />\r\n' +
								'</printerCommand>\r\n';

			var eposPayment = new epson.fiscalPrint();
			var onErrorCount = 0;
			eposPayment.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					// for error list see A_PDU in "Communication Protocol"
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					/* response analysis
					Messaggio di risposta quando non è possibile chiudere lo scontrino:
					responseCommand: 1 084
					responseData:	 OP 0 RIM
							 AA 0 BBBBBBBBB
	
					Messaggio di risposta con chiusura scontrino:
					responseCommand: 1 084
					responseData:	 OP 1 RESTO     DATA   ORA  N.SF
							 AA 1 BBBBBBBBB DDMMYY HHMM CCCC
					*/
					if (add_info.responseData !== undefined)
					{
						paymentPhase = true;
						somethingToVoid = false;
						updateTotal();						
						var response_data = add_info.responseData;
						var is_closed = response_data[2];
						if (is_closed == '1')				 // 0 = if receipt still open (pagamento insufficiente), 1 = closed.
						{
							paymentPhase = false;
							partialPaymentsInProgress = false;
							var resto = response_data.substr(3, 9);
							lastDocCommDate = response_data.substr(12, 6);
							lastDocCommTime = response_data.substr(18, 4);
							lastDocCommDocNumber = response_data.substr(22, 4);

							if (parseInt(resto, 10) == 0)
							{
								/*
								Se resto == 0
								mostra il totale della spesa e la scritta del tasto
								*/
								if (paymentOutstanding == receiptTotalCalculatedInternally)
								{
									display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', true]);
								}
								else
								{
									display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [paymentOutstanding.toString(), '', true]);
								}
								display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
							}
							else
							{
								/*
								Resto != 0
								mostra il RESTO preso da responseData e la scritta 'RESTO'
								*/
								display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [resto, '', true]);
								display.trigger('virtualPrinterDisplay:set_row2_to', [changeText]);
							}
							receiptTotalCalculatedInternally = 0;
							closeFiscalReceipt();
							paymentOutstanding = 0;							
							lastTransactionAmount = 0;
							lastSaleStornoAmount = 0;
						}
						else	// is_closed == '0')
						{
							/*
							Se lo scontrino non è chiuso (il cliente ha pagato meno del dovuto)
							mostra la rimanenza (RIM) presa da responseData e la scritta
							'DIFFERENZA'
							*/
							partialPaymentsInProgress = true;
							paymentOutstanding = parseInt(response_data.substr(3, 9), 10);
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [paymentOutstanding.toString(), '', true]);
							display.trigger('virtualPrinterDisplay:set_row2_to', [paymentDifferenceText]);
						}
						acceptNewNumericInput = true;
					}
					else
					{
						manageErrors(result, 91);
						acceptNewNumericInput = true;
					}
				}
			};
			
			eposPayment.onerror = function (result)
			{
				onErrorCount++;
				if (onErrorCount == 1) // Ignoriamo eventi onError multipli (possono verificarsi quando timeout ! = 0. Due eventi in fiscalprint.js.
				{
					manageErrors(result, 90);
				}
			};
			
			eposPayment.send(xmlHTTPRequestURLMain, dataToSend, defaultPostTimeout);
		}
		else		//  Casse multipla o demoMode true. printerFiscalReceipt
		{
			// var dataToSend = '<printRecTotal operator="' + currentOperatorNumberString + '" description="' + description +  " payment="' + payment + '" ' paymentType="' + paymentType + '" index="' + index + '" justification="1" />';

			amountNumeric = 0;
			var resto = 0;
			var paymentOutstandingNow = 0;
			lastTransactionAmount = 0;
			lastSaleStornoAmount = 0;
			somethingToVoid = false;
			paymentPhase = true;
			updateTotal();
			if (amount != "0")
			{
				amountNumeric = parseInt(amount, 10);
				amount = amount.substr(0, amount.length - 2) + "," + amount.substr(amount.length - 2);
				
				if (amountNumeric >= paymentOutstanding)
				{
					paymentOutstandingNow = 0;
					partialPaymentsInProgress = false;
					if (amountNumeric > paymentOutstanding)
					{
						resto = amountNumeric - paymentOutstanding;
					}
				}
				else
				{
					paymentOutstandingNow = paymentOutstanding - amountNumeric;					
					partialPaymentsInProgress = true;
				} 
			}
			else
			{
				paymentOutstandingNow = 0;
				resto = 0;
				partialPaymentsInProgress = false;
			}
			
			if (partialPaymentsInProgress == false)
			{
				if (resto == 0)
				{
					if (paymentOutstanding == receiptTotalCalculatedInternally) // Unico pagamento.
					{
						display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', true]);
					}
					else
					{
						display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [paymentOutstanding.toString(), '', true]);
					}
					display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
				}
				else
				{
					/*
					Resto != 0
					mostra il RESTO preso da responseData e la scritta 'RESTO'
					*/
					display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [resto, '', true]);
					display.trigger('virtualPrinterDisplay:set_row2_to', [changeText]);
				}
			}
			else	// ancora aperto con pagamenti da effettuare.
			{
				/*
				Se lo scontrino non è chiuso (il cliente ha pagato meno del dovuto)
				mostra il dovuto e la scritta 'DIFFERENZA'.
				*/
				paymentOutstanding = paymentOutstandingNow;
				display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [paymentOutstanding, '', true]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [paymentDifferenceText]);				
			}			
			bodyXML += '\t<printRecTotal operator="' + currentOperatorNumberString + '" ' +
						'description="' + buttonText + '" ' +
						'payment="' + amount + '" ' +
						'paymentType="' + paymentType+ '" ' +
						'index="' + paymentIndex+ '" ' +
						'justification="1" />\r\n';
			if (paymentOutstandingNow == 0)
			{
				if (mainSettings.demoMode == false)
				{
					closeFiscalReceipt();
				}
				else
				{
					docOpen = false;
					somethingToVoid = false;
				}
				paymentPhase = false;
				receiptTotalCalculatedInternally = 0;
			}
			acceptNewNumericInput = true;
			if (debugMode == true)
			{
				console.log('bodyXML = ' + bodyXML);
			}
		}
	}

	function closeFiscalReceipt()
	{
		var dataToSend = "";
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommands>\r\n';
			if (scontrinoCortesiaRequested == true)
			{
				dataToSend += '<directIO  command="1137" data="' + currentOperatorNumberString + '0" comment="Disattivazione taglio" />\r\n';
			}
			if (mainSettings.operatori == "1")
			{
				var operatorTrailerLine = compileOperatorLine();
				dataToSend += ('\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + operatorTrailerLine + '" />\r\n' +
								'\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n');
			}
			dataToSend += ('\t<directIO  command="1087" data="' + currentOperatorNumberString + '" timeout="' + longDirectIOTimeout + '" />\r\n' + 	// CHIUSURA DOCUMENTO COMMERCIALE.
							'</printerCommands>\r\n');
		}
		else	// Multipla
		{			
			bodyXML += '\t<endFiscalReceipt  operator="' + currentOperatorNumberString + '" />\r\n';
			dataToSend = '<printerFiscalReceipt>\r\n' +
							bodyXML +
							'</printerFiscalReceipt>\r\n';
		}

		var eposCloseDoc = new epson.fiscalPrint();
		eposCloseDoc.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == true)
			{
				docOpen = false;
				somethingToVoid = false;
				if (mainSettings.tipoConnessione == "Multipla")
				{
					bodyXML = "";
					if (add_info.fiscalReceiptDate !== undefined)
					{
						lastDocCommDate = add_info.fiscalReceiptDate;
					}
					if (add_info.fiscalReceiptTime !== undefined)
					{
						lastDocCommTime = add_info.fiscalReceiptTime;
					}
					if (add_info.zRepNumber !== undefined)
					{
						lastDocCommZRepNumber = add_info.zRepNumber;
					}
					if (add_info.fiscalReceiptNumber !== undefined)
					{
						lastDocCommDocNumber = add_info.fiscalReceiptNumber;
					}						
				}					
				
				if (add_info.printerStatus !== undefined)
				{
					managePrinterStatus(add_info.printerStatus);
				}
				if (scontrinoCortesiaRequested == true)
				{
					if (mainSettings.tipoConnessione == "Multipla")
					{
						sendScontrinoCortesia();
					}
					else
					{
						requestCurrentZNumber();	// Poi chiama sendScontrinoCortesia()
					}
				}
				else
				{
					scontrinoCortesiaArray = [];
				}				
			}
			else
			{
				sendScontrinoCortesia(); // For testing
				manageErrors(result, 90);
			}
		};
		// alert (xml);
		eposCloseDoc.onerror = function (result)
		{
			manageErrors(result, 90);
		};
		try
		{
			if (mainSettings.tipoConnessione == "Multipla" && mainSettings.operatori == "1")
			{
				sendAllVoid(true);	// Annulla eventuale doc lasciato aperto da un'altro operatore.
				// Necessari perché il reset in fpmate.cgi fallisce con operatore diverso.
			}
			eposCloseDoc.send(xmlHTTPRequestURLMain, dataToSend);
		}
		catch (myEx)
		{
			alert(myEx.message);
		}
	}
	
	function requestCurrentZNumber()
	{
		var getGranTotalNativeCommand = '2052';
		var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + getGranTotalNativeCommand + '" comment="Leggere grand totali" />\r\n' +
							'</printerCommand>\r\n';
		var eposGrandTot = new epson.fiscalPrint();
		eposGrandTot.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == true)
			{
				if (add_info.responseData !== undefined)
				{
					var response_data = add_info.responseData;
					var lastDocCommZRepNumberNumeric = parseInt(response_data.substr(14, 4), 10);
					lastDocCommZRepNumberNumeric++;
					lastDocCommZRepNumber = "000" + lastDocCommZRepNumberNumeric;
					lastDocCommZRepNumber = lastDocCommZRepNumber.substr(lastDocCommZRepNumber.length - 4, 4);
					if (debugMode == true)
					{
						console.log('responseData = ' +  response_data);
						console.log('lastDocCommZRepNumberNumeric = ' + lastDocCommZRepNumberNumeric);
						console.log('lastDocCommZRepNumber = ' + lastDocCommZRepNumber);									
					}
					if (scontrinoCortesiaRequested == true)
					{
						sendScontrinoCortesia();
					}
				}
			}
		};
		eposGrandTot.send(xmlHTTPRequestURLMain, dataToSend);
	}
	
	function sendScontrinoCortesia()	// Scontrino di Cortesia
	{
		var tearOffDashes = "----------------------------------------------";
		var sdcHeader = "            SCONTRINO di CORTESIA             ";
		var blankLine = "                                              ";
		var dataToSend = "";
		var ari = 0;
		var paddedText = "";
		var dateTimeLine = "";
		var zDocLine = "";
		
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommands>\r\n' +
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20102' + tearOffDashes + '" />\r\n' + 
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20104' + blankLine + '" />\r\n';
			for (ari = 1; ari < retailHeaderArray.length; ari ++)
			{
				paddedText = "   " + retailHeaderArray[ari] + "                                           ";
				paddedText = paddedText.substr(0, 46);
				dataToSend += '\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + paddedText + '" />\r\n';
			}
			dataToSend += 	'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20104' + blankLine + '" />\r\n' +
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20104' + sdcHeader + '" />\r\n' +
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20104' + blankLine + '" />\r\n';
		}
		else	// Multipla
		{
			dataToSend = '<printerNonFiscal>\r\n' +
							'\t<printRecMessage  operator="' + currentOperatorNumberString + '" messageType="1" index="1" font="4" message="' + sdcHeader + '" />\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n';
			}		
			dataToSend += ('\t<beginNonFiscal  operator="' + currentOperatorNumberString + '" />\r\n');
		}
		for (ari = 0; ari < scontrinoCortesiaArray.length; ari++)
		{
			if (mainSettings.tipoConnessione == "Dedicata")
			{
				paddedText = scontrinoCortesiaArray[ari] + "                                              ";
				paddedText = paddedText.substr(0, 46);
				dataToSend += '\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + paddedText + '" />\r\n';
			}
			else
			{
				dataToSend += '\t<printNormal  operator="' + currentOperatorNumberString + '" font="1" data="' + scontrinoCortesiaArray[ari] + '" />\r\n';
			}
		}
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dateTimeLine = "               " +
						lastDocCommDate.substr(0, 2) + "-" +
						lastDocCommDate.substr(2, 2) + "-20" +
						lastDocCommDate.substr(4, 2) + " " +
						lastDocCommTime.substr(0, 2) + ":" +
						lastDocCommTime.substr(2, 2) + "               ";
			zDocLine = "            DOCUMENTO N. " +
						lastDocCommZRepNumber + "-" +
						lastDocCommDocNumber + "            ";
		
			dataToSend += '\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + blankLine + '" />\r\n' +
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + dateTimeLine + '" />\r\n' +
							'\t<directIO  command="1078" data="' + currentOperatorNumberString + '20101' + zDocLine + '" />\r\n' +
							'\t<directIO  command="1137" data="' + currentOperatorNumberString + '1" comment="Attivazione taglio" />' +
							'</printerCommands>';
		}
		else	// Multipla
		{
			dateTimeLine = "               ";
			var lastDocCommDateSplit = lastDocCommDate.split('/');
			var gio = parseInt(lastDocCommDateSplit[0], 10);			
			if (gio < 10)
			{
				dateTimeLine += ("0" + gio.toString());
			}
			else
			{
				dateTimeLine += gio.toString();
			}
			dateTimeLine += "-";
			var mes = parseInt(lastDocCommDateSplit[1], 10);			
			if (mes < 10)
			{
				dateTimeLine += ("0" + mes.toString());
			}
			else
			{
				dateTimeLine += mes.toString();
			}
			dateTimeLine += "-";
			var ann = parseInt(lastDocCommDateSplit[2], 10);			
			if (ann < 100)
			{
				dateTimeLine += ("20" + ann.toString());
			}
			else
			{
				dateTimeLine += ann.toString();
			}
			dateTimeLine += " ";
			var lastDocCommTimeSplit = lastDocCommTime.split(':');
			var ore = parseInt(lastDocCommTimeSplit[0], 10);
			if (ore < 10)
			{
				dateTimeLine += ("0" + ore.toString());
			}
			else
			{
				dateTimeLine += ore.toString();
			}
			dateTimeLine += ":";
			var min = parseInt(lastDocCommTimeSplit[1], 10);
			if (min < 10)
			{
				dateTimeLine += ("0" + min.toString());
			}
			else
			{
				dateTimeLine += min.toString();
			}

			zDocLine = "            DOCUMENTO N. ";
			var zn = "000" + lastDocCommZRepNumber;
			zn = zn.substr(zn.length - 4, 4);
			zDocLine += (zn + "-");
			var dn = "000" + lastDocCommDocNumber;
			dn = dn.substr(dn.length - 4, 4);
			zDocLine += dn;
			dataToSend += ('\t<printNormal  operator="' + currentOperatorNumberString + '" font="1" data="' + blankLine + '" />\r\n' +
							'\t<printNormal  operator="' + currentOperatorNumberString + '" font="1" data="' + dateTimeLine + '" />\r\n' +
							'\t<printNormal  operator="' + currentOperatorNumberString + '" font="1" data="' + zDocLine + '" />\r\n' +
							'\t<printNormal  operator="' + currentOperatorNumberString + '" font="1" data="' + blankLine + '" />\r\n' +
							'\t<endNonFiscal  operator="' + currentOperatorNumberString + '" />\r\n' +
							'</printerNonFiscal>');
		}
		scontrinoCortesiaArray = [];
		scontrinoCortesiaRequested = false;
		sendToPrinter(dataToSend, false, false);
	}
		
	function sendScontoMaggPerc(isDiscount, buttonFunction, percentage, subtotalPressed)
	{
		if (debugMode == true)
		{
			console.log('sendScontoMaggPerc =:');
			console.log('    isDiscount = ' + isDiscount + ' buttonFunction = ' + buttonFunction + ' percentage = ' + percentage + ' subtotalPressed = ' + subtotalPressed);
		}

		var depSurchargeNativeCommand = '1022';
		var depDiscountNativeCommand = '1023';
		var subtotSurchargeNativeCommand = '1025';
		var subtotDiscountNativeCommand = '1026';
		var nativeCommand = '';
		
		if (isDiscount == true && subtotalPressed == false)
		{
			nativeCommand = depDiscountNativeCommand;
		}
		else if (isDiscount == true && subtotalPressed == true)
		{
			nativeCommand = subtotDiscountNativeCommand;
		}
		else if (subtotalPressed == false)	// Maggiorazione
		{
			nativeCommand = depSurchargeNativeCommand;
		}
		else
		{
			nativeCommand = subtotSurchargeNativeCommand;
		}

		percentage = pad(percentage, 4, '0');
		
		if (mainSettings.tipoConnessione == "Dedicata" && mainSettings.demoMode == false)
		{
			var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + nativeCommand + '" ' +
							'data="' + currentOperatorNumberString +	// Operator.
							percentage + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommand>\r\n';

			var eposScontoMaggPerc = new epson.fiscalPrint();
			eposScontoMaggPerc.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				/*
				RESPONSE STRUCTURE	1022 e 1023	(Reparto ultima vendita)
				
				         1         2         3         4         5         6      
				123456789012345678901234567890123456789012345678901234567890123456
				          1         2         3         4         5         6      
				012345678901234567890123456789012345678901234567890123456789012345
				01                                        000010000200000000200001
				OP				Codice prodotto
				                                          123456789 (Netto precedente)
				                                                   1234 (%)
				                                                       123456789 (Importo)
				                                                                12 (Reparto)
				
				RESPONSE STRUCTURE	1025 e 1026	(Subtotal)
				
				         1         2         3         4         5         6      
				123456789012345678901234567890123456789012345678901234567890123456
				          1         2         3         4         5         6      
				012345678901234567890123456789012345678901234567890123456789012345
				010000100002000000002000
				OP
				  123456789 (Subtotale)
				           1234 (%)
				               123456789 (Importo)
				*/
				if (result.success == false)
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					if (add_info.responseData !== undefined)
					{
						docOpen = true;		// sendScontoMaggPerc
						somethingToVoid = true;
						var response_data = add_info.responseData;
						var abs_discMagg_val = "";
						if (subtotalPressed == false)
						{
							abs_discMagg_val = response_data.substr(55, 9);
						}
						else
						{
							abs_discMagg_val = response_data.substr(15, 9);
						}
						if (buttonFunction.toLowerCase() == 'sconto %' || buttonFunction.toLowerCase() == 'sconto%')
						{
							receiptTotalCalculatedInternally -= parseInt(abs_discMagg_val, 10);
							lastTransactionAmount = -parseInt(abs_discMagg_val, 10);
						}
						else
						{
							receiptTotalCalculatedInternally += parseInt(abs_discMagg_val, 10);
							lastTransactionAmount = parseInt(abs_discMagg_val, 10);
						}
						
						if (isDiscount == true && subtotalPressed == false)
						{
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [abs_discMagg_val, '', false]);
							display.trigger('virtualPrinterDisplay:set_row2_to', [percentageDiscountText]);
						}
						else if (subtotalPressed == true)
						{				
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', false]);
							display.trigger('virtualPrinterDisplay:set_row2_to', [subtotalText]);
						}
						else
						{
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [abs_discMagg_val, '', false]);
							display.trigger('virtualPrinterDisplay:set_row2_to', [percentageSurchargeText]);
						}
						updateSubtotal();
					}
					else
					{
						manageErrors(result, 91);
						acceptNewNumericInput = true;
					}
				}
			};
	
			eposScontoMaggPerc.onerror = function (result)
			{
				manageErrors(result, 90);
			};
			// alert (xml);
			eposScontoMaggPerc.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else	// Casse multipla o demoMode == true. printerFiscalReceipt
		{
			if (docOpen == false)
			{
				setBodyXMLHeader();
				docOpen = true;	// sendScontoMaggPerc
			}
			somethingToVoid = true;
			bodyXML += '\t<directIO  command="' + nativeCommand + '" ' +
						'data="' + currentOperatorNumberString +	// Operator.
						percentage + '" ' + '/>\r\n';
			
			var abs_discMagg_val = 0;
			if (subtotalPressed == false)
			{
				abs_discMagg_val = parseInt(percentage, 10) * lastSaleStornoAmount / 10000;
				
			}
			else
			{
				abs_discMagg_val = parseInt(percentage, 10) * receiptTotalCalculatedInternally / 10000;
			}
			abs_discMagg_val = Math.round(abs_discMagg_val);
			
			if (buttonFunction.toLowerCase() == 'sconto %' || buttonFunction.toLowerCase() == 'sconto%')
			{
				receiptTotalCalculatedInternally -= abs_discMagg_val;
				lastTransactionAmount = -abs_discMagg_val;
			}
			else	// Maggiorazione
			{
				receiptTotalCalculatedInternally += abs_discMagg_val;
				lastTransactionAmount = abs_discMagg_val;
			}
			if (subtotalPressed == false)
			{
				lastSaleStornoAmount += lastTransactionAmount;
			}
			if (isDiscount == true && subtotalPressed == false)
			{
				display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [abs_discMagg_val.toString(), '', false]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [percentageDiscountText]);
			}
			else if (subtotalPressed == true)
			{				
				display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', false]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [subtotalText]);
			}
			else // isDiscount == false && subtotalPressed == false (maggiorazione sull'ultima transazione.
			{
				display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [abs_discMagg_val.toString(), '', false]);
				display.trigger('virtualPrinterDisplay:set_row2_to', [percentageSurchargeText]);
			}
			updateSubtotal();
		}
	}
	
	function sendSubtotalRequest()
	{
		var requestType = '2'; // Tipo = 2 = Display only. Response contains subtotal.
		var dataToSend =  '<printerCommand>\r\n' +
							'\t<directIO  command="1086" data="' + currentOperatorNumberString + requestType + '" />\r\n' +
							'</printerCommand>\r\n';
		var eposSubtotal = new epson.fiscalPrint();
		eposSubtotal.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.responseData !== undefined)
				{
					var response_data = add_info.responseData;
					var subtot = response_data.substr(3, 9);
					receiptTotalReadFromPrinter = parseInt(subtot, 10);
					if (debugMode == true)
					{
						console.log('response_data = ' + response_data);
						console.log('receiptTotalReadFromPrinter = ' + receiptTotalReadFromPrinter);
					}
					display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalReadFromPrinter.toString(), '', false]);
				}
				else
				{
					manageErrors(result, 91);
					acceptNewNumericInput = true;
				}
			}
		};
		
		eposSubtotal.onerror = function (result)
		{
			manageErrors(result, 90);
		};

		eposSubtotal.send(xmlHTTPRequestURLMain, dataToSend);		
	}
	
	function sendOpenDrawerRequest()
	{
		var dataToSend = "";
		
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			if (mainSettings.operatori == "1")
			{
				dataToSend = '<printerCommands>\r\n' + 
							'\t<directIO  command="4014" data="071" comment="STAMPA OPERATORI on" />\r\n' +
							'\t<openDrawer  operator="' + currentOperatorNumberString + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n';
			}
			else
			{
				dataToSend = '<printerCommand>\r\n' + 
							'\t<openDrawer  operator="' + currentOperatorNumberString + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommand>\r\n';
			}
		}
		else	// Multipla
		{
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORI on" />\r\n';
			}
			else
			{
				dataToSend += compileCurrentTillNumberDirectIOLine();
			}
			dataToSend += 	'\t<openDrawer  operator="' + currentOperatorNumberString + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n';
		}
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}
	
	function manageZReport()
	{
		display.trigger('virtualPrinterDisplay:blank', []);
		display.trigger('virtualPrinterDisplay:set_row2_to', [zReportText]);
		if (mainSettings.demoMode == false)
		{
			requestZReport();
		}
	}
									
	function requestZReport()
	{
		var dataToSend = '<printerFiscalReport>\r\n' + 
							'\t<displayText  operator="' + currentOperatorNumberString + '" data="                    ' + zReportText + '" />\r\n';
		if (mainSettings.operatori == "1")
		{
			dataToSend += ('\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n' +
							'\t<directIO  command="3006" data="' + currentOperatorNumberString + '00" />\r\n');
		}
		dataToSend += ('\t<printXZReport  operator="' + currentOperatorNumberString + '" />\r\n' +
							'</printerFiscalReport>\r\n');
		var eposZReport = new epson.fiscalPrint();
		var onErrorCount = 0;
		eposZReport.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == true)
			{
				if (add_info.printerStatus !== undefined)
				{
					managePrinterStatus(add_info.printerStatus);
				}
				requestRTStatus(false);
			}
			else
			{
				manageErrors(result, 90);
			}
		};
		// alert (xml);
		eposZReport.onerror = function (result)
		{
			if (onErrorCount == 1) // Ignoriamo eventi onError multipli (possono verificarsi quando timeout ! = 0. Due eventi in fiscalprint.js.
			{
				manageErrors(result, 90);
			}
		};
		try
		{
			eposZReport.send(xmlHTTPRequestURLMain, dataToSend, defaultPostTimeout);
		}
		catch (myEx)
		{
			alert(myEx.message);
		}
	}

	function requestXReport()
	{
		var dataToSend = '<printerFiscalReport>\r\n' +
							'\t<displayText  operator="' + currentOperatorNumberString + '" data="                    ' + xReportText + '" />\r\n';
		if (mainSettings.operatori == "1")
		{
			dataToSend += ('\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n');
		}							
		dataToSend += ('\t<printXReport  operator="' + currentOperatorNumberString + '" />\r\n' +
						'</printerFiscalReport>\r\n');
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}
	
	function requestXOperatorsReport()
	{
		var dataToSend = '<printerCommands>\r\n' +
							'\t<displayText  operator="' + currentOperatorNumberString + '" data="                    ' + xOperatorsReportText + '" />\r\n' +
							'\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n' +
							'\t<directIO  command="2006" data="' + currentOperatorNumberString + '00" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n';
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}
	
	function requestXOperatorReport(rowOneText)
	{
		var dataToSend = '<printerCommands>\r\n' +
							'\t<displayText  operator="' + currentOperatorNumberString + '" data="' + rowOneText + xOperatorsReportText + '" />\r\n' +
							'\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n' +
							'\t<directIO  command="2006" data="' + currentOperatorNumberString + currentOperatorNumberString + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n';
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}

	function requestVoidTransazione()
	{
		var dataToSend = "";
		
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="1027" data="' + currentOperatorNumberString + '" />\r\n' +	// operator
							'</printerCommand>\r\n';
			if (mainSettings.demoMode == false)
			{
				sendToPrinter(dataToSend, false, false);
				scontrinoCortesiaArray.pop();
				if (scontrinoCortesiaArray[scontrinoCortesiaArray.length - 1] == sconCortStornoText)
				{
					scontrinoCortesiaArray.pop();
				}					
			}
		}
		else
		{
			bodyXML += 	'\t<printRecItemVoid  operator="' + currentOperatorNumberString + '" voidLastItem="1" />\r\n';
			scontrinoCortesiaArray.pop();
			if (scontrinoCortesiaArray[scontrinoCortesiaArray.length - 1] == sconCortStornoText)
			{
				scontrinoCortesiaArray.pop();
			}	
		}
	}

	function requestPlu(pluNumber)
	{
		var nativeCommand = '4203';
		pluNumber =  pad(pluNumber, 4, '0');
		var dataToSend = '<printerCommand>\r\n' +
							'\t<directIO  command="' + nativeCommand + '" data="' + pluNumber + '" />\r\n' +
							'</printerCommand>\r\n';
		var eposPlu = new epson.fiscalPrint();
		eposPlu.onreceive = function (result, tag_names_array, add_info)
		{
			// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
			if (debugMode == true)
			{
				statoAndResultConsoleLog(result, tag_names_array, add_info);
			}
			if (result.success == false)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				manageErrors(result, 90);
				needClear = true;
			}
			else
			{
				if (add_info.responseData !== undefined)
				{
					//	PLU		<responseData>0001P.L.U.    1         00000012300000000000000000001                                        </responseData>
					// 	NO PLU	<responseData>0002P.L.U.    2         00000000000000000000000000000                                        </responseData>
					//						  012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012
					var response_data = add_info.responseData;					
					var description = response_data.substr(4, 20);					
					var unitPrice = response_data.substr(24, 9);					
					var department = response_data.substr(51, 2);
					if (debugMode == true)
					{
						console.log('response_data = ' + response_data);
						console.log('description = ' + description);
						console.log('unitPrice= ' + unitPrice);
						console.log('department = ' + department);
					}
					if (department == '00')	// No PLU
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [notProgrammedText]);
						needClear = true;
					}
					else	// PLU exists
					{
						display.trigger('virtualPrinterDisplay:set_row2_to', [description]);
						addSaleStorno(unitPrice, department, description, stornoPressed);
					}
					lastPluUnitPrice = unitPrice;
					lastPluDepartment = department;
					lastPluDescription = description;
				}
				else
				{
					manageErrors(result, 91);					
				}
			}
		};

		eposPlu.onerror = function (result)
		{
			manageErrors(result, 90);
		};

		// alert (xml);
		
		if (mainSettings.demoMode == false)
		{
			eposPlu.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else
		{
			var pluNumberInt = parseInt(pluNumber, 10);
			if (pluNumberInt >= 1 && pluNumberInt <= 1000)
			{
				var description = "    " + pluNumberInt;
				description = description.slice(-5);
				description = "P.L.U." + description;
				var unitPrice = "000000" + pluNumber + "00";
				unitPrice = unitPrice.slice(-9);
				var department = pluNumberInt;
				if (pluNumberInt < 10)
				{
					department = "0" + pluNumberInt;
				}
				else if (pluNumberInt > 99)
				{
					department = "99";
				}
							
				if (debugMode == true)
				{
					console.log('description = ' + description);
					console.log('unitPrice= ' + unitPrice);
					console.log('department = ' + department);
				}
				display.trigger('virtualPrinterDisplay:set_row2_to', [description]);
				addSaleStorno(unitPrice, department, description, stornoPressed);
				
				lastPluUnitPrice = unitPrice;
				lastPluDepartment = department;
				lastPluDescription = description;
			}
			else
			{
				display.trigger('virtualPrinterDisplay:set_row2_to', [notForeseenText]);
				needClear = true;
			}			
		}
	}

	function sendAllVoid(ignoreError)
	{
	/* come specificato da Camillo Radaelli 140220 mando un RESET STAMPANTE FISCALE */
		var dataToSend = "";
		if (mainSettings.operatori == "1")
		{
			dataToSend = '<printerCommands>\r\n' +
							'\t<directIO  command="4014" data="040" comment="OPERATORI off prima per consentire sempre il cambiamento del numero operatore altrimenti reset potrebbe fallire." />\r\n' + 							
							'\t<resetPrinter  operator="' + currentOperatorNumberString + '" />\r\n' +
							'\t<directIO  command="4014" data="041" comment="OPERATORI on" />\r\n' +
							'</printerCommands>\r\n';
		}
		else
		{
			dataToSend = '<printerCommand>\r\n' +
							'\t<resetPrinter  operator="' + currentOperatorNumberString + '" />\r\n' +
							'</printerCommand>\r\n';
		}
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, ignoreError, false);
		}
	}
		
	function sendRefundVoidRequest(buttonFunction)
	{
		docResoAnnulloOpeningInProgress = false;
		var refundVoidText = '';
		var operatorHeaderLine = "";
		if (buttonFunction.toLowerCase() == "reso")
		{
			refundVoidText = "REFUND";
		}
		else
		{
			refundVoidText = "VOID";
		}
		var myDate = resoAnnulloDate.substr(0, 2) +
					 resoAnnulloDate.substr(3, 2) + '20' +
					 resoAnnulloDate.substr(6, 2);
		var dataToSend = "";
		var specialString = refundVoidText + ' ' +
							resoAnnulloZNum + ' ' +
							resoAnnulloDocNum + ' ' +
							myDate + ' ' +
							resoAnnulloFiscalSerialNumber;
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			var nativeCommand = '1078';
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				operatorHeaderLine = compileOperatorLine();
				dataToSend += ('\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n' +
								'\t<directIO  command="1078" data="' + currentOperatorNumberString + '10101' + operatorHeaderLine + '" />\r\n');
			}
			dataToSend +=	'\t<directIO  command="' + nativeCommand + '" ' +
							'data="' + currentOperatorNumberString + '10101' +
							specialString +
							'" />\r\n' +
							'</printerCommands>\r\n';
		}
		else	// Multipla
		{
			if (mainSettings.operatori == "1")
			{
				operatorHeaderLine = compileOperatorLine();
				bodyXML = '\t<directIO  command="4014" data="070" comment="STAMPA OPERATORE off" />\r\n' +
							'\t<printRecMessage  operator="' + currentOperatorNumberString + '" messageType="1" index="1" font="1" message="' + operatorHeaderLine + '" />\r\n';
			}
			else
			{
				bodyXML = compileCurrentTillNumberDirectIOLine();
			}
			bodyXML += '\t<printRecMessage  operator="' + currentOperatorNumberString + '" messageType="4" message="' + specialString + '" />\r\n';		
			if (refundVoidText == "VOID" && resoAnnulloFiscalSerialNumber == fiscalSerialNumber)
			{
				dataToSend = '<printerFiscalReceipt>\r\n' +
							bodyXML +
							'</printerFiscalReceipt>\r\n';
				bodyXML = "";
			}
		}
			
		if (debugMode == true)
		{
			console.log('dataToSend = ' + dataToSend);
			console.log('bodyXML  = ' + bodyXML );
		}
		if ((mainSettings.tipoConnessione == "Dedicata" ||
			(mainSettings.tipoConnessione == "Multipla" && refundVoidText == "VOID" && resoAnnulloFiscalSerialNumber == fiscalSerialNumber)) &&
			mainSettings.demoMode == false)
		{
			var eposRefundVoid = new epson.fiscalPrint();
			eposRefundVoid.onreceive = function (result, tag_names_array, add_info)
			{
				// alert("result: " + res.result + "\ncode: " + res.code + "\ndescription: " + res.description);
				if (debugMode == true)
				{
					statoAndResultConsoleLog(result, tag_names_array, add_info);
				}
				if (result.success == false)
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					manageErrors(result, 90);
					needClear = true;
				}
				else
				{
					if (mainSettings.tipoConnessione == "Dedicata")
					{
						if (add_info.responseData !== undefined)
						{
							var response_data = add_info.responseData;
							var operatorReply = response_data.substr(0, 2);
							if (debugMode == true)
							{
								console.log('response_data = ' + response_data);
								console.log('operatorReply = ' + operatorReply);
							}
							if (parseInt(operatorReply, 10) >= 50)
							{
								// Annullo automatico.
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [cashText]);
							}
							else
							{
								docOpen = true;
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								// display.trigger('virtualPrinterDisplay:set_row2_to', [registrationStateText]);
								if (refundVoidText == "VOID")
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [docDiAnnulloApertoText]);
								}
								else
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [docDiResoApertoText]);
								}
							}
						}
						else
						{
							manageErrors(result, 91);
							needClear = true;
						}
					}
					else	// result.success == true e mainSettings.tipoConnessione == "Multipla")

					{
						// Con esito positivo, deve essere un annullo automatico.
						display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [cashText]);
					}
				}
			};

			eposRefundVoid.onerror = function (result)
			{
				manageErrors(result, 90);
			};

			// alert (xml);
			if (mainSettings.tipoConnessione == "Multipla" && mainSettings.operatori == "1")
			{
				sendAllVoid(true);	// Annulla eventuale doc lasciato aperto da un'altro operatore.
				// Necessari perché il reset in fpmate.cgi fallisce con operatore diverso.
			}
			eposRefundVoid.send(xmlHTTPRequestURLMain, dataToSend);
		}
		else	// Non trasmette se ("Multipla" && refundVoidText != "VOID" && resoAnnulloFiscalSerialNumber != fiscalSerialNumber) ||
				// demoMode == true)
		{
			docOpen = true;
			display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
			if (refundVoidText == "VOID")
			{
				display.trigger('virtualPrinterDisplay:set_row2_to', [docDiAnnulloApertoText]);
			}
			else
			{
				display.trigger('virtualPrinterDisplay:set_row2_to', [docDiResoApertoText]);
			}
		}
	}
	
	function sendExtendedDescription(textAreaTag, withSale)
	{		
		var descLines = document.getElementById(textAreaTag).value.split("\n");
		var lastLineIndex = descLines.length - 1;
		if (descLines.length > maxDescLines)
		{
			lastLineIndex = maxDescLines - 1;
			var tempDescLines = descLines.slice(0, maxDescLines);
			descLines = tempDescLines;
			if (descLines[maxDescLines - 1].length <= 22)
			{
				descLines[maxDescLines - 1] += "...";
			}
			else
			{
				descLines[maxDescLines - 1] = descLines[maxDescLines - 1].substr(0, 22) + "...";
			}
		}
	
		display.trigger('virtualPrinterDisplay:set_row2_to', [descLines[lastLineIndex]]);
		/*
		var dl=0;
		for (dl=0; dl <= lastLineIndex; dl++)
		{
			if (dl != lastLineIndex)
			{
				sendAdditionalDescriptions(descLines[dl]);
			}
		}
		*/
		
		if (lastLineIndex != 0 || withSale == false)
		{
			sendAdditionalDescriptions(descLines, withSale);
		}
		if (withSale == true)
		{
			sendSale(descLines[lastLineIndex]);
		}
	}
	
	function closeCodesForm()
	{
		document.getElementById('codeString').value = "";
		$('.codesFormClass').css('display', 'none');
		$('.landscape').css('display', '');
		$('.portrait').css('display', '');
		codesFormOpen = false;
		document.getElementById('codeString').blur();
	}
	
	function sendSale(saleDesc)
	{			
		var qtyWhole = prepareText(document.getElementById('quantityTextWhole').value);
		// qtywhole = pad(qtywhole, 4, '0');
		var qtyDec = "";
		if (document.getElementById('quantityTextDecimals').value == "")
		{
			qtyDec = '000';
		}
		else
		{
			qtyDec =  prepareText(document.getElementById('quantityTextDecimals').value);
			qtyDec = qtyDec + '000';
			qtyDec = qtyDec .substr(0, 3);
		}
		quantity = qtyWhole + qtyDec ;		

		var unitPriceWhole = prepareText(document.getElementById('unitPriceTextWhole').value);
		var unitPriceDec = "";
		if (document.getElementById('unitPriceTextDecimals').value == "")
		{
			unitPriceDec = '00';
		}
		else
		{
			unitPriceDec = prepareText(document.getElementById('unitPriceTextDecimals').value);
			unitPriceDec = unitPriceDec + '00';
			unitPriceDec = unitPriceDec.substr(0, 2);
		}
		setTimeout(function()
		{
			addSaleStorno(unitPriceWhole + unitPriceDec, document.getElementById('departmentNumberText').value, saleDesc, stornoPressed);
			resetPrincipalVariables();
			lastUnitPrice = unitPriceWhole + unitPriceDec;
		}, 250);
	}
	
	function sendAdditionalDescriptions(additionalDescriptionsText, withSale)
	{
		var offset = 0;
		if (withSale == true)
		{
			offset = 1;
		}
		var dataToSend = "";
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommands>\r\n';
		}
		var dl = 0;
		for (dl = 0; dl < (additionalDescriptionsText.length - offset); dl++)
		{
			if (mainSettings.tipoConnessione == "Dedicata")
			{
				dataToSend += ('\t<directIO  command="1078" data="' + currentOperatorNumberString + '40001' + additionalDescriptionsText[dl] + '" />\r\n');
			}
			else
			{
				dataToSend += ('\t<printRecMessage  operator="' + currentOperatorNumberString + '" messageType="4" message="' + additionalDescriptionsText[dl] + '" />\r\n');
			}
		}
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend += '</printerCommands>\r\n';		
			if (mainSettings.demoMode == false)
			{
				sendToPrinter(dataToSend, false, false);
			}
		}
		else
		{
			bodyXML += dataToSend;
		}
		docOpen = true;	// sendAdditionalDescriptions
	}

	function sendCashInOut(buttonFunction, amount)
	{
		var nativeCommand = '';
		if (buttonFunction.toLowerCase() == 'entrate')
		{
			nativeCommand="1031";
		}
		else
		{
			nativeCommand="1032";
		}
		amount = pad(amount, 9, '0');
		var dataToSend = "";
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += ('\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n');
			}
			dataToSend += ('\t<directIO  command="' + nativeCommand + '" data="' + currentOperatorNumberString + amount + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n');
		}
		else	// Multipla
		{
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n';
			}
			else
			{
				dataToSend += compileCurrentTillNumberDirectIOLine();
			}
			dataToSend +=	'\t<directIO  command="' + nativeCommand + '" data="' + currentOperatorNumberString + amount + '" timeout="' + directIOTimeout + '" />\r\n' +
							'</printerCommands>\r\n';
		}
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}

	function requestReprintLast()
	{
		var dataToSend = "";
		if (mainSettings.tipoConnessione == "Dedicata")
		{
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n';
			}
			dataToSend += ('\t<printDuplicateReceipt  operator="' + currentOperatorNumberString + '" />\r\n' +
						 '</printerCommands>\r\n');
		}
		else	// Multipla
		{
			dataToSend = '<printerCommands>\r\n';
			if (mainSettings.operatori == "1")
			{
				dataToSend += '\t<directIO  command="4014" data="071" comment="STAMPA OPERATORE on" />\r\n';
			}
			else
			{
				dataToSend += compileCurrentTillNumberDirectIOLine();
			}
			if (lastDocCommDate == "" || lastDocCommDocNumber == "")
			{
				dataToSend += '\t<printDuplicateReceipt  operator="' + currentOperatorNumberString + '" />\r\n';
			}
			else
			{
				// <printContentByNumbers  operator="' + currentOperatorNumberString + '" dataType="0" day="17" month="02" year="2020" fromNumber="1" toNumber="2" />
				var lastDocCommDateSplit = lastDocCommDate.split('/');
				dataToSend += ('\t<printContentByNumbers  operator="' + currentOperatorNumberString + '" dataType="0" day="' + lastDocCommDateSplit[0] + '" ' +
									'month="' + lastDocCommDateSplit[1] + '" ' +
									'year="' + lastDocCommDateSplit[2] + '" ' +
									'fromNumber="' + lastDocCommDocNumber + '" ' +
									'toNumber="' + lastDocCommDocNumber + '"  />');
			}
			dataToSend += '</printerCommands>\r\n';
		}
		if (mainSettings.demoMode == false)
		{
			sendToPrinter(dataToSend, false, false);
		}
	}
	
	// *************** G E S T I O N E   P U L S A N T I ***************
	
	function clickedTouched(mouseEventObject)
	{
		// alert("mouseEventObject = " + mouseEventObject);
		var myButton = $(this);
		myButton.css('background','#FFFF00');
		if (mainSettings.beepMode == "1")
		{			
			setTimeout(function(){beep.play();}, 50);
		}
		else if (mainSettings.beepMode == "2")	// Certain mobile devices do not allow media riproduction in setTimeout.
		{
			beep.play();
		}
		if (debugMode == true)
		{
			console.log('myButton.data(color) = ' + myButton.data('color'));
		}
		setTimeout(function()
		{
			myButton.css('background', myButton.data('color'));
			myButton.timeout=null;
		}, 300);
		// setTimeout(function(){myButton.css('background', myButton.data('color')), myButton.timeout=null}, 50);
		// var buttonText = myButton.text();
		var buttonText = myButton.attr('innerHTML');
		buttonText = buttonText.replace("<br>", " ");
		// alert(myButton.attr('innerHTML'));
		var buttonFunction = myButton.attr('title');
		if (buttonFunction == "")
		{
			buttonFunction = buttonText;
		}
		if (debugMode == true)
		{
			console.log('buttonText = ' + buttonText);
			console.log('buttonFunction = ' + buttonFunction);
			console.log('needClear = ' + needClear);
			console.log('acceptNewNumericInput = ' + acceptNewNumericInput);
			console.log('previousFunction = ' + previousFunction);
		}
		// alert (buttonText);
		var buttonFunctionTrimmedLower = buttonFunction.replace(/ /g, "");	// Togliere eventuali spazi.
		if (appLoadingInProgress == true && buttonFunctionTrimmedLower != 'allvoid')
		{
			alert ("Caricamento applicativo in corso");
			return;
		}
		if (eftposInProgress == true)
		{
			if (buttonFunctionTrimmedLower == "allvoid" ||
				buttonFunctionTrimmedLower == "esci" ||
				buttonFunctionTrimmedLower.length >= 7 && buttonFunctionTrimmedLower.substr(0, 7) == "pagina-")
			{
				// Per adesso non interrompiamo.
				alert("Pagamento elettronico EFT-POS in corso.");
				return;
			}
			else
			{
				alert("Pagamento elettronico EFT-POS in corso.");
				return;
			}
		}		
		if (buttonFunction.length > 13 && buttonFunction.substr(0, 13) == 'NUMERO CASSA ')
		{
			currentTillNumber = parseInt(buttonFunction.substr(13), 10);
			if (currentTillNumber == 1)
			{
				masterTillOrOperator = true;
			}
			$('.tillsFormClass').css('display', 'none');
			$('.landscape').css('display', '');
			$('.portrait').css('display', '');
			prepareAll();	// Questa funzione controlla switchingOperators per non riprogrammare la stampante.
		}
		
		else if (buttonFunction.length > 17 && buttonFunction.substr(0, 17) == 'NUMERO OPERATORE ')
		{
			if (currentOperatorNumber != -1)
			{
				switchingOperators = true;	// Controllata in funzione prepareAll. Cambia da un operatore ad un altro non dovrebbe programmare la stampante.
			}
			currentOperatorNumber = parseInt(buttonFunction.substr(17), 10);
			$('.operatorsFormClass').css('display', 'none');
			$('.landscape').css('display', '');
			$('.portrait').css('display', '');
			prepareAll();	// Questa funzione controlla switchingOperators per non riprogrammare la stampante.
		}
		
		var pluNumber = '';		
		var ti = 0;
		var amount = '0';
		var isDiscount = false;
		var descLines = "";
		var codeString = "";
		
		if (extendedDescriptionFormOpen == false &&
			extendedDescriptionAndSaleFormOpen == false &&
			codesFormOpen == false)
		{
			
			if (buttonFunction.toLowerCase() == 'esci')
			{				
				for (ti = 0; ti < keyPages[0].length; ti++)
				{
					var posxy = keyPages[0][ti].position;
					if (debugMode == true)
					{
						console.log('posxy = ' + posxy);
						console.log('class = ' + keyPages[0][ti].className);
						console.log('funzione = ' + keyPages[0][ti].buttonFunction);
						console.log('testo = ' + keyPages[0][ti].buttonText);
					}
					document.getElementById(posxy).className = keyPages[0][ti].className;
					document.getElementById(posxy).title = keyPages[0][ti].buttonFunction;
					document.getElementById(posxy).innerHTML = keyPages[0][ti].buttonText;
					if (document.getElementById(posxy).title.toLowerCase() == "nasconde")
					{
						document.getElementById(posxy).style.visibility = "hidden";
					}
					else
					{
						document.getElementById(posxy).style.visibility = "visible";
					}
				}
			}
			else if (buttonFunction.length > 7 && buttonFunction.toLowerCase().substr(0, 7) == 'pagina-')
			{
				managePageChange (buttonFunction.substr(7));

				/*
				var pageNumber = parseInt(buttonFunction.substr(7), 10);
				
				if (pageNumber <= numSecondaryPages)
				{
					if (keyPages[pageNumber].length > 0)
					{
						var ti = 0;
						for (ti = 0; ti < keyPages[pageNumber].length; ti++)
						{
							var posxy = keyPages[pageNumber][ti].position;
							if (debugMode == true)
							{
								console.log('posxy = ' + posxy);
								console.log('class = ' + keyPages[pageNumber][ti].className);
								console.log('funzione = ' + keyPages[pageNumber][ti].buttonFunction);
								console.log('testo = ' + keyPages[pageNumber][ti].buttonText);
							}
							document.getElementById(posxy).className = keyPages[pageNumber][ti].className;
							document.getElementById(posxy).title = keyPages[pageNumber][ti].buttonFunction;
							document.getElementById(posxy).innerHTML = keyPages[pageNumber][ti].buttonText;
							if (document.getElementById(posxy).title.toLowerCase() == "nasconde")
							{
								document.getElementById(posxy).style.visibility = "hidden";
							}
							else
							{
								document.getElementById(posxy).style.visibility = "visible";
							}
						}
					}
					else
					{
						alert("Pagina " + pageNumber + " è vuota (file xml/Pagina-" + pageNumber + ".xml non esiste o non contiene i tag previsti.)");
					}
				}
				else
				{
					alert("Pagina " + pageNumber + " oltre il numero programmato in Settings.xml.");
				} 
											
				// pageymentFormOpen = true;
				*/						
			}
			else if (buttonFunction.toLowerCase() == 'cambia operatore' ||
					buttonFunction.toLowerCase() == 'cambiaoperatore')
			{				
				if (mainSettings.operatori == "1")
				{
					if (docOpen != true)
					{
						$('.landscape').css('display', 'none');
						$('.portrait').css('display', 'none');
						$('.operatorsFormClass').css('display', 'block');
					}
					else
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
						alert("Non è possibile cambiare operatore con documento aperto.");
						needClear = true;
					}
				}
				else
		 		{
		 			alert("Modalità operatori non è stata impostata in Settings.xml.");
		 		}
			}
			else if (buttonFunction.toLowerCase() == 'cl clear' ||
					buttonFunction.toLowerCase() == 'clclear' ||
					buttonFunction.toLowerCase() == 'cl' ||
					buttonFunction.toLowerCase() == 'clear')
			{
				needClear = false;
				if (docResoAnnulloOpeningInProgress == false)
				{
					if (mainSettings.tipoConnessione == "Dedicata")
					{
						clearPrinterDisplay();
					}
					resetDisplayAndVariables();
				}
				else
				{
					manageDocResoAnnullo(buttonFunction, buttonText);
				}
			}
			else if (needClear == true)
			{
				// alert("Per cortesia premere il tasto CL Clear e poi " + buttonText + "!");
				alert("Per cortesia premere il tasto CL Clear!");
			}
			
			// * * * * * * * R E P A R T I * * * * * * *
			else if (buttonFunction.length >= 8 &&
				buttonFunction.toLowerCase().substr(0, 7) == "reparto" &&
				buttonFunction.toLowerCase() != "reparto generico" &&
				buttonFunction.toLowerCase() != "repartogenerico")
			{
				genericDepartmentStep = 1;
				if (docResoAnnulloOpeningInProgress == false)
				{
					var fixedUnitPriceKey = false;
					var lastIndexEuro = buttonFunctionTrimmedLower.lastIndexOf("€");
					if (lastIndexEuro != -1)
					{
						// € trovato. Indica possibilità prezzo unitario fisso.
						fixedUnitPriceKey = true;
					}
					if (acceptNewNumericInput == false || (previousFunction == buttonFunction && quantity == defaultQuantity1) || fixedUnitPriceKey == true)
					{
						display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
						var unitPrice = '';
						if (acceptNewNumericInput == true)	// Vuol dire che non è stato digitato un prezzo unitario.
						{
							if (previousFunction == buttonFunction && quantity == defaultQuantity1)
							{
								unitPrice = lastUnitPrice;
							}
							else // fixedUnitPriceKey == true
							{
								unitPrice = buttonFunctionTrimmedLower.substr(lastIndexEuro + 1);
								if (unitPrice.lastIndexOf(",") == -1) // Ha numero intero senza decimali.
								{
									unitPrice += "00";
								}
								else // Ha decimali.
								{
									unitPrice = unitPrice.replace(/,/g, '');
								}
							}
						}
						else	// acceptNewNumericInput == false - vuol dire che non è stato digitato un prezzo unitario.
						{
							unitPrice =	row1[0].textContent;
						}
						if (debugMode == true)
						{
							console.log('unitPrice = ' + unitPrice );
						}
						unitPrice = prepareText(unitPrice);
						if (debugMode == true)
						{
							console.log('unitPrice = ' + unitPrice );
						}
						var depFunctionText = buttonFunctionTrimmedLower;
						if (lastIndexEuro != -1)
						{
							depFunctionText = depFunctionText.substr(0, lastIndexEuro);
						}			
						var depNumber = depFunctionText.substr(depFunctionText.length - 2);
						if (depNumber.toLowerCase().substr(0, 1) == "o") // lettera "o" della parola Reparto
						{
							depNumber = "0" + depNumber.substr(1, 1);
						}
						addSaleStorno(unitPrice, depNumber, buttonText, stornoPressed);
						resetPrincipalVariables();
						lastUnitPrice = unitPrice;
					}
					else
					{
						display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [notProgrammedText]);
						needClear = true;
					}
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}
			}
			else if (buttonFunction.toLowerCase() == "scontrino cortesia" ||
					buttonFunction.toLowerCase() == "scontrinocortesia" ||
					buttonFunction.toLowerCase() == "scontrino di cortesia" ||
					buttonFunction.toLowerCase() == "scontrinodicortesia" ||
					buttonFunction.toLowerCase() == "scontrino dicortesia" ||
					buttonFunction.toLowerCase() == "scontrinodi cortesia")
			{
				if (docResoAnnulloOpeningInProgress == false)
				{
					if (scontrinoCortesiaRequested == false)
					{
						scontrinoCortesiaRequested = true;
						alert ("Richiesta Scontrino di Cortesia accettata.");
					}
					else
					{
						scontrinoCortesiaRequested = false;
						alert ("Scontrino di Cortesia disattivato.");
					}
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}			
			}

			// * * * * * * * P A G A M E N T I * * * * * * *
			else if ((buttonFunction.length >= 8 && buttonFunction.toLowerCase().substr(0, 8) == 'contante') ||
					buttonFunction.toLowerCase() == 'assegni' ||
					buttonFunction.toLowerCase() == 'credito' ||
					(buttonFunction.length >= 16 &&  buttonFunction.toLowerCase().substr(0, 16) == 'carta di credito') ||
					(buttonFunction.length >= 15 &&  buttonFunction.toLowerCase().substr(0, 15) == 'cartadi credito') ||
					(buttonFunction.length >= 15 &&  buttonFunction.toLowerCase().substr(0, 15) == 'carta dicredito') ||
					(buttonFunction.length >= 14 &&  buttonFunction.toLowerCase().substr(0, 14) == 'cartadicredito') ||
					(buttonFunction.length >= 6 && buttonFunction.toLowerCase().substr(0, 6) == 'ticket') ||
					(buttonFunction.length == 12 && buttonFunction.toLowerCase().substr(0, 9) ==  'pagamento'))
			{
				if (docResoAnnulloOpeningInProgress == false)
				{
					if (mainSettings.tipoConnessione == "Multipla" && docOpen == false)
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousSequenceText]);
						needClear = true;
						return;
					}
					if (mainSettings.tipoConnessione == "Multipla" && receiptTotalCalculatedInternally < 0)
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
						needClear = true;
						return;
					}
					if (quantityDecimalsInProgress == true)
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
						needClear = true;
						return;
					}
					if (paymentPhase == false)
					{
						paymentOutstanding = receiptTotalCalculatedInternally;
					}
					if (buttonText.length >= 2 && buttonText.substr(0, 1) == "€")
					{
						var  buttonTextTrimmed = buttonText.replace(/\s/g, '');
						amount = buttonTextTrimmed.substr(1);
						if (amount.lastIndexOf(",") == -1)
						{
							amount += "00";
						}						
					}
					else if (anyNumKeyWasPressed)
					{
						amount = row1[0].textContent;
					}
					if (debugMode == true)
					{
						console.log("amount = " + amount);
					}
					amount = prepareText(amount);
					if (debugMode == true)
					{
						console.log("amount = " + amount);
					}					
					addPayment(amount, buttonFunction, buttonText);
					subtotalPressed = false;
				}
				else if (buttonFunction.toLowerCase() == 'contante') // docResoAnnulloOpeningInProgress == true
				{
					docResoAnnulloStep++;
					if (debugMode == true)
					{
						console.log('docResoAnnulloStep = ' + docResoAnnulloStep);
					}
					manageDocResoAnnullo(buttonFunction, buttonText);			
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}
			}
			else if (buttonFunction.toLowerCase() == 'eftpos' ||
					buttonFunction.toLowerCase() == 'eft-pos')
			{
				if (docResoAnnulloOpeningInProgress == false)
				{
					if (docOpen == true)
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousSequenceText]);
						needClear = true;
						return;
					}
															
					if (quantityDecimalsInProgress == true)
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
						needClear = true;
						return;
					}
					
					if (debugMode == true)
					{
						console.log("start amount = " + amount);
					}

					if (anyNumKeyWasPressed)
					{
						amount = row1[0].textContent;
					}
					if (debugMode == true)
					{
						console.log("amount = " + amount);
					}
					amount = prepareText(amount);
					
					if (debugMode == true)
					{
						console.log("amount (preparato) = " + amount);
					}					
					// Send authorizeSales
					manageEftpos(amount);
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}
			}					
			else if (buttonFunction.toLowerCase() == 'plu generico' ||
					 buttonFunction.toLowerCase() == 'plugenerico')
			{
				if (docResoAnnulloOpeningInProgress == false)
				{
					if (acceptNewNumericInput == false || previousFunction == buttonFunction)
					{
						if (acceptNewNumericInput == true && previousFunction == buttonFunction && quantity == defaultQuantity1)
						{
							pluNumber = lastPluNumber;
							display.trigger('virtualPrinterDisplay:set_row2_to', [lastPluDescription]);
						}
						else
						{
							pluNumber = row1[0].textContent;							
							display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
						}
						if (debugMode == true)
						{
							console.log('pluNumber = ' + pluNumber);
						}
						pluNumber = prepareText(pluNumber);
						if (debugMode == true)
						{
							console.log('pluNumber = ' + pluNumber);
						}
						if (pluNumber == lastPluNumber)
						{
							addSaleStorno(lastPluUnitPrice, lastPluDepartment, lastPluDescription, stornoPressed);
						}
						else
						{
							requestPlu(pluNumber);
						}
						resetPrincipalVariables();
						lastPluNumber = pluNumber;
					}
					else
					{
						display.trigger('virtualPrinterDisplay:blank', []);
						display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
						needClear = true;
					}
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}
			}
			else if (buttonFunction.length >= 4 && buttonFunction.toLowerCase().substr(0, 3) == 'plu')
			{
				if (docResoAnnulloOpeningInProgress == false)
				{					
					if (previousFunction == buttonFunction)
					{
						quantity = defaultQuantity1;
						pluNumber = lastPluNumber;
						display.trigger('virtualPrinterDisplay:set_row2_to', [lastPluDescription]);
					}
					else
					{
						// buttonFunctionTrimmedLower = buttonFunction.replace(/ /g, "");	// Togliere eventuali spazi.
						pluNumber = buttonFunctionTrimmedLower.substr(3);							
						display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
					}
					if (debugMode == true)
					{
						console.log('pluNumber = ' + pluNumber);
					}
					pluNumber = prepareText(pluNumber);
					if (debugMode == true)
					{
						console.log('pluNumber = ' + pluNumber);
					}
					if (pluNumber == lastPluNumber)
					{
						addSaleStorno(lastPluUnitPrice, lastPluDepartment, lastPluDescription, stornoPressed);
					}
					else
					{
						requestPlu(pluNumber);
					}
					resetPrincipalVariables();
					lastPluNumber = pluNumber;
				}
				else
				{
					display.trigger('virtualPrinterDisplay:blank', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
					needClear = true;
				}
			}					
			else
			{
				switch (buttonFunction.toLowerCase())
				{
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
					case '00':
						if (docResoAnnulloOpeningInProgress == false && genericDepartmentStep == 1)
						{
							if (debugMode == true)
							{
								console.log('acceptNewNumericInput = ' + acceptNewNumericInput);
							}
							if (acceptNewNumericInput == true)
							{
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								acceptNewNumericInput = false;
								if (debugMode == true)
								{
									console.log('acceptNewNumericInput changed to ' + acceptNewNumericInput);
								}
							}
							if (debugMode == true)
							{
								console.log('quantityDecimalsInProgress = ' + quantityDecimalsInProgress);
							}
							if (quantityDecimalsInProgress == false)
							{
								display.trigger('virtualPrinterDisplay:add_numeral', [buttonFunction]);
								anyNumKeyWasPressed = true;
							}
							else
							{
								currentQuantityDecimal += buttonFunction.length;
								if (currentQuantityDecimal > 3)
								{
									display.trigger('virtualPrinterDisplay:blank', []);
									display.trigger('virtualPrinterDisplay:set_row2_to', [valueExceededText]);
									currentQuantityDecimal = 0;
									needClear = true;
									return;
								}
								else
								{
									display.trigger('virtualPrinterDisplay:add_quantity_decimal', [buttonFunction]);
								}
							}
						}
						else if (docResoAnnulloOpeningInProgress == true && buttonFunction!= "00")
						{
							manageDocResoAnnullo(buttonFunction, buttonText);
						}
						else if (genericDepartmentStep == 2)
						{
							if (buttonFunction == "00")
							{
								genericDepartmentNumber = '0';
							}
							else
							{
								if (genericDepartmentNumber == '0')
								{
									genericDepartmentNumber = buttonFunction;
								}
								else if (genericDepartmentNumber.length == 1)
								{
									genericDepartmentNumber += buttonFunction;
								}
								else
								{
									genericDepartmentNumber = genericDepartmentNumber.substr(1, 1) + buttonFunction;
								}
								genericDepartmentNumber = parseInt(genericDepartmentNumber, 10).toString();	// Removes possible leading zero.
							}
							display.trigger('virtualPrinterDisplay:set_row2_rep_generico', []);
						}
						break;
				
					case ',':
						if (docResoAnnulloOpeningInProgress == false)
						{
							acceptNewNumericInput = false;
							if (quantityDecimalsInProgress == true || commaKeyAllowed == false)
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
								return;
							}
							quantityDecimalsInProgress = true;
							var wholeQuantity = row1[0].textContent;							
							wholeQuantity = prepareText(wholeQuantity);
							if (debugMode == true)
							{
								console.log("textContent = " + wholeQuantity);
								console.log("wholeQuantity = " + wholeQuantity);
							}
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [wholeQuantity, buttonFunction, true]);
						}
						break;
				
					case 'reparto generico':
					case 'repartogenerico':
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (genericDepartmentStep == 1)
							{
								if (acceptNewNumericInput == false)
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [buttonText]);
									lastUnitPrice = row1[0].textContent;
									if (debugMode == true)
									{
										console.log('lastUnitPrice = ' + lastUnitPrice);
									}
									lastUnitPrice = prepareText(lastUnitPrice);
									if (debugMode == true)
									{
										console.log('lastUnitPrice = ' + lastUnitPrice);
									}
									genericDepartmentStep++;
									genericDepartmentNumber = '0';
									display.trigger('virtualPrinterDisplay:set_row2_rep_generico', []);
								}
								else
								{
									display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
									display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousValueText]);
									needClear = true;
								}
							}
							else	// genericDepartmentStep == 2.
							{
								if (genericDepartmentNumber == '0')
								{
									display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
									display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousValueText]);
									needClear = true;
								}
								else
								{
									var desc = "Reparto " + genericDepartmentNumber;
									display.trigger('virtualPrinterDisplay:set_row2_to', [desc]);
									addSaleStorno(lastUnitPrice, genericDepartmentNumber, desc, stornoPressed);
									resetPrincipalVariables();
									genericDepartmentStep = 1;
								}
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
					
					case 'all void':
					case 'allvoid':
						if (mainSettings.tipoConnessione == "Dedicata")
						{
							sendAllVoid(false);
						}
						else
						{
							if (confirm("Reset anche la stampante?") == true)
							{
								sendAllVoid(false);
							}
						}
						resetDisplayAndVariables();
						docOpen = false;
						somethingToVoid = false;
						paymentPhase = false;
						partialPaymentsInProgress = false;
						paymentOutstanding = 0;
						docResoAnnulloOpeningInProgress = false;
						docResoAnnulloStep = 0;
						receiptTotalCalculatedInternally = 0;
						lastTransactionAmount = 0;
						lastSaleStornoAmount = 0;
						eftposInProgress = false;
						scontrinoCortesiaArray = [];
						scontrinoCortesiaRequested = false;
						appLoadingInProgress = false;
						rowInfo.html(addRowPrefix);
						break; 
	
					case 'reso':
					case 'annullo':
						if (docOpen == false)
						{
							if (docResoAnnulloOpeningInProgress == false)
							{
								docResoAnnulloOpeningInProgress = true;
								manageDocResoAnnullo(buttonFunction, buttonText);
							}
							else if (docResoAnnulloStep == 4)
							{								
								sendRefundVoidRequest(buttonFunction);
							}
							else
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
							needClear = true;
						}
						
						break;
					
					case 'sconto valore':
					case 'scontovalore':
					case 'maggiorazione valore':
					case 'maggiorazionevalore':
						if(docResoAnnulloOpeningInProgress == false)
						{
							/*
							See manual "Communication Protocol"
							Operazioni Light - H1=1; H2=083 â€“ SCONTO/PROMOZIONE LIGHT
							
							Messaggio da PC a stampante:
								OP DESC IMP TIPO REP GIUST
							
							   sono possibili solo
								TIPO 0 Sc/prom sulla ultima vendita
								TIPO 1 Sc/prom sul sub-totale con stampa subtotale
							*/
							amount = row1[0].textContent;
							if (debugMode == true)
							{
								console.log(amount);
							}
							amount = prepareText(amount);
							isDiscount = false;
							var discMaggType = 0;
							if (parseInt(amount, 10) == 0)
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
								return;
							}
							if (buttonFunction.toLowerCase() == 'sconto valore' || buttonFunction.toLowerCase() == 'scontovalore')
							{
								isDiscount = true;
							}
							if (mainSettings.tipoConnessione == "Multipla" && subtotalPressed == true &&
								receiptTotalCalculatedInternally < 0)
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
								return;
							}
							if (mainSettings.tipoConnessione == "Multipla" && subtotalPressed == false &&
								lastSaleStornoAmount < 0)	// Era uno storno.
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
								return;
							}
							if (isDiscount == true && subtotalPressed == false)
							{
								if (mainSettings.tipoConnessione == "Multipla" && parseInt(amount, 10) > lastSaleStornoAmount)
								{
									display.trigger('virtualPrinterDisplay:blank', []);
									display.trigger('virtualPrinterDisplay:set_row2_to', [limitExceededText]);
									needClear = true;
									return;
								}
								discMaggType = 0;								
							}
							else if (isDiscount == true && subtotalPressed == true)
							{
								discMaggType = 1;
							}
							else if (subtotalPressed == false)	// Maggiorazione
							{
								discMaggType = 5;
							}
							else
							{
								discMaggType = 6;
							}
							sendScontoMaggVal(buttonFunction, buttonText, amount, discMaggType);
							resetPrincipalVariables();
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;		
											
					case 'x':
						if (debugMode == true)
						{
							console.log('docResoAnnulloOpeningInProgress = ' + docResoAnnulloOpeningInProgress);
						}
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (anyNumKeyWasPressed || quantityDecimalsInProgress == true)
							{
								quantity = row1[0].textContent;
								quantity = prepareText(quantity);
								var quantityInt = parseInt(quantity, 10);
								if (quantityInt == 0)
								{
									display.trigger('virtualPrinterDisplay:blank', []);
									display.trigger('virtualPrinterDisplay:set_row2_to', [limitExceededText]);
									needClear = true;
									return;
								}
								if (quantityDecimalsInProgress == false)
								{
									quantity = quantityInt.toString();	// Removes leading zeroes.
									quantity += '000';
								}
								if (debugMode == true)
								{
									console.log('quantity = ' + quantity);
								}
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:display_quantity_row2', []);
								quantityDecimalsInProgress = false;
								commaKeyAllowed = false;
								acceptNewNumericInput = true;
							}
							else
							{
								// Possible get date request
							}
						}
						else
						{
							manageDocResoAnnullo(buttonFunction, buttonText);
						}						
						break;		
		
					case 'sconto %':
					case 'sconto%':
					case 'maggiorazione %':
					case 'maggiorazione%':
						if (docResoAnnulloOpeningInProgress == false)
						{
							var percentage = row1[0].textContent;
							if (debugMode == true)
							{
								console.log(percentage);
							}
							if (mainSettings.tipoConnessione == "Multipla" && subtotalPressed == true && receiptTotalCalculatedInternally < 0)
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
								return;
							}
							if (mainSettings.tipoConnessione == "Multipla" && subtotalPressed == false && lastSaleStornoAmount < 0)	// Era uno storno.
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
								return;
							}

							// Verifica numeri interi o con decimali.
							if (percentage.substr(percentage.length - 3, 1) == ",")
							{
								// Numero intero
								percentage = prepareText(percentage);
								percentage = parseInt(percentage, 10) * 100;
							}
							else
							{	//  numero con decimali.
								percentage = prepareText(percentage);
								// Ignoriamo terzo decimale in quanto non si trova nel comando nativo.
								percentage = percentage.substr(0, percentage.length - 1);
								percentage = parseInt(percentage, 10);
							}								
							percentage = percentage.toString();
		
							if (parseInt(percentage, 10) > 9999 || parseInt(percentage, 10) == 0)
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousValueText]);
								needClear = true;
							}
							else
							{
								isDiscount = false;
								if (buttonFunction.toLowerCase() == 'sconto %' || buttonFunction.toLowerCase() == 'sconto%')
								{
									isDiscount = true;
								}
								sendScontoMaggPerc(isDiscount, buttonFunction, percentage, subtotalPressed);
								resetPrincipalVariables();
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
		
					case 'sub totale':
					case 'subtotale':
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (docOpen == true)
							{
								if (partialPaymentsInProgress == false)
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [subtotalText]);
									display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [receiptTotalCalculatedInternally.toString(), '', false]);
									if (mainSettings.tipoConnessione == "Dedicata" && mainSettings.demoMode == false)
									{
										sendSubtotalRequest();
									}
								}
								else
								{
									display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [paymentOutstanding.toString(), '', true]);
									display.trigger('virtualPrinterDisplay:set_row2_to', [paymentDifferenceText]);
								}
	
							}
							else	// docOpen == false
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [openDrawerText]);
								sendOpenDrawerRequest();
							}
							subtotalPressed = true;
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
					
					case 'z report':
					case 'zreport':
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (docOpen == false)
							{
								if (confirm("Procedo con la chiusura fiscale giornaliera???") == true)
								{
									if (mainSettings.operatori == "1")
									{
										sendAllVoid(true);	// Annulla eventuale doc lasciato aperto da un'altro operatore.
										// Necessari perché il reset in fpmate.cgi fallisce con operatore diverso.
									}
									manageZReport();
								}
								resetPrincipalVariables();
							}
							else	// docOpen == true
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
							}
						}
						else	// docResoAnnulloOpeningInProgress == true
						{						
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
			
					case 'storno':
						if (docResoAnnulloOpeningInProgress == false)
						{
							stornoPressed = true;
							display.trigger('virtualPrinterDisplay:set_row2_to', [stornoText]);
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
	 					}
						break;
				
					case 'x report':
					case 'xreport':
						display.trigger('virtualPrinterDisplay:blank', []);
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (docOpen == false)
							{								
								display.trigger('virtualPrinterDisplay:set_row2_to', [xReportText]);
								if (mainSettings.operatori == "1")
								{
									sendAllVoid(true);	// Annulla eventuale doc lasciato aperto da un'altro operatore.
									// Necessari perché il reset in fpmate.cgi fallisce con operatore diverso.
								}
								requestXReport();
								resetPrincipalVariables();
							}
							else	// docOpen == true
							{
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;							
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
	 					}
	 					break;
	 					
					case 'x operatori report':
					case 'xoperatorireport':
					case 'x operatorireport':
					case 'xoperatori report':
						if (mainSettings.operatori == "1")
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							if (docResoAnnulloOpeningInProgress == false)
							{
								if (docOpen == false)
								{								
									display.trigger('virtualPrinterDisplay:set_row2_to', [xOperatorsReportText]);
									sendAllVoid(true);	// Invia reset perché è del tipo printerCommands.
									requestXOperatorsReport();
									resetPrincipalVariables();
								}
								else	// docOpen == true
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
									needClear = true;							
								}
							}
							else
							{
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
		 					}
		 				}
		 				else
		 				{
		 					alert("Modalità operatori non è stata impostata in Settings.xml.");
		 				}
	 					break;
	 					
					case 'x operatore report':
					case 'xoperatorereport':
					case 'x operatorereport':
					case 'xoperatore report':
						var rowOneText = "";
						if (mainSettings.operatori == "1")
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							if (docResoAnnulloOpeningInProgress == false)
							{
								if (docOpen == false)
								{								
									if (currentOperatorNumber < 10)
									{
										rowOneText = "                   " + currentOperatorNumber;
									}
									else
									{
										rowOneText = "                  " + currentOperatorNumber;
									}
									display.trigger('virtualPrinterDisplay:set_row1_to', [rowOneText]);
									display.trigger('virtualPrinterDisplay:set_row2_to', [xOperatorsReportText]);
									sendAllVoid(true);	// Invia reset perché è del tipo printerCommands.
									requestXOperatorReport(rowOneText);
									resetPrincipalVariables();
								}
								else	// docOpen == true
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
									needClear = true;							
								}
							}
							else
							{
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
		 					}
		 				}
	 					else
		 				{
		 					alert("Modalità operatori non è stata impostata in Settings.xml.");
		 				}

	 					break;

					case 'void transazione':
					case 'voidtransazione':
					case 'correzione':
						if (somethingToVoid == false)
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
							needClear = true;
						}
						else if (docResoAnnulloOpeningInProgress == true || docOpen == false || partialPaymentsInProgress == true)
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						else
						{
							display.trigger('virtualPrinterDisplay:set_row1_numeral_to', [Math.abs(lastTransactionAmount)]);
							display.trigger('virtualPrinterDisplay:set_row2_to', [voidLastText]);
							requestVoidTransazione();
							resetPrincipalVariables();
							receiptTotalCalculatedInternally -= lastTransactionAmount;	
							updateSubtotal();		
							somethingToVoid = false;				
						}
						break;
					
					case 'codici':
					case 'descrizione':
					case 'descrizione e vendita':
					case 'descrizionee vendita':
					case 'descrizione evendita':
					case 'descrizioneevendita':					
						manageForms(buttonFunction, "buttonFunction", "");
						break;
					
					case 'pagamentitest': // NON UTILIZZATA.
						/*
						if (docResoAnnulloOpeningInProgress == false)
						{							
							document.getElementById('portraitModePOS').style.zIndex = "0";
							document.getElementById('portraitModePOSPagamenti').style.zIndex = "1";
							document.getElementById('landscapeModePOS').style.zIndex = "0";
							document.getElementById('landscapeModePOSPagamenti').style.zIndex = "1";
						    
						    $('.landscapePagamenti').css('display', $('.landscape').css('display'))
							$('.portraitPagamenti').css('display', $('.portrait').css('display'))
							$('.landscape').css('display', 'none')
							$('.portrait').css('display', 'none')
														
							paymentFormOpen = true;
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						*/
						break;

					case 'entrate':
					case 'uscite':
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (acceptNewNumericInput == false)
							{
								if (buttonFunction.toLowerCase() == "entrate")
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [cashInText]);
								}
								else
								{
									display.trigger('virtualPrinterDisplay:set_row2_to', [cashOutText]);
								}
								var cashInOutAmount = row1[0].textContent;
								if (debugMode == true)
								{
									console.log('cashInOutAmount = ' + cashInOutAmount);
								}
								cashInOutAmount = prepareText(cashInOutAmount);
								if (debugMode == true)
								{
									console.log('cashInOutAmount = ' + cashInOutAmount);
								}
								if (mainSettings.tipoConnessione == "Multipla")
								{
									sendAllVoid(true);
								}
								sendCashInOut(buttonFunction, cashInOutAmount);
								resetPrincipalVariables();
							}
							else
							{
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
								needClear = true;
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
						
					case 'ristampa':
						if (docResoAnnulloOpeningInProgress == false)
						{
							if (docOpen == false)
							{
								if (mainSettings.tipoConnessione == "Multipla")
								{
									sendAllVoid(true);
								}
								requestReprintLast();
								display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [registrationStateText]);
							}
							else
							{
								display.trigger('virtualPrinterDisplay:blank', []);
								display.trigger('virtualPrinterDisplay:set_row2_to', [notPossibleNowText]);
								needClear = true;
							}
						}
						else
						{
							display.trigger('virtualPrinterDisplay:blank', []);
							display.trigger('virtualPrinterDisplay:set_row2_to', [erroneousKeyText]);
							needClear = true;
						}
						break;
					
					case 'websocketconnect':
						if (mainSettings.demoMode == true)
						{
							alert("La funzione webSocketConnect non è possibile in modalità demo.");
						}
						else if (mainSettings.usaWebSocket == true)
						{
							var dataToSend = '<printerCommand>\r\n' +
												'\t<directIO  command="4034" data="0104001                                                               " timeout="' + directIOTimeout + '" comment="Web socket abilitato" />\r\n' +
												'</printerCommand>\r\n';
								
							// '\t<directIO  command="4034" data="019900                                                                " comment="Reset web server" />\r\n' +
							// Il reset scollega un eventuale altra cassa connessa.

							sendToPrinter(dataToSend, true, false);
							setTimeout(manageEposDevice, 4000);
						}
						else
						{
							alert("L'opzione usaWebSocket non è stata abilitata nel file Settings.xml");
						}
						break;

					case 'esci-test':	// Pagamenti NON UTILIZZATA
						/*
						$('.landscape').css('display', $('.landscapePagamenti').css('display'))
						$('.portrait').css('display', $('.portraitPagamenti').css('display'))
						$('.landscapePagamenti').css('display', 'none')
						$('.portraitPagamenti').css('display', 'none')
						paymentFormOpen = false;
						*/
						break;

					default:
				}
			}
		}
		else if (extendedDescriptionFormOpen == true)
		{
			if (document.getElementById('extendedDescriptionTextArea1').value == "" && buttonFunction == 'OK')
			{
				alert("Descrizione vuota!");
			}
			else
			{
				if (buttonFunction == 'OK')
				{
					descLines = document.getElementById('extendedDescriptionTextArea1').value.split("\n");
					checkAndRealignExtendedDescription(descLines, "extendedDescriptionTextArea1");
					sendExtendedDescription("extendedDescriptionTextArea1", false);
				}
				clearExtendedDescriptionForm();
				$('.descriptionFormClass').css('display', 'none');
				$('.landscape').css('display', '');
				$('.portrait').css('display', '');
				extendedDescriptionFormOpen = false;
				document.getElementById('extendedDescriptionTextArea1').blur();
			}
		}
		else if (extendedDescriptionAndSaleFormOpen == true)
		{
			if (buttonFunction == 'Canc' || buttonFunction == 'Esci')
			{
				clearExtendedDescriptionAndSaleForm();
				if (buttonFunction == 'Esci')
				{
					$('.descriptionAndSaleFormClass').css('display', 'none');
					$('.landscape').css('display', '');
					$('.portrait').css('display', '');
					extendedDescriptionAndSaleFormOpen = false;
					document.getElementById('extendedDescriptionTextArea2').blur();
				}
				else
				{
					display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
					display.trigger('virtualPrinterDisplay:set_row2_to', [registrationStateText]);
					// document.getElementById('myDebug').innerHTML = "";
				}
			}
			else if (buttonFunction == 'OK')
			{				
				/*
				descLines = document.getElementById('extendedDescriptionTextArea').value.split("\n");				
				if (descLines.length > maxDescLines)
				{
					alert("Descrizione massima " + maxDescLines + " righe.");					
				}
				else if ((document.getElementById('extendedDescriptionText1').value == "" &&				
					document.getElementById('extendedDescriptionText2').value == "" &&
					document.getElementById('extendedDescriptionText3').value == "" ) ||
					document.getElementById('unitPriceTextWhole').value == "" ||
					document.getElementById('quantityTextWhole').value == "" ||
					document.getElementById('departmentNumberText').value == "")
				{}
				*/
				if (document.getElementById('extendedDescriptionTextArea2').value == "" ||
					document.getElementById('unitPriceTextWhole').value == "" ||
					document.getElementById('quantityTextWhole').value == "" ||
					document.getElementById('departmentNumberText').value == "")
				{
					alert("Form incompleto!");
				}
				else if (parseInt(document.getElementById('quantityTextWhole').value, 10) == 0 &&
						(document.getElementById('quantityTextDecimals').value == "" ||
						parseInt(document.getElementById('quantityTextDecimals').value, 10) == 0))
				{
					alert("Quantità non può essere zero!");
				}
				else if (parseInt(document.getElementById('departmentNumberText').value, 10) == 0)
				{
					alert("Reparto non può essere zero!");
				}
				else				
				{					
					descLines = document.getElementById('extendedDescriptionTextArea2').value.split("\n");
					checkAndRealignExtendedDescription(descLines,"extendedDescriptionTextArea2");
					sendExtendedDescription("extendedDescriptionTextArea2", true);					
				}
			}
		}
		else if (codesFormOpen == true)
		{
			var closeCodesFormIndication = true;
			if (buttonFunction == 'Canc')
			{
				document.getElementById('codeString').value = "";
				display.trigger('virtualPrinterDisplay:clear_row1_euro_0', []);
				display.trigger('virtualPrinterDisplay:set_row2_to', [registrationStateText]);
				document.getElementById('codeString').focus();
				closeCodesFormIndication = false;
				// document.getElementById('myDebug').innerHTML = "";
			}
			else if (buttonFunction == 'Esci')
			{
				closeCodesFormIndication = true;
				// closeCodesForm(); Chiamata spostata più sotto.
			}
			else if (buttonFunction == 'Barcode PLU')
			{
				codeString = document.getElementById('codeString').value;
				managePluBarcode(codeString);
				closeCodesFormIndication = false; // Lasciamo il form aperto per altri eventuali PLU o altro tipo di codice.
			}
			else if (buttonFunction == 'Codice Fiscale' || buttonFunction == 'Codice Fisc.')
			{
				document.getElementById('codeString').value = document.getElementById('codeString').value.toUpperCase();
				codeString = document.getElementById('codeString').value;
				if (verifyCodiceFiscale(codeString, true) == true)
				{
					if (mainSettings.demoMode == false)
					{
						sendCodiceFiscale(codeString);
					}
					else
					{
						display.trigger('virtualPrinterDisplay:set_row2_to', [codeString + "  OK"]);
					}
					closeCodesFormIndication = true;
				}
				else
				{
					closeCodesFormIndication = false;
				}			
			}
			else if (buttonFunction == 'Partita IVA')
			{
				codeString = document.getElementById('codeString').value;
				closeCodesFormIndication = managePartitaIVA(codeString);
			}
			else if (buttonFunction == 'Lotteria')
			{
				document.getElementById('codeString').value = document.getElementById('codeString').value.toUpperCase();
				codeString = document.getElementById('codeString').value;
				closeCodesFormIndication = manageLotteryCode(codeString);
			}
			if (closeCodesFormIndication == true)
			{
				closeCodesForm();
			}
		}
		
		previousFunction = buttonFunction;
		
		// * * * * F I N E   G E S T I O N E   P U L S A N T I * * * *
	}

	function checkDateCongruence()
	{
		var myDay = parseInt(resoAnnulloDate.substr(0, 2), 10);
		var myMonth = parseInt(resoAnnulloDate.substr(3, 2), 10);
		var myYear = parseInt(resoAnnulloDate.substr(6, 2), 10);

		if (myDay > 31)
		{
			return false;
		}
		else if (myDay == 0)
		{
			return false;
		}
		else if (myMonth > 12)
		{
			return false;
		}
		else if (myMonth == 0)
		{
			return false;
		}
		else if ((myMonth == 4 || myMonth == 6 || myMonth == 9 || myMonth == 11) && myDay > 30)
		{
			return false;
		}
		else if (myYear == 0)
		{
			return false;
		}
		else if (myMonth == 2)
		{
			if (myYear % 4 == 0)	// Anno bisestile. Leap year.
			{
				if (myDay > 29)
				{
					return false;
				}
				}
				else	// Non anno bisestile. Non-leap year.
				{
				if (myDay > 28)
				{
					return false;
				}
			}
		}
		return true;		
	}
	
	function clearExtendedDescriptionForm()
	{
		document.getElementById('extendedDescriptionTextArea1').value = "";
	}
	
	function clearExtendedDescriptionAndSaleForm()
	{
		document.getElementById('extendedDescriptionTextArea2').value = "";
		/*
		document.getElementById('extendedDescriptionText1').value = "";
		document.getElementById('extendedDescriptionText2').value = "";
		document.getElementById('extendedDescriptionText3').value = "";
		*/
		document.getElementById('unitPriceTextWhole').value = "";
		document.getElementById('unitPriceTextDecimals').value = "";
		document.getElementById('quantityTextWhole').value = "";
		document.getElementById('quantityTextDecimals').value = "";
		document.getElementById('departmentNumberText').value = "";
	}

	
	window.scrollTo(0, 1);
	$(window).resize(function(){ window.scrollTo(0, 1); });

	display.on('virtualPrinterDisplay:add_numeral', function(mouseEventObject, myNumeral)
	{
		// add pressed numeric char to first row
		var current = display.data('row1');
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:add_numeral - ' + mouseEventObject + ' - ' + myNumeral);
			console.log('current = ' + current);
		}
				// delete comma and dot char from string
		current = current.replace(/,/g, '');
		current = current.replace(/\./g, '');
		if (debugMode == true)
		{			
			console.log('current no comma and dot = ' + current);
		}
		var row1Data = current + myNumeral;
		if (debugMode == true)
		{			
			console.log('row1Data = ' + row1Data );
		}
		var row1DataTrimmed = parseInt(row1Data, 10).toString();	// Removes leading zeroes.
		if (debugMode == true)
		{			
			console.log('row1DataTrimmed = ' + row1DataTrimmed );
		}

		if (row1DataTrimmed.length > 9)
		{
			row1DataTrimmed = row1DataTrimmed.slice(-9);
		}
		if (parseInt(row1DataTrimmed, 10) == 0)
		{
			row1DataTrimmed = "0";
		}

		if (row1DataTrimmed.length <= 2)
		{
			row1DataTrimmed = pad(row1DataTrimmed, 3, '0');
		}
		if (debugMode == true)
		{			
			console.log('row1DataTrimmed = ' + row1DataTrimmed );
		}
		
		var row1DataTrimmedWithComma = [row1DataTrimmed.slice(0, -2), ',', row1DataTrimmed.slice(-2)].join('');	// Add comma decimal separator.
		if (debugMode == true)
		{			
			console.log('row1DataTrimmedWithComma = ' + row1DataTrimmedWithComma );
		}
		var row1DataNew = row1DataTrimmedWithComma;
		if (row1DataNew.length > 6)
		{
			row1DataNew = [row1DataNew.slice(0, -6), '.', row1DataNew.slice(-6)].join('');
		}
		if (debugMode == true)
		{			
			console.log('row1DataNew possible dot= ' + row1DataNew);
		}
		if (row1DataNew.length > 10)
		{
			row1DataNew = [row1DataNew.slice(0, -10), '.', row1DataNew.slice(-10)].join('');
		}
		if (debugMode == true)
		{			
			console.log('row1DataNew possibile two dots = ' + row1DataNew);
		}
		row1DataNew = row1DataNew.substr(0, 20);
		if (debugMode == true)
		{			
			console.log('row1DataNew substr 0, 20 = ' + row1DataNew);
		}
		row1DataNew = row1DataNew.substr(0, 12);
		if (debugMode == true)
		{			
			console.log('row1DataNew substr 0, 12 = ' + row1DataNew);
		}
		display.data('row1', row1DataNew);
		// add € at 19
		var tmpHTML = pad(row1DataNew, 20, '&nbsp;');
		if (debugMode == true)
		{			
			console.log('tmpHTML = ' + tmpHTML);
		}
		tmpHTML = '€' + tmpHTML.substr(6);
		if (debugMode == true)
		{			
			console.log('tmpHTML = ' + tmpHTML);
		}
		row1.html(tmpHTML);
	});
	
	display.on('virtualPrinterDisplay:add_quantity_decimal', function(mouseEventObject, myDecimal)
	{		
		var current = display.data('row1');
		if (debugMode == true)
		{
			console.log('current = ' + current);
			console.log('virtualPrinterDisplay:add_quantity_decimal - ' + mouseEventObject + ' - ' + myDecimal);
		}
		//	1234,678
		//      ,123	(currentQuantityDecimal)
		var wholeNumberLength = current.length - 4;
		if (debugMode == true)
		{
			console.log('wholeNumberLength = ' + wholeNumberLength);
		}
		var toShow = current.substr(0, wholeNumberLength) + ',';
		var decimals = current.substr(current.length - 3);
		if (debugMode == true)
		{
			console.log('decimals = ' + decimals);
			console.log('currentQuantityDecimal = ' + currentQuantityDecimal);
		}
		switch (currentQuantityDecimal)
		{
			case 1:
				toShow += (myDecimal + '00');
				break;
				
			case 2:
				if (myDecimal.length == 1)
				{
					toShow += (decimals.substr(0, 1) + myDecimal + '0');
				}
				else
				{
					toShow += (decimals.substr(0, 1) + myDecimal);
				}
				break;
				
			case 3:
				if (myDecimal.length == 1)
				{
					toShow += (decimals.substr(0, 2) + myDecimal);
				}
				else
				{
					toShow += (decimals.substr(0, 1) + myDecimal);
				}
				break;

			default:
		}
		
		if (debugMode == true)
		{
			console.log('toShow = ' + toShow);
		}
			
		if (toShow.length == 8)
		{
			toShow = [toShow.slice(0, -7), '.', toShow.slice(-7)].join('');
		}
		if (debugMode == true)
		{
			console.log('toShow = ' + toShow);
		}
		toShow = toShow.substr(0, 20);
		toShow = toShow.substr(0, 12);
		if (debugMode == true)
		{
			console.log('toShow = ' + toShow);
		}
		display.data('row1', toShow);
		// add € at 19
		var tmp = pad(toShow, 20, '&nbsp;');
		if (debugMode == true)
		{
			console.log('tmp3 = ' + tmp);
		}
		var tmprow = '€' + tmp.substr(6);
		if (debugMode == true)
		{
			console.log('tmprow = ' + tmprow);
		}
		row1.html(tmprow);
	});
	
	display.on('virtualPrinterDisplay:display_quantity_row2', function(mouseEventObject)
	{
		var wholeNumberLength = quantity.length - 3;
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:display_quantity_row2 - ' + mouseEventObject);
			console.log('wholeNumberLength = ' + wholeNumberLength);
		}
		var tmpHTML = quantity.substr(0, wholeNumberLength);
		
		if  (quantityDecimalsInProgress == true)
		{
			tmpHTML += (',' + quantity.substr(quantity.length - 3));
		}
						
		if (debugMode == true)
		{
			console.log('tmpHTML = ' + tmpHTML);
		}
		if (tmpHTML.length > 7 && quantityDecimalsInProgress == true)
		{
			tmpHTML = [tmpHTML.slice(0, -7), '.', tmpHTML.slice(-7)].join('');
		}
		if (debugMode == true)
		{
			console.log('tmpHTML = ' + tmpHTML);
		}
		tmpHTML  = pad(tmpHTML, 10, '&nbsp;') + 'x' +  pad('', 9, '&nbsp;');
		if (debugMode == true)
		{
			console.log('tmpHTML = ' + tmpHTML);
		}
		row2.html(tmpHTML);
	});

	display.on('virtualPrinterDisplay:set_row1_numeral_to', function(mouseEventObject, toShow, buttonFunction, cleanRow2)
	{
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:set_row1_numeral_to - ' + mouseEventObject + ' - ' + toShow + ' - ' + buttonFunction + ' - ' + cleanRow2);
		}
		// set first row to fixed value passed
		var tmp = parseInt(toShow, 10).toString();
		if (debugMode == true)
		{
			console.log('tmp = ' + tmp);
		}
		var numDecimals = 0;
		if (buttonFunction == ",")
		{
			if (tmp.length > 4)
			{
				display.trigger('virtualPrinterDisplay:blank', []);
				display.trigger('virtualPrinterDisplay:set_row2_to', [limitExceededText]);
				return;
			}
			tmp =  tmp + '000';
			numDecimals = 3;
		}
		else
		{
			numDecimals = 2;
		}

		if (tmp.length > 9)
		{
			tmp = tmp.slice(-9);
		}
		
		if (parseInt(tmp, 10) == 0)
		{
			tmp = "0";
		}

		if (tmp.substr(0, 1) == "-")
		{
			if (tmp.substr(1).length <= numDecimals )
			{
				tmp = "-" + pad(tmp.substr(1), numDecimals + 1, '0');
			}
		}
		else
		{
			if (tmp.length <= numDecimals )
			{
				tmp = pad(tmp, numDecimals + 1, '0');
			}
		}
		tmp = [tmp.slice(0, -numDecimals), ',', tmp.slice(-numDecimals)].join(''); // Insert decimal separator.
		
		if (tmp.length > (4 + numDecimals))
		{
			// tmp = [tmp.slice(0, -6), '.', tmp.slice(-6)].join('');
			tmp = [tmp.slice(0, -(4 + numDecimals)), '.', tmp.slice(-(4 + numDecimals))].join('');
		}
		
		if (tmp.length > (8 + numDecimals))
		{
			tmp = [tmp.slice(0, -(8 + numDecimals)), '.', tmp.slice(-(8 + numDecimals))].join('');
		}

		toShow = tmp;
		toShow = toShow.substr(0, 20);
		toShow = toShow.substr(0, 12);
		display.data('row1', toShow);
		// add € at 19
		tmp = pad(toShow, 20, '&nbsp;');
		var tmprow = '€' + tmp.substr(6);
		row1.html(tmprow);
		if (cleanRow2 == true)
		{
			row2.html('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
		}
	});

	display.on('virtualPrinterDisplay:set_row1_serial_to', function(mouseEventObject)
	{
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:set_row1_serial_to - ' + mouseEventObject);
			console.log('resoAnnulloFiscalSerialNumber = ' + resoAnnulloFiscalSerialNumber);
		}
		display.data('row1', resoAnnulloFiscalSerialNumber);
		var tmprow = pad(resoAnnulloFiscalSerialNumber, 17, '&nbsp;');
		tmprow = 'Z91' + tmprow;
		row1.html(tmprow);
	});
	
	display.on('virtualPrinterDisplay:set_row1_Z91_to', function(mouseEventObject, Z91Text)
	{
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:set_row1_Z91_to - ' + mouseEventObject + ' - ' + Z91Text);
		}
		display.data('row1', Z91Text);
		var tmprow = pad(Z91Text, 17, '&nbsp;');
		tmprow = 'Z91' + tmprow;
		row1.html(tmprow);
	});
	
	display.on('virtualPrinterDisplay:set_row1_to', function(mouseEventObject, toShow)
	{
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:set_row1_to - ' + mouseEventObject + ' - ' + toShow);
		}
		display.data('row1', toShow);
		// pad right with blank
		toShow = toShow + Array(20 + 1 - toShow.length).join(' ');
		// substitute " " with &nbsp;
		toShow = toShow.replace(/\s/g, '&nbsp;'); 
		row1.html(toShow);
	});

	display.on('virtualPrinterDisplay:set_row2_to', function(mouseEventObject, toShow)
	{
		var current = display.data('row2');
		// cut string at 20
		toShow = toShow.substr(0, 20);
		display.data('row2', toShow);
		// pad right with blank
		toShow = toShow + Array(20 + 1 - toShow.length).join(' ');
		// substitute " " with &nbsp;
		toShow = toShow.replace(/\s/g, '&nbsp;'); 
		row2.html(toShow);
	});
	
	display.on('virtualPrinterDisplay:set_row2_rep_generico', function(mouseEventObject)
	{
		if (debugMode == true)
		{
			console.log('virtualPrinterDisplay:set_row2_rep_generico - ' + mouseEventObject + ' - ' + genericDepartmentNumber);
		}
		var tmprow = pad(genericDepartmentText, 17, '&nbsp;');
		tmprow = tmprow + pad(genericDepartmentNumber, 3, '&nbsp;');
		row2.html(tmprow);
	});

	display.on('virtualPrinterDisplay:blank', function(mouseEventObject, buttonFunction)
	{
		row1.html('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
		row2.html('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
		display.data('row1','');
		display.data('row2','');
	});

	display.on('virtualPrinterDisplay:clear_row1_euro_0', function(mouseEventObject, buttonFunction)
	{
		row1.html('€&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;0,00');
		row2.html('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
		display.data('row1','0,00');
		display.data('row2','');
	});

	$('button').each(function(index)
	{
		// Commentata perché incasina i colori dei pulsanti.
		// $(this).data('color', $(this).css('background'));
	});

	// 15/05/2020 Philip Barnett. V5.6.
	// Aggiunto == true per evitare falsa identificazione di un touchscreen.
	if (supportsTouch == true)
	{
		$('button').tap(clickedTouched);
	}
	else
	{
		$('button').on('click', clickedTouched);
	}
});
